/*
 * The FUJABA ToolSuite project:
 *
 *   FUJABA is the acronym for 'From Uml to Java And Back Again'
 *   and originally aims to provide an environment for round-trip
 *   engineering using UML as visual programming language. During
 *   the last years, the environment has become a base for several
 *   research activities, e.g. distributed software, database
 *   systems, modelling mechanical and electrical systems and
 *   their simulation. Thus, the environment has become a project,
 *   where this source code is part of. Further details are avail-
 *   able via http://www.fujaba.de
 *
 *      Copyright (C) 1997-2004 Fujaba Development Group
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA 02111-1307, USA or download the license under
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * WARRANTY:
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Lesser General Public License for more details.
 *
 * Contact adress:
 *
 *   Fujaba Management Board
 *   Software Engineering Group
 *   University of Paderborn
 *   Warburgerstr. 100
 *   D-33098 Paderborn
 *   Germany
 *
 *   URL  : http://www.fujaba.de
 *   email: info@fujaba.de
 *
 */
package de.uni_paderborn.fujaba.fsa.actions;

import java.awt.*;
import java.awt.event.ActionEvent;

import javax.swing.*;

import de.uni_paderborn.fujaba.fsa.SelectionManager;
import de.uni_paderborn.fujaba.fsa.swing.JGrab;
import de.upb.lib.userinterface.ElementInitializer;


/**
 * @author    $Author: lowende $
 * @version   $Revision: 1.10 $
 */
public class GrabAutoAlignAction extends AbstractAction implements ElementInitializer
{
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @param event  No description provided
    */
   public void actionPerformed (ActionEvent event)
   {
      JComponent comp = (JComponent) SelectionManager.get().getPopupSource();
      JGrab grab = findGrab (comp);

      if (grab != null)
      {
         boolean newState = ! (grab.isAutoAlignment() || grab.isAutoOrientation());
         grab.setAutoAlignment (newState);
         grab.setAutoOrientation (newState);
      }
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @param item    No description provided
    * @param source  No description provided
    */
   public void initialize (JComponent item, Object source)
   {
      if (source instanceof JComponent && item instanceof JCheckBoxMenuItem)
      {
         JCheckBoxMenuItem check = (JCheckBoxMenuItem) item;
         JGrab grab = findGrab ((JComponent) source);

         if (grab != null)
         {
            check.setEnabled (true);
            check.setSelected (! (grab.isAutoAlignment() && grab.isAutoOrientation()));
         }
         else
         {
            check.setSelected (false);
            check.setEnabled (false);
         }
      }
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @param comp  No description provided
    * @return      No description provided
    */
   private JGrab findGrab (JComponent comp)
   {
      Container cont = comp;

      while (cont != null)
      {
         if (cont instanceof JGrab)
         {
            return (JGrab) cont;
         }
         cont = cont.getParent();
      }
      return null;
   }
}

/*
 * $Log: GrabAutoAlignAction.java,v $
 * Revision 1.10  2004/11/03 10:17:53  lowende
 * Javadoc warnings removed.
 *
 */
