/*
 * The FUJABA ToolSuite project:
 *
 *   FUJABA is the acronym for 'From Uml to Java And Back Again'
 *   and originally aims to provide an environment for round-trip
 *   engineering using UML as visual programming language. During
 *   the last years, the environment has become a base for several
 *   research activities, e.g. distributed software, database
 *   systems, modelling mechanical and electrical systems and
 *   their simulation. Thus, the environment has become a project,
 *   where this source code is part of. Further details are avail-
 *   able via http://www.fujaba.de
 *
 *      Copyright (C) 1997-2004 Fujaba Development Group
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or (at your option) any later version.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free
 *   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *   MA 02111-1307, USA or download the license under
 *   http://www.gnu.org/copyleft/lesser.html
 *
 * WARRANTY:
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Lesser General Public License for more details.
 *
 * Contact adress:
 *
 *   Fujaba Management Board
 *   Software Engineering Group
 *   University of Paderborn
 *   Warburgerstr. 100
 *   D-33098 Paderborn
 *   Germany
 *
 *   URL  : http://www.fujaba.de
 *   email: info@fujaba.de
 *
 */
package de.uni_paderborn.fujaba.gui;

import java.awt.*;
import java.util.Iterator;

import de.upb.tools.fca.FLinkedList;


/**
 * No comment provided by developer, please add a comment to improve documentation.
 *
 * @author    $Author: lowende $
 * @version   $Revision: 1.16 $
 */
public class PEComponentGroup extends PEBaseComponent
{
   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   private FLinkedList items = new FLinkedList();


   /**
    * Constructor for class PEComponentGroup
    *
    * @param parent  No description provided
    */
   public PEComponentGroup (BasicPropertyEditor parent)
   {
      super (parent);
   }


   /**
    * Constructor for class PEComponentGroup
    */
   public PEComponentGroup()
   {
      super();
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    *
    * @param comp  No description provided
    * @return      No description provided
    */
   public Component add (Component comp)
   {
      if (comp != null)
      {
         items.add (comp);
         return super.add (comp);
      }
      return null;
   }


   /**
    * No comment provided by developer, please add a comment to improve documentation.
    */
   public void removeAll()
   {
      items.clear();
   }


   /**
    * Access method for an one to n association.
    */
   protected void addComponents()
   {
   }


   /**
    * Sets the readOnly attribute of the PEComponentGroup object
    *
    * @param b  The new readOnly value
    */
   public void setReadOnly (boolean b)
   {
      Iterator itemIter = items.iterator();
      while (itemIter.hasNext())
      {
          ((PEBaseComponent) itemIter.next()).setReadOnly (b);
      }
   }


   /**
    * Get the horzResizable attribute of the PEComponentGroup object
    *
    * @return   The horzResizable value
    */
   public boolean isHorzResizable()
   {
      boolean resizable = false;
      Component comp = null;
      Iterator itemIter = items.iterator();
      while (itemIter.hasNext())
      {
         comp = (Component) itemIter.next();
         if (comp instanceof PEResizable)
         {
            if ( ((PEResizable) comp).isHorzResizable())
            {
               resizable = true;
            }
         }
      }
      return resizable;
   }


   /**
    * Get the vertResizable attribute of the PEComponentGroup object
    *
    * @return   The vertResizable value
    */
   public boolean isVertResizable()
   {
      boolean resizable = false;
      Component comp = null;
      Iterator itemIter = items.iterator();
      while (itemIter.hasNext())
      {
         comp = (Component) itemIter.next();
         if (comp instanceof PEResizable)
         {
            if ( ((PEResizable) comp).isVertResizable())
            {
               resizable = true;
            }
         }
      }
      return resizable;
   }

}

/*
 * $Log: PEComponentGroup.java,v $
 * Revision 1.16  2004/11/03 10:18:04  lowende
 * Javadoc warnings removed.
 *
 */
