package de.upb.inferenceengine.engines;

import de.upb.tools.fca.FEmptyIterator;
import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.upb.javaast.methodast.PrimaryExpressionNode;
import de.upb.javaast.methodast.IdentifierNode;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLParam;
import de.uni_paderborn.fujaba.uml.ASTRootNode;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLType;
import de.upb.javaast.methodast.AssignmentNode;

public class AssignmentEngine
extends GFRNEngine
{
   private  AssignmentEngine()
   {
   }

   private static AssignmentEngine theAssignmentEngine;

   public static AssignmentEngine get()
   {
      if (theAssignmentEngine == null)
      {
         theAssignmentEngine = new AssignmentEngine ();
      }
      return theAssignmentEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ASTPathVisitor fujaba__IterLeftToLeftID = null ;
      ASTPathVisitor fujaba__IterRootToAssignmentNode12 = null ;
      ASTPathVisitor fujaba__IterRootToAssignmentNode4 = null ;
      ASTPathVisitor fujaba__IterRootToAssignmentNode8 = null ;
      de.uni_paderborn.fujaba.uml.ASTRootNode root = null ;
      AssignmentAnnotation assignment = null ;
      de.upb.javaast.methodast.AssignmentNode assignmentNode12 = null ;
      de.upb.javaast.methodast.AssignmentNode assignmentNode4 = null ;
      de.upb.javaast.methodast.AssignmentNode assignmentNode8 = null ;
      Iterator fujaba__IterAttribAnnotationsAssignment = null ;
      Iterator fujaba__IterParamAnnotationsAssignment = null ;
      Iterator fujaba__IterUMLClass9AttrsAttrib = null ;
      Iterator fujaba__IterUMLMethod11ParamParam = null ;
      Iterator fujaba__IterUMLMethod7AnnotationsAssignment = null ;
      Iterator fujaba__IterUMLType2RevParamTypeParam = null ;
      Iterator fujaba__IterUMLType6RevAttrTypeAttrib = null ;
      de.upb.javaast.methodast.IdentifierNode leftID = null ;
      de.upb.javaast.methodast.IdentifierNode rightID = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode left = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode right = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr attrib = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass1 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass5 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass9 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod11 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod3 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod7 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam param = null ;
      de.uni_paderborn.fujaba.uml.UMLType uMLType10 = null ;
      de.uni_paderborn.fujaba.uml.UMLType uMLType2 = null ;
      de.uni_paderborn.fujaba.uml.UMLType uMLType6 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            attrib = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind uMLType2: UMLType
            uMLType2 = attrib.getAttrType () ;
            JavaSDM.ensure ( uMLType2 != null ) ;
             
            // bind uMLClass1: UMLClass
            uMLClass1 = attrib.getParent () ;
            JavaSDM.ensure ( uMLClass1 != null ) ;
             
            // check isomorphic binding
            JavaSDM.ensure ( !(uMLType2.equals (uMLClass1)) ) ;
             
            // bind param: UMLParam
            fujaba__IterUMLType2RevParamTypeParam = uMLType2.iteratorOfRevParamType () ;
            while ( fujaba__IterUMLType2RevParamTypeParam.hasNext () )
            {
               try
               {
                  param = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__IterUMLType2RevParamTypeParam.next () ;
                   
                  // bind uMLMethod3: UMLMethod
                  uMLMethod3 = param.getRevParam () ;
                  JavaSDM.ensure ( uMLMethod3 != null ) ;
                   
                  // check To-One-Link 'parent' between uMLMethod3 and uMLClass1
                  JavaSDM.ensure ( (uMLMethod3.getParent () != null) && uMLMethod3.getParent ().equals (uMLClass1) ) ;
                   
                  // bind root: ASTRootNode
                  root = uMLMethod3.getASTRootNode () ;
                  JavaSDM.ensure ( root != null ) ;
                   
                  // Path search between ASTRootNode and AssignmentNode
                  // Bind assignmentNode4 : AssignmentNode
                  fujaba__IterRootToAssignmentNode4 = new ASTPathVisitor (root, AssignmentNode.class ) ;
                  while ( fujaba__IterRootToAssignmentNode4.hasNext () )
                  {
                     try
                     {
                        assignmentNode4 = (de.upb.javaast.methodast.AssignmentNode) fujaba__IterRootToAssignmentNode4.next () ;
                         
                        // bind left: PrimaryExpressionNode
                        fujaba__TmpObject = assignmentNode4.getLeftExpression () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                        left = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__TmpObject ;
                         
                        // bind right: PrimaryExpressionNode
                        fujaba__TmpObject = assignmentNode4.getRightExpression () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                        right = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(left.equals (right)) ) ;
                         
                        // bind rightID: IdentifierNode
                        rightID = right.getIdentifier () ;
                        JavaSDM.ensure ( rightID != null ) ;
                         
                        // Path search between PrimaryExpressionNode and IdentifierNode
                        // Bind leftID : IdentifierNode
                        fujaba__IterLeftToLeftID = new ASTPathVisitor (left, IdentifierNode.class ) ;
                        while ( fujaba__IterLeftToLeftID.hasNext () )
                        {
                           try
                           {
                              leftID = (de.upb.javaast.methodast.IdentifierNode) fujaba__IterLeftToLeftID.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(rightID.equals (leftID)) ) ;
                               
                              // constraint
                              JavaSDM.ensure ( leftID.getName().equals(attrib.getName()) ) ;
                               
                              // constraint
                              JavaSDM.ensure ( rightID.getName().equals(param.getName()) ) ;
                               
                              {
                                 //  for each flow
                                 try
                                 {
                                    fujaba__Success = false ;
                                     
                                    // check object uMLMethod3 is really bound
                                    JavaSDM.ensure ( uMLMethod3 != null ) ;
                                     
                                    // check object attrib is really bound
                                    JavaSDM.ensure ( attrib != null ) ;
                                     
                                    // check object param is really bound
                                    JavaSDM.ensure ( param != null ) ;
                                     
                                    // bind assignment: AssignmentAnnotation
                                    fujaba__IterAttribAnnotationsAssignment = attrib.iteratorOfAnnotations () ;
                                    while ( !(fujaba__Success) && fujaba__IterAttribAnnotationsAssignment.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAttribAnnotationsAssignment.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof AssignmentAnnotation ) ;
                                          assignment = (AssignmentAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between assignment and attrib
                                          JavaSDM.ensure ( assignment.hasInElements ("field", attrib) ) ;
                                           
                                          // check To-Many-Link 'elements' between assignment and uMLMethod3
                                          JavaSDM.ensure ( assignment.hasInElements ("method", uMLMethod3) ) ;
                                           
                                          // check To-Many-Link 'elements' between assignment and param
                                          JavaSDM.ensure ( assignment.hasInElements ("param", param) ) ;
                                           
                                          fujaba__Success = true ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                    fujaba__Success = false ;
                                 }
                                  
                                 if ( !(fujaba__Success) )
                                 {
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object uMLMethod3 is really bound
                                       JavaSDM.ensure ( uMLMethod3 != null ) ;
                                        
                                       // check object attrib is really bound
                                       JavaSDM.ensure ( attrib != null ) ;
                                        
                                       // check object param is really bound
                                       JavaSDM.ensure ( param != null ) ;
                                        
                                       // check object leftID is really bound
                                       JavaSDM.ensure ( leftID != null ) ;
                                        
                                       // check object left is really bound
                                       JavaSDM.ensure ( left != null ) ;
                                        
                                       // check object root is really bound
                                       JavaSDM.ensure ( root != null ) ;
                                        
                                       // check object right is really bound
                                       JavaSDM.ensure ( right != null ) ;
                                        
                                       // check isomorphic binding
                                       JavaSDM.ensure ( !(left.equals (right)) ) ;
                                        
                                       // check object rightID is really bound
                                       JavaSDM.ensure ( rightID != null ) ;
                                        
                                       // check isomorphic binding
                                       JavaSDM.ensure ( !(leftID.equals (rightID)) ) ;
                                        
                                       // create object
                                       assignment = new AssignmentAnnotation ( ) ;
                                        
                                       // create link
                                       assignment.addToElements ("method", uMLMethod3);
                                        
                                       // create link
                                       assignment.addToElements ("field", attrib);
                                        
                                       // create link
                                       assignment.addToElements ("param", param);
                                        
                                       // create link
                                       assignment.addToBoundObjects ("attrib", attrib);
                                        
                                       // create link
                                       assignment.addToBoundObjects ("param", param);
                                        
                                       // create link
                                       assignment.addToBoundObjects ("leftID", leftID);
                                        
                                       // create link
                                       assignment.addToBoundObjects ("left", left);
                                        
                                       // create link
                                       assignment.addToBoundObjects ("root", root);
                                        
                                       // create link
                                       assignment.addToBoundObjects ("right", right);
                                        
                                       // create link
                                       assignment.addToBoundObjects ("rightID", rightID);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    return (assignment) ;
                                 }
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object assignment is really bound
            JavaSDM.ensure ( assignment != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("param", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
             
            // explicit type cast
            param = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__tmpTypeCastObject ;
             
            // bind uMLType6: UMLType
            uMLType6 = param.getParamType () ;
            JavaSDM.ensure ( uMLType6 != null ) ;
             
            // bind uMLMethod7: UMLMethod
            uMLMethod7 = param.getRevParam () ;
            JavaSDM.ensure ( uMLMethod7 != null ) ;
             
            // bind root: ASTRootNode
            root = uMLMethod7.getASTRootNode () ;
            JavaSDM.ensure ( root != null ) ;
             
            // bind uMLClass5: UMLClass
            uMLClass5 = uMLMethod7.getParent () ;
            JavaSDM.ensure ( uMLClass5 != null ) ;
             
            // check isomorphic binding
            JavaSDM.ensure ( !(uMLType6.equals (uMLClass5)) ) ;
             
            // bind attrib: UMLAttr
            fujaba__IterUMLType6RevAttrTypeAttrib = uMLType6.iteratorOfRevAttrType () ;
            while ( fujaba__IterUMLType6RevAttrTypeAttrib.hasNext () )
            {
               try
               {
                  attrib = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterUMLType6RevAttrTypeAttrib.next () ;
                   
                  // check To-One-Link 'parent' between attrib and uMLClass5
                  JavaSDM.ensure ( (attrib.getParent () != null) && attrib.getParent ().equals (uMLClass5) ) ;
                   
                  // Path search between ASTRootNode and AssignmentNode
                  // Bind assignmentNode8 : AssignmentNode
                  fujaba__IterRootToAssignmentNode8 = new ASTPathVisitor (root, AssignmentNode.class ) ;
                  while ( fujaba__IterRootToAssignmentNode8.hasNext () )
                  {
                     try
                     {
                        assignmentNode8 = (de.upb.javaast.methodast.AssignmentNode) fujaba__IterRootToAssignmentNode8.next () ;
                         
                        // bind right: PrimaryExpressionNode
                        fujaba__TmpObject = assignmentNode8.getRightExpression () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                        right = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__TmpObject ;
                         
                        // bind left: PrimaryExpressionNode
                        fujaba__TmpObject = assignmentNode8.getLeftExpression () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                        left = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(right.equals (left)) ) ;
                         
                        // bind rightID: IdentifierNode
                        rightID = right.getIdentifier () ;
                        JavaSDM.ensure ( rightID != null ) ;
                         
                        // Path search between PrimaryExpressionNode and IdentifierNode
                        // Bind leftID : IdentifierNode
                        fujaba__IterLeftToLeftID = new ASTPathVisitor (left, IdentifierNode.class ) ;
                        while ( fujaba__IterLeftToLeftID.hasNext () )
                        {
                           try
                           {
                              leftID = (de.upb.javaast.methodast.IdentifierNode) fujaba__IterLeftToLeftID.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(rightID.equals (leftID)) ) ;
                               
                              // constraint
                              JavaSDM.ensure ( leftID.getName().equals(attrib.getName()) ) ;
                               
                              // constraint
                              JavaSDM.ensure ( rightID.getName().equals(param.getName()) ) ;
                               
                              {
                                 //  for each flow
                                 try
                                 {
                                    fujaba__Success = false ;
                                     
                                    // check object uMLMethod7 is really bound
                                    JavaSDM.ensure ( uMLMethod7 != null ) ;
                                     
                                    // check object attrib is really bound
                                    JavaSDM.ensure ( attrib != null ) ;
                                     
                                    // check object param is really bound
                                    JavaSDM.ensure ( param != null ) ;
                                     
                                    // bind assignment: AssignmentAnnotation
                                    fujaba__IterUMLMethod7AnnotationsAssignment = uMLMethod7.iteratorOfAnnotations () ;
                                    while ( !(fujaba__Success) && fujaba__IterUMLMethod7AnnotationsAssignment.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterUMLMethod7AnnotationsAssignment.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof AssignmentAnnotation ) ;
                                          assignment = (AssignmentAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between assignment and uMLMethod7
                                          JavaSDM.ensure ( assignment.hasInElements ("method", uMLMethod7) ) ;
                                           
                                          // check To-Many-Link 'elements' between assignment and attrib
                                          JavaSDM.ensure ( assignment.hasInElements ("field", attrib) ) ;
                                           
                                          // check To-Many-Link 'elements' between assignment and param
                                          JavaSDM.ensure ( assignment.hasInElements ("param", param) ) ;
                                           
                                          fujaba__Success = true ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                    fujaba__Success = false ;
                                 }
                                  
                                 if ( !(fujaba__Success) )
                                 {
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object uMLMethod7 is really bound
                                       JavaSDM.ensure ( uMLMethod7 != null ) ;
                                        
                                       // check object attrib is really bound
                                       JavaSDM.ensure ( attrib != null ) ;
                                        
                                       // check object param is really bound
                                       JavaSDM.ensure ( param != null ) ;
                                        
                                       // check object leftID is really bound
                                       JavaSDM.ensure ( leftID != null ) ;
                                        
                                       // check object left is really bound
                                       JavaSDM.ensure ( left != null ) ;
                                        
                                       // check object root is really bound
                                       JavaSDM.ensure ( root != null ) ;
                                        
                                       // check object right is really bound
                                       JavaSDM.ensure ( right != null ) ;
                                        
                                       // check isomorphic binding
                                       JavaSDM.ensure ( !(left.equals (right)) ) ;
                                        
                                       // check object rightID is really bound
                                       JavaSDM.ensure ( rightID != null ) ;
                                        
                                       // check isomorphic binding
                                       JavaSDM.ensure ( !(leftID.equals (rightID)) ) ;
                                        
                                       // create object
                                       assignment = new AssignmentAnnotation ( ) ;
                                        
                                       // create link
                                       assignment.addToElements ("method", uMLMethod7);
                                        
                                       // create link
                                       assignment.addToElements ("field", attrib);
                                        
                                       // create link
                                       assignment.addToElements ("param", param);
                                        
                                       // create link
                                       assignment.addToBoundObjects ("attrib", attrib);
                                        
                                       // create link
                                       assignment.addToBoundObjects ("param", param);
                                        
                                       // create link
                                       assignment.addToBoundObjects ("leftID", leftID);
                                        
                                       // create link
                                       assignment.addToBoundObjects ("left", left);
                                        
                                       // create link
                                       assignment.addToBoundObjects ("root", root);
                                        
                                       // create link
                                       assignment.addToBoundObjects ("right", right);
                                        
                                       // create link
                                       assignment.addToBoundObjects ("rightID", rightID);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    return (assignment) ;
                                 }
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object assignment is really bound
            JavaSDM.ensure ( assignment != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("param", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            uMLMethod11 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind root: ASTRootNode
            root = uMLMethod11.getASTRootNode () ;
            JavaSDM.ensure ( root != null ) ;
             
            // bind uMLClass9: UMLClass
            uMLClass9 = uMLMethod11.getParent () ;
            JavaSDM.ensure ( uMLClass9 != null ) ;
             
            // bind param: UMLParam
            fujaba__IterUMLMethod11ParamParam = uMLMethod11.iteratorOfParam () ;
            while ( fujaba__IterUMLMethod11ParamParam.hasNext () )
            {
               try
               {
                  param = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__IterUMLMethod11ParamParam.next () ;
                   
                  // bind uMLType10: UMLType
                  uMLType10 = param.getParamType () ;
                  JavaSDM.ensure ( uMLType10 != null ) ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(uMLClass9.equals (uMLType10)) ) ;
                   
                  // bind attrib: UMLAttr
                  fujaba__IterUMLClass9AttrsAttrib = uMLClass9.iteratorOfAttrs () ;
                  while ( fujaba__IterUMLClass9AttrsAttrib.hasNext () )
                  {
                     try
                     {
                        attrib = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterUMLClass9AttrsAttrib.next () ;
                         
                        // check To-One-Link 'attrType' between attrib and uMLType10
                        JavaSDM.ensure ( (attrib.getAttrType () != null) && attrib.getAttrType ().equals (uMLType10) ) ;
                         
                        // Path search between ASTRootNode and AssignmentNode
                        // Bind assignmentNode12 : AssignmentNode
                        fujaba__IterRootToAssignmentNode12 = new ASTPathVisitor (root, AssignmentNode.class ) ;
                        while ( fujaba__IterRootToAssignmentNode12.hasNext () )
                        {
                           try
                           {
                              assignmentNode12 = (de.upb.javaast.methodast.AssignmentNode) fujaba__IterRootToAssignmentNode12.next () ;
                               
                              // bind right: PrimaryExpressionNode
                              fujaba__TmpObject = assignmentNode12.getRightExpression () ;
                              JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                              right = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__TmpObject ;
                               
                              // bind left: PrimaryExpressionNode
                              fujaba__TmpObject = assignmentNode12.getLeftExpression () ;
                              JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.PrimaryExpressionNode ) ;
                              left = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(right.equals (left)) ) ;
                               
                              // bind rightID: IdentifierNode
                              rightID = right.getIdentifier () ;
                              JavaSDM.ensure ( rightID != null ) ;
                               
                              // Path search between PrimaryExpressionNode and IdentifierNode
                              // Bind leftID : IdentifierNode
                              fujaba__IterLeftToLeftID = new ASTPathVisitor (left, IdentifierNode.class ) ;
                              while ( fujaba__IterLeftToLeftID.hasNext () )
                              {
                                 try
                                 {
                                    leftID = (de.upb.javaast.methodast.IdentifierNode) fujaba__IterLeftToLeftID.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(rightID.equals (leftID)) ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( leftID.getName().equals(attrib.getName()) ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( rightID.getName().equals(param.getName()) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object uMLMethod11 is really bound
                                          JavaSDM.ensure ( uMLMethod11 != null ) ;
                                           
                                          // check object attrib is really bound
                                          JavaSDM.ensure ( attrib != null ) ;
                                           
                                          // check object param is really bound
                                          JavaSDM.ensure ( param != null ) ;
                                           
                                          // bind assignment: AssignmentAnnotation
                                          fujaba__IterParamAnnotationsAssignment = param.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterParamAnnotationsAssignment.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterParamAnnotationsAssignment.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof AssignmentAnnotation ) ;
                                                assignment = (AssignmentAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between assignment and param
                                                JavaSDM.ensure ( assignment.hasInElements ("param", param) ) ;
                                                 
                                                // check To-Many-Link 'elements' between assignment and uMLMethod11
                                                JavaSDM.ensure ( assignment.hasInElements ("method", uMLMethod11) ) ;
                                                 
                                                // check To-Many-Link 'elements' between assignment and attrib
                                                JavaSDM.ensure ( assignment.hasInElements ("field", attrib) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object uMLMethod11 is really bound
                                             JavaSDM.ensure ( uMLMethod11 != null ) ;
                                              
                                             // check object attrib is really bound
                                             JavaSDM.ensure ( attrib != null ) ;
                                              
                                             // check object param is really bound
                                             JavaSDM.ensure ( param != null ) ;
                                              
                                             // check object leftID is really bound
                                             JavaSDM.ensure ( leftID != null ) ;
                                              
                                             // check object left is really bound
                                             JavaSDM.ensure ( left != null ) ;
                                              
                                             // check object root is really bound
                                             JavaSDM.ensure ( root != null ) ;
                                              
                                             // check object right is really bound
                                             JavaSDM.ensure ( right != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(left.equals (right)) ) ;
                                              
                                             // check object rightID is really bound
                                             JavaSDM.ensure ( rightID != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(leftID.equals (rightID)) ) ;
                                              
                                             // create object
                                             assignment = new AssignmentAnnotation ( ) ;
                                              
                                             // create link
                                             assignment.addToElements ("method", uMLMethod11);
                                              
                                             // create link
                                             assignment.addToElements ("field", attrib);
                                              
                                             // create link
                                             assignment.addToElements ("param", param);
                                              
                                             // create link
                                             assignment.addToBoundObjects ("attrib", attrib);
                                              
                                             // create link
                                             assignment.addToBoundObjects ("param", param);
                                              
                                             // create link
                                             assignment.addToBoundObjects ("leftID", leftID);
                                              
                                             // create link
                                             assignment.addToBoundObjects ("left", left);
                                              
                                             // create link
                                             assignment.addToBoundObjects ("root", root);
                                              
                                             // create link
                                             assignment.addToBoundObjects ("right", right);
                                              
                                             // create link
                                             assignment.addToBoundObjects ("rightID", rightID);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (assignment) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object assignment is really bound
            JavaSDM.ensure ( assignment != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("method", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (assignment) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLParam )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("param", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      return (FEmptyIterator.get()) ;
   }


}
