package de.upb.inferenceengine.engines;

import de.upb.tools.fca.FEmptyIterator;
import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLParam;
import de.upb.javaast.methodast.PrimaryExpressionNode;
import de.uni_paderborn.fujaba.uml.ASTRootNode;
import de.upb.javaast.methodast.IdentifierNode;
import java.util.regex.Pattern;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.upb.javaast.methodast.MethodCallNode;

public class AssignmentToContainerEngine
extends GFRNEngine
{
   private  AssignmentToContainerEngine()
   {
   }

   private static AssignmentToContainerEngine theAssignmentToContainerEngine;

   public static AssignmentToContainerEngine get()
   {
      if (theAssignmentToContainerEngine == null)
      {
         theAssignmentToContainerEngine = new AssignmentToContainerEngine ();
      }
      return theAssignmentToContainerEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ASTPathVisitor fujaba__IterMethodCallToId2 = null ;
      ASTPathVisitor fujaba__IterRootToPrimaryExpressionNode2 = null ;
      ASTPathVisitor fujaba__IterRootToPrimaryExpressionNode5 = null ;
      ASTPathVisitor fujaba__IterRootToPrimaryExpressionNode8 = null ;
      de.uni_paderborn.fujaba.uml.ASTRootNode root = null ;
      AssignmentToContainerAnnotation assignmentToContainer = null ;
      Iterator fujaba__IterAttribAnnotationsAssignmentToContainer = null ;
      Iterator fujaba__IterParamAnnotationsAssignmentToContainer = null ;
      Iterator fujaba__IterUMLClass3AttrsAttrib = null ;
      Iterator fujaba__IterUMLClass6MethodsUMLMethod4 = null ;
      Iterator fujaba__IterUMLClass9AttrsAttrib = null ;
      Iterator fujaba__IterUMLMethod1ParamParam = null ;
      Iterator fujaba__IterUMLMethod4ParamParam = null ;
      Iterator fujaba__IterUMLMethod7AnnotationsAssignmentToContainer = null ;
      de.upb.javaast.methodast.IdentifierNode addTo = null ;
      de.upb.javaast.methodast.IdentifierNode id1 = null ;
      de.upb.javaast.methodast.IdentifierNode id2 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCall = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode2 = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode5 = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode8 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr attrib = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass3 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass6 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass9 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod1 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod4 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod7 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam param = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            uMLMethod1 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind root: ASTRootNode
            root = uMLMethod1.getASTRootNode () ;
            JavaSDM.ensure ( root != null ) ;
             
            // bind uMLClass3: UMLClass
            uMLClass3 = uMLMethod1.getParent () ;
            JavaSDM.ensure ( uMLClass3 != null ) ;
             
            // bind param: UMLParam
            fujaba__IterUMLMethod1ParamParam = uMLMethod1.iteratorOfParam () ;
            while ( fujaba__IterUMLMethod1ParamParam.hasNext () )
            {
               try
               {
                  param = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__IterUMLMethod1ParamParam.next () ;
                   
                  // bind attrib: UMLAttr
                  fujaba__IterUMLClass3AttrsAttrib = uMLClass3.iteratorOfAttrs () ;
                  while ( fujaba__IterUMLClass3AttrsAttrib.hasNext () )
                  {
                     try
                     {
                        attrib = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterUMLClass3AttrsAttrib.next () ;
                         
                        // Path search between ASTRootNode and PrimaryExpressionNode
                        // Bind primaryExpressionNode2 : PrimaryExpressionNode
                        fujaba__IterRootToPrimaryExpressionNode2 = new ASTPathVisitor (root, PrimaryExpressionNode.class ) ;
                        while ( fujaba__IterRootToPrimaryExpressionNode2.hasNext () )
                        {
                           try
                           {
                              primaryExpressionNode2 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootToPrimaryExpressionNode2.next () ;
                               
                              // bind id1: IdentifierNode
                              id1 = primaryExpressionNode2.getIdentifier () ;
                              JavaSDM.ensure ( id1 != null ) ;
                               
                              // bind methodCall: MethodCallNode
                              fujaba__TmpObject = primaryExpressionNode2.getNextPrimaryExpression () ;
                              JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                              methodCall = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(primaryExpressionNode2.equals (methodCall)) ) ;
                               
                              // bind addTo: IdentifierNode
                              addTo = methodCall.getIdentifier () ;
                              JavaSDM.ensure ( addTo != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( ((addTo.getName () != null) && Pattern.matches ("add|put", addTo.getName ())) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(id1.equals (addTo)) ) ;
                               
                              // Path search between MethodCallNode and IdentifierNode
                              // Bind id2 : IdentifierNode
                              fujaba__IterMethodCallToId2 = new ASTPathVisitor (methodCall, IdentifierNode.class ) ;
                              while ( fujaba__IterMethodCallToId2.hasNext () )
                              {
                                 try
                                 {
                                    id2 = (de.upb.javaast.methodast.IdentifierNode) fujaba__IterMethodCallToId2.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(addTo.equals (id2)) && !(id1.equals (id2)) ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( id1.getName().equals(attrib.getName()) ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( id2.getName().equals(param.getName()) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object attrib is really bound
                                          JavaSDM.ensure ( attrib != null ) ;
                                           
                                          // check object param is really bound
                                          JavaSDM.ensure ( param != null ) ;
                                           
                                          // check object uMLMethod1 is really bound
                                          JavaSDM.ensure ( uMLMethod1 != null ) ;
                                           
                                          // bind assignmentToContainer: AssignmentToContainerAnnotation
                                          fujaba__IterAttribAnnotationsAssignmentToContainer = attrib.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterAttribAnnotationsAssignmentToContainer.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterAttribAnnotationsAssignmentToContainer.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof AssignmentToContainerAnnotation ) ;
                                                assignmentToContainer = (AssignmentToContainerAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between assignmentToContainer and attrib
                                                JavaSDM.ensure ( assignmentToContainer.hasInElements ("field", attrib) ) ;
                                                 
                                                // check To-Many-Link 'elements' between assignmentToContainer and param
                                                JavaSDM.ensure ( assignmentToContainer.hasInElements ("param", param) ) ;
                                                 
                                                // check To-Many-Link 'elements' between assignmentToContainer and uMLMethod1
                                                JavaSDM.ensure ( assignmentToContainer.hasInElements ("method", uMLMethod1) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object attrib is really bound
                                             JavaSDM.ensure ( attrib != null ) ;
                                              
                                             // check object param is really bound
                                             JavaSDM.ensure ( param != null ) ;
                                              
                                             // check object uMLMethod1 is really bound
                                             JavaSDM.ensure ( uMLMethod1 != null ) ;
                                              
                                             // check object root is really bound
                                             JavaSDM.ensure ( root != null ) ;
                                              
                                             // check object methodCall is really bound
                                             JavaSDM.ensure ( methodCall != null ) ;
                                              
                                             // check object id2 is really bound
                                             JavaSDM.ensure ( id2 != null ) ;
                                              
                                             // check object addTo is really bound
                                             JavaSDM.ensure ( addTo != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(id2.equals (addTo)) ) ;
                                              
                                             // check object id1 is really bound
                                             JavaSDM.ensure ( id1 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(id2.equals (id1)) && !(addTo.equals (id1)) ) ;
                                              
                                             // create object
                                             assignmentToContainer = new AssignmentToContainerAnnotation ( ) ;
                                              
                                             // create link
                                             assignmentToContainer.addToElements ("field", attrib);
                                              
                                             // create link
                                             assignmentToContainer.addToElements ("param", param);
                                              
                                             // create link
                                             assignmentToContainer.addToElements ("method", uMLMethod1);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("attrib", attrib);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("param", param);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("root", root);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("methodCall", methodCall);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("id2", id2);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("addTo", addTo);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("id1", id1);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (assignmentToContainer) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object assignmentToContainer is really bound
            JavaSDM.ensure ( assignmentToContainer != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("method", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            attrib = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind uMLClass6: UMLClass
            uMLClass6 = attrib.getParent () ;
            JavaSDM.ensure ( uMLClass6 != null ) ;
             
            // bind uMLMethod4: UMLMethod
            fujaba__IterUMLClass6MethodsUMLMethod4 = uMLClass6.iteratorOfMethods () ;
            while ( fujaba__IterUMLClass6MethodsUMLMethod4.hasNext () )
            {
               try
               {
                  uMLMethod4 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterUMLClass6MethodsUMLMethod4.next () ;
                   
                  // bind root: ASTRootNode
                  root = uMLMethod4.getASTRootNode () ;
                  JavaSDM.ensure ( root != null ) ;
                   
                  // bind param: UMLParam
                  fujaba__IterUMLMethod4ParamParam = uMLMethod4.iteratorOfParam () ;
                  while ( fujaba__IterUMLMethod4ParamParam.hasNext () )
                  {
                     try
                     {
                        param = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__IterUMLMethod4ParamParam.next () ;
                         
                        // Path search between ASTRootNode and PrimaryExpressionNode
                        // Bind primaryExpressionNode5 : PrimaryExpressionNode
                        fujaba__IterRootToPrimaryExpressionNode5 = new ASTPathVisitor (root, PrimaryExpressionNode.class ) ;
                        while ( fujaba__IterRootToPrimaryExpressionNode5.hasNext () )
                        {
                           try
                           {
                              primaryExpressionNode5 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootToPrimaryExpressionNode5.next () ;
                               
                              // bind id1: IdentifierNode
                              id1 = primaryExpressionNode5.getIdentifier () ;
                              JavaSDM.ensure ( id1 != null ) ;
                               
                              // bind methodCall: MethodCallNode
                              fujaba__TmpObject = primaryExpressionNode5.getNextPrimaryExpression () ;
                              JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                              methodCall = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(primaryExpressionNode5.equals (methodCall)) ) ;
                               
                              // bind addTo: IdentifierNode
                              addTo = methodCall.getIdentifier () ;
                              JavaSDM.ensure ( addTo != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( ((addTo.getName () != null) && Pattern.matches ("add|put", addTo.getName ())) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(id1.equals (addTo)) ) ;
                               
                              // Path search between MethodCallNode and IdentifierNode
                              // Bind id2 : IdentifierNode
                              fujaba__IterMethodCallToId2 = new ASTPathVisitor (methodCall, IdentifierNode.class ) ;
                              while ( fujaba__IterMethodCallToId2.hasNext () )
                              {
                                 try
                                 {
                                    id2 = (de.upb.javaast.methodast.IdentifierNode) fujaba__IterMethodCallToId2.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(addTo.equals (id2)) && !(id1.equals (id2)) ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( id1.getName().equals(attrib.getName()) ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( id2.getName().equals(param.getName()) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object attrib is really bound
                                          JavaSDM.ensure ( attrib != null ) ;
                                           
                                          // check object param is really bound
                                          JavaSDM.ensure ( param != null ) ;
                                           
                                          // check object uMLMethod4 is really bound
                                          JavaSDM.ensure ( uMLMethod4 != null ) ;
                                           
                                          // bind assignmentToContainer: AssignmentToContainerAnnotation
                                          fujaba__IterParamAnnotationsAssignmentToContainer = param.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterParamAnnotationsAssignmentToContainer.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterParamAnnotationsAssignmentToContainer.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof AssignmentToContainerAnnotation ) ;
                                                assignmentToContainer = (AssignmentToContainerAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between assignmentToContainer and param
                                                JavaSDM.ensure ( assignmentToContainer.hasInElements ("param", param) ) ;
                                                 
                                                // check To-Many-Link 'elements' between assignmentToContainer and attrib
                                                JavaSDM.ensure ( assignmentToContainer.hasInElements ("field", attrib) ) ;
                                                 
                                                // check To-Many-Link 'elements' between assignmentToContainer and uMLMethod4
                                                JavaSDM.ensure ( assignmentToContainer.hasInElements ("method", uMLMethod4) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object attrib is really bound
                                             JavaSDM.ensure ( attrib != null ) ;
                                              
                                             // check object param is really bound
                                             JavaSDM.ensure ( param != null ) ;
                                              
                                             // check object uMLMethod4 is really bound
                                             JavaSDM.ensure ( uMLMethod4 != null ) ;
                                              
                                             // check object root is really bound
                                             JavaSDM.ensure ( root != null ) ;
                                              
                                             // check object methodCall is really bound
                                             JavaSDM.ensure ( methodCall != null ) ;
                                              
                                             // check object id2 is really bound
                                             JavaSDM.ensure ( id2 != null ) ;
                                              
                                             // check object addTo is really bound
                                             JavaSDM.ensure ( addTo != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(id2.equals (addTo)) ) ;
                                              
                                             // check object id1 is really bound
                                             JavaSDM.ensure ( id1 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(id2.equals (id1)) && !(addTo.equals (id1)) ) ;
                                              
                                             // create object
                                             assignmentToContainer = new AssignmentToContainerAnnotation ( ) ;
                                              
                                             // create link
                                             assignmentToContainer.addToElements ("field", attrib);
                                              
                                             // create link
                                             assignmentToContainer.addToElements ("param", param);
                                              
                                             // create link
                                             assignmentToContainer.addToElements ("method", uMLMethod4);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("attrib", attrib);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("param", param);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("root", root);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("methodCall", methodCall);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("id2", id2);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("addTo", addTo);
                                              
                                             // create link
                                             assignmentToContainer.addToBoundObjects ("id1", id1);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (assignmentToContainer) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object assignmentToContainer is really bound
            JavaSDM.ensure ( assignmentToContainer != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("param", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
             
            // explicit type cast
            param = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod7: UMLMethod
            uMLMethod7 = param.getRevParam () ;
            JavaSDM.ensure ( uMLMethod7 != null ) ;
             
            // bind root: ASTRootNode
            root = uMLMethod7.getASTRootNode () ;
            JavaSDM.ensure ( root != null ) ;
             
            // bind uMLClass9: UMLClass
            uMLClass9 = uMLMethod7.getParent () ;
            JavaSDM.ensure ( uMLClass9 != null ) ;
             
            // bind attrib: UMLAttr
            fujaba__IterUMLClass9AttrsAttrib = uMLClass9.iteratorOfAttrs () ;
            while ( fujaba__IterUMLClass9AttrsAttrib.hasNext () )
            {
               try
               {
                  attrib = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterUMLClass9AttrsAttrib.next () ;
                   
                  // Path search between ASTRootNode and PrimaryExpressionNode
                  // Bind primaryExpressionNode8 : PrimaryExpressionNode
                  fujaba__IterRootToPrimaryExpressionNode8 = new ASTPathVisitor (root, PrimaryExpressionNode.class ) ;
                  while ( fujaba__IterRootToPrimaryExpressionNode8.hasNext () )
                  {
                     try
                     {
                        primaryExpressionNode8 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootToPrimaryExpressionNode8.next () ;
                         
                        // bind id1: IdentifierNode
                        id1 = primaryExpressionNode8.getIdentifier () ;
                        JavaSDM.ensure ( id1 != null ) ;
                         
                        // bind methodCall: MethodCallNode
                        fujaba__TmpObject = primaryExpressionNode8.getNextPrimaryExpression () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                        methodCall = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(primaryExpressionNode8.equals (methodCall)) ) ;
                         
                        // bind addTo: IdentifierNode
                        addTo = methodCall.getIdentifier () ;
                        JavaSDM.ensure ( addTo != null ) ;
                         
                        // attribute condition
                        JavaSDM.ensure ( ((addTo.getName () != null) && Pattern.matches ("add|put", addTo.getName ())) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(id1.equals (addTo)) ) ;
                         
                        // Path search between MethodCallNode and IdentifierNode
                        // Bind id2 : IdentifierNode
                        fujaba__IterMethodCallToId2 = new ASTPathVisitor (methodCall, IdentifierNode.class ) ;
                        while ( fujaba__IterMethodCallToId2.hasNext () )
                        {
                           try
                           {
                              id2 = (de.upb.javaast.methodast.IdentifierNode) fujaba__IterMethodCallToId2.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(addTo.equals (id2)) && !(id1.equals (id2)) ) ;
                               
                              // constraint
                              JavaSDM.ensure ( id1.getName().equals(attrib.getName()) ) ;
                               
                              // constraint
                              JavaSDM.ensure ( id2.getName().equals(param.getName()) ) ;
                               
                              {
                                 //  for each flow
                                 try
                                 {
                                    fujaba__Success = false ;
                                     
                                    // check object attrib is really bound
                                    JavaSDM.ensure ( attrib != null ) ;
                                     
                                    // check object param is really bound
                                    JavaSDM.ensure ( param != null ) ;
                                     
                                    // check object uMLMethod7 is really bound
                                    JavaSDM.ensure ( uMLMethod7 != null ) ;
                                     
                                    // bind assignmentToContainer: AssignmentToContainerAnnotation
                                    fujaba__IterUMLMethod7AnnotationsAssignmentToContainer = uMLMethod7.iteratorOfAnnotations () ;
                                    while ( !(fujaba__Success) && fujaba__IterUMLMethod7AnnotationsAssignmentToContainer.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterUMLMethod7AnnotationsAssignmentToContainer.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof AssignmentToContainerAnnotation ) ;
                                          assignmentToContainer = (AssignmentToContainerAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between assignmentToContainer and uMLMethod7
                                          JavaSDM.ensure ( assignmentToContainer.hasInElements ("method", uMLMethod7) ) ;
                                           
                                          // check To-Many-Link 'elements' between assignmentToContainer and attrib
                                          JavaSDM.ensure ( assignmentToContainer.hasInElements ("field", attrib) ) ;
                                           
                                          // check To-Many-Link 'elements' between assignmentToContainer and param
                                          JavaSDM.ensure ( assignmentToContainer.hasInElements ("param", param) ) ;
                                           
                                          fujaba__Success = true ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                    fujaba__Success = false ;
                                 }
                                  
                                 if ( !(fujaba__Success) )
                                 {
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object attrib is really bound
                                       JavaSDM.ensure ( attrib != null ) ;
                                        
                                       // check object param is really bound
                                       JavaSDM.ensure ( param != null ) ;
                                        
                                       // check object uMLMethod7 is really bound
                                       JavaSDM.ensure ( uMLMethod7 != null ) ;
                                        
                                       // check object root is really bound
                                       JavaSDM.ensure ( root != null ) ;
                                        
                                       // check object methodCall is really bound
                                       JavaSDM.ensure ( methodCall != null ) ;
                                        
                                       // check object id2 is really bound
                                       JavaSDM.ensure ( id2 != null ) ;
                                        
                                       // check object addTo is really bound
                                       JavaSDM.ensure ( addTo != null ) ;
                                        
                                       // check isomorphic binding
                                       JavaSDM.ensure ( !(id2.equals (addTo)) ) ;
                                        
                                       // check object id1 is really bound
                                       JavaSDM.ensure ( id1 != null ) ;
                                        
                                       // check isomorphic binding
                                       JavaSDM.ensure ( !(id2.equals (id1)) && !(addTo.equals (id1)) ) ;
                                        
                                       // create object
                                       assignmentToContainer = new AssignmentToContainerAnnotation ( ) ;
                                        
                                       // create link
                                       assignmentToContainer.addToElements ("field", attrib);
                                        
                                       // create link
                                       assignmentToContainer.addToElements ("param", param);
                                        
                                       // create link
                                       assignmentToContainer.addToElements ("method", uMLMethod7);
                                        
                                       // create link
                                       assignmentToContainer.addToBoundObjects ("attrib", attrib);
                                        
                                       // create link
                                       assignmentToContainer.addToBoundObjects ("param", param);
                                        
                                       // create link
                                       assignmentToContainer.addToBoundObjects ("root", root);
                                        
                                       // create link
                                       assignmentToContainer.addToBoundObjects ("methodCall", methodCall);
                                        
                                       // create link
                                       assignmentToContainer.addToBoundObjects ("id2", id2);
                                        
                                       // create link
                                       assignmentToContainer.addToBoundObjects ("addTo", addTo);
                                        
                                       // create link
                                       assignmentToContainer.addToBoundObjects ("id1", id1);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    return (assignmentToContainer) ;
                                 }
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object assignmentToContainer is really bound
            JavaSDM.ensure ( assignmentToContainer != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("param", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (assignmentToContainer) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLParam )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("param", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      return (FEmptyIterator.get()) ;
   }


}
