package de.upb.inferenceengine.engines;

import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.upb.javaast.methodast.MethodCallNode;
import de.upb.javaast.methodast.IdentifierNode;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.ASTRootNode;

public class AssocSetMethodEngine
extends GFRNEngine
{
   private  AssocSetMethodEngine()
   {
   }

   private static AssocSetMethodEngine theAssocSetMethodEngine;

   public static AssocSetMethodEngine get()
   {
      if (theAssocSetMethodEngine == null)
      {
         theAssocSetMethodEngine = new AssocSetMethodEngine ();
      }
      return theAssocSetMethodEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ASTPathVisitor fujaba__IterASTRootNode10ToMethodCallNode11 = null ;
      ASTPathVisitor fujaba__IterASTRootNode2ToMethodCallNode3 = null ;
      ASTPathVisitor fujaba__IterASTRootNode6ToMethodCallNode7 = null ;
      de.uni_paderborn.fujaba.uml.ASTRootNode aSTRootNode10 = null ;
      de.uni_paderborn.fujaba.uml.ASTRootNode aSTRootNode2 = null ;
      de.uni_paderborn.fujaba.uml.ASTRootNode aSTRootNode6 = null ;
      AssocSetMethodAnnotation assocSetMethod = null ;
      AttributeAccessAnnotation attributeAccess1 = null ;
      AttributeAccessAnnotation attributeAccess5 = null ;
      AttributeAccessAnnotation attributeAccess9 = null ;
      Iterator fujaba__IterCalleeAnnotationsAssocSetMethod = null ;
      Iterator fujaba__IterReference12ElementsReferencingField = null ;
      Iterator fujaba__IterReference4ElementsReferencedClass = null ;
      Iterator fujaba__IterReference8AnnotationsAssocSetMethod = null ;
      Iterator fujaba__IterReference8ElementsReferencedClass = null ;
      Iterator fujaba__IterReference8ElementsReferencingField = null ;
      Iterator fujaba__IterReferencedClassAnnotationsReference12 = null ;
      Iterator fujaba__IterReferencedClassMethodsCallee = null ;
      Iterator fujaba__IterReferencingClassAttrsReferencingField = null ;
      Iterator fujaba__IterReferencingClassMethodsSetter = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsAttributeAccess5 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsAttributeAccess9 = null ;
      Iterator fujaba__IterReferencingFieldAnnotationsReference4 = null ;
      Iterator fujaba__IterSetterAnnotationsAssocSetMethod = null ;
      Iterator fujaba__IterSetterAnnotationsAttributeAccess1 = null ;
      de.upb.javaast.methodast.IdentifierNode id = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode11 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode3 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode7 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference12 = null ;
      ReferenceAnnotation reference4 = null ;
      ReferenceAnnotation reference8 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr referencingField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referencedClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referencingClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod setter = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("setMethod", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            setter = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind aSTRootNode2: ASTRootNode
            aSTRootNode2 = setter.getASTRootNode () ;
            JavaSDM.ensure ( aSTRootNode2 != null ) ;
             
            // bind referencingClass: UMLClass
            referencingClass = setter.getParent () ;
            JavaSDM.ensure ( referencingClass != null ) ;
             
            // bind attributeAccess1: AttributeAccessAnnotation
            fujaba__IterSetterAnnotationsAttributeAccess1 = setter.iteratorOfAnnotations () ;
            while ( fujaba__IterSetterAnnotationsAttributeAccess1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSetterAnnotationsAttributeAccess1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AttributeAccessAnnotation ) ;
                  attributeAccess1 = (AttributeAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between attributeAccess1 and setter
                  JavaSDM.ensure ( attributeAccess1.hasInElements ("method", setter) ) ;
                   
                  // bind referencingField: UMLAttr
                  fujaba__IterReferencingClassAttrsReferencingField = referencingClass.iteratorOfAttrs () ;
                  while ( fujaba__IterReferencingClassAttrsReferencingField.hasNext () )
                  {
                     try
                     {
                        referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterReferencingClassAttrsReferencingField.next () ;
                         
                        // check To-Many-Link 'elements' between attributeAccess1 and referencingField
                        JavaSDM.ensure ( attributeAccess1.hasInElements ("field", referencingField) ) ;
                         
                        // bind reference4: ReferenceAnnotation
                        fujaba__IterReferencingFieldAnnotationsReference4 = referencingField.iteratorOfAnnotations () ;
                        while ( fujaba__IterReferencingFieldAnnotationsReference4.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsReference4.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                              reference4 = (ReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between reference4 and referencingField
                              JavaSDM.ensure ( reference4.hasInElements ("field", referencingField) ) ;
                               
                              // bind referencedClass: UMLClass
                              fujaba__IterReference4ElementsReferencedClass = reference4.iteratorOfElements ("references") ;
                              while ( fujaba__IterReference4ElementsReferencedClass.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterReference4ElementsReferencedClass.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    referencedClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                     
                                    // bind callee: UMLMethod
                                    fujaba__IterReferencedClassMethodsCallee = referencedClass.iteratorOfMethods () ;
                                    while ( fujaba__IterReferencedClassMethodsCallee.hasNext () )
                                    {
                                       try
                                       {
                                          callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencedClassMethodsCallee.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                           
                                          // Path search between ASTRootNode and MethodCallNode
                                          // Bind methodCallNode3 : MethodCallNode
                                          fujaba__IterASTRootNode2ToMethodCallNode3 = new ASTPathVisitor (aSTRootNode2, MethodCallNode.class ) ;
                                          while ( fujaba__IterASTRootNode2ToMethodCallNode3.hasNext () )
                                          {
                                             try
                                             {
                                                methodCallNode3 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterASTRootNode2ToMethodCallNode3.next () ;
                                                 
                                                // bind id: IdentifierNode
                                                id = methodCallNode3.getIdentifier () ;
                                                JavaSDM.ensure ( id != null ) ;
                                                 
                                                // constraint
                                                JavaSDM.ensure ( id.getName().equals(callee.getName()) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object setter is really bound
                                                      JavaSDM.ensure ( setter != null ) ;
                                                       
                                                      // check object callee is really bound
                                                      JavaSDM.ensure ( callee != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                                       
                                                      // check object reference4 is really bound
                                                      JavaSDM.ensure ( reference4 != null ) ;
                                                       
                                                      // bind assocSetMethod: AssocSetMethodAnnotation
                                                      fujaba__IterCalleeAnnotationsAssocSetMethod = callee.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterCalleeAnnotationsAssocSetMethod.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterCalleeAnnotationsAssocSetMethod.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                                                            assocSetMethod = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between assocSetMethod and callee
                                                            JavaSDM.ensure ( assocSetMethod.hasInElements ("calledMethod", callee) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between assocSetMethod and setter
                                                            JavaSDM.ensure ( assocSetMethod.hasInElements ("setMethod", setter) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between assocSetMethod and reference4
                                                            JavaSDM.ensure ( assocSetMethod.hasInElements ("reference", reference4) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object setter is really bound
                                                         JavaSDM.ensure ( setter != null ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                                          
                                                         // check object reference4 is really bound
                                                         JavaSDM.ensure ( reference4 != null ) ;
                                                          
                                                         // check object referencingField is really bound
                                                         JavaSDM.ensure ( referencingField != null ) ;
                                                          
                                                         // check object id is really bound
                                                         JavaSDM.ensure ( id != null ) ;
                                                          
                                                         // check object referencingClass is really bound
                                                         JavaSDM.ensure ( referencingClass != null ) ;
                                                          
                                                         // check object referencedClass is really bound
                                                         JavaSDM.ensure ( referencedClass != null ) ;
                                                          
                                                         // create object
                                                         assocSetMethod = new AssocSetMethodAnnotation ( ) ;
                                                          
                                                         // create link
                                                         assocSetMethod.addToElements ("setMethod", setter);
                                                          
                                                         // create link
                                                         assocSetMethod.addToElements ("calledMethod", callee);
                                                          
                                                         // create link
                                                         assocSetMethod.addToElements ("reference", reference4);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("referencingField", referencingField);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("setter", setter);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("id", id);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("referencingClass", referencingClass);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("referencedClass", referencedClass);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("callee", callee);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object attributeAccess1 is really bound
                                                         JavaSDM.ensure ( attributeAccess1 != null ) ;
                                                          
                                                         // check object reference4 is really bound
                                                         JavaSDM.ensure ( reference4 != null ) ;
                                                          
                                                         // check object assocSetMethod is really bound
                                                         JavaSDM.ensure ( assocSetMethod != null ) ;
                                                          
                                                         // create link
                                                         assocSetMethod.addToAntecedentAnnos (attributeAccess1);
                                                          
                                                         // create link
                                                         assocSetMethod.addToAntecedentAnnos (reference4);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (assocSetMethod) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object assocSetMethod is really bound
            JavaSDM.ensure ( assocSetMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("setMethod", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("reference", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference8 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReference8ElementsReferencingField = reference8.iteratorOfElements ("field") ;
            while ( fujaba__IterReference8ElementsReferencingField.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference8ElementsReferencingField.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                   
                  // bind referencingClass: UMLClass
                  referencingClass = referencingField.getParent () ;
                  JavaSDM.ensure ( referencingClass != null ) ;
                   
                  // bind referencedClass: UMLClass
                  fujaba__IterReference8ElementsReferencedClass = reference8.iteratorOfElements ("references") ;
                  while ( fujaba__IterReference8ElementsReferencedClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterReference8ElementsReferencedClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        referencedClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // bind attributeAccess5: AttributeAccessAnnotation
                        fujaba__IterReferencingFieldAnnotationsAttributeAccess5 = referencingField.iteratorOfAnnotations () ;
                        while ( fujaba__IterReferencingFieldAnnotationsAttributeAccess5.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsAttributeAccess5.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof AttributeAccessAnnotation ) ;
                              attributeAccess5 = (AttributeAccessAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between attributeAccess5 and referencingField
                              JavaSDM.ensure ( attributeAccess5.hasInElements ("field", referencingField) ) ;
                               
                              // bind setter: UMLMethod
                              fujaba__IterReferencingClassMethodsSetter = referencingClass.iteratorOfMethods () ;
                              while ( fujaba__IterReferencingClassMethodsSetter.hasNext () )
                              {
                                 try
                                 {
                                    setter = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsSetter.next () ;
                                     
                                    // check To-Many-Link 'elements' between attributeAccess5 and setter
                                    JavaSDM.ensure ( attributeAccess5.hasInElements ("method", setter) ) ;
                                     
                                    // bind aSTRootNode6: ASTRootNode
                                    aSTRootNode6 = setter.getASTRootNode () ;
                                    JavaSDM.ensure ( aSTRootNode6 != null ) ;
                                     
                                    // bind callee: UMLMethod
                                    fujaba__IterReferencedClassMethodsCallee = referencedClass.iteratorOfMethods () ;
                                    while ( fujaba__IterReferencedClassMethodsCallee.hasNext () )
                                    {
                                       try
                                       {
                                          callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencedClassMethodsCallee.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                           
                                          // Path search between ASTRootNode and MethodCallNode
                                          // Bind methodCallNode7 : MethodCallNode
                                          fujaba__IterASTRootNode6ToMethodCallNode7 = new ASTPathVisitor (aSTRootNode6, MethodCallNode.class ) ;
                                          while ( fujaba__IterASTRootNode6ToMethodCallNode7.hasNext () )
                                          {
                                             try
                                             {
                                                methodCallNode7 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterASTRootNode6ToMethodCallNode7.next () ;
                                                 
                                                // bind id: IdentifierNode
                                                id = methodCallNode7.getIdentifier () ;
                                                JavaSDM.ensure ( id != null ) ;
                                                 
                                                // constraint
                                                JavaSDM.ensure ( id.getName().equals(callee.getName()) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object setter is really bound
                                                      JavaSDM.ensure ( setter != null ) ;
                                                       
                                                      // check object callee is really bound
                                                      JavaSDM.ensure ( callee != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                                       
                                                      // check object reference8 is really bound
                                                      JavaSDM.ensure ( reference8 != null ) ;
                                                       
                                                      // bind assocSetMethod: AssocSetMethodAnnotation
                                                      fujaba__IterReference8AnnotationsAssocSetMethod = reference8.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterReference8AnnotationsAssocSetMethod.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterReference8AnnotationsAssocSetMethod.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                                                            assocSetMethod = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between assocSetMethod and reference8
                                                            JavaSDM.ensure ( assocSetMethod.hasInElements ("reference", reference8) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between assocSetMethod and setter
                                                            JavaSDM.ensure ( assocSetMethod.hasInElements ("setMethod", setter) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between assocSetMethod and callee
                                                            JavaSDM.ensure ( assocSetMethod.hasInElements ("calledMethod", callee) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object setter is really bound
                                                         JavaSDM.ensure ( setter != null ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                                          
                                                         // check object reference8 is really bound
                                                         JavaSDM.ensure ( reference8 != null ) ;
                                                          
                                                         // check object referencingField is really bound
                                                         JavaSDM.ensure ( referencingField != null ) ;
                                                          
                                                         // check object id is really bound
                                                         JavaSDM.ensure ( id != null ) ;
                                                          
                                                         // check object referencingClass is really bound
                                                         JavaSDM.ensure ( referencingClass != null ) ;
                                                          
                                                         // check object referencedClass is really bound
                                                         JavaSDM.ensure ( referencedClass != null ) ;
                                                          
                                                         // create object
                                                         assocSetMethod = new AssocSetMethodAnnotation ( ) ;
                                                          
                                                         // create link
                                                         assocSetMethod.addToElements ("setMethod", setter);
                                                          
                                                         // create link
                                                         assocSetMethod.addToElements ("calledMethod", callee);
                                                          
                                                         // create link
                                                         assocSetMethod.addToElements ("reference", reference8);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("referencingField", referencingField);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("setter", setter);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("id", id);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("referencingClass", referencingClass);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("referencedClass", referencedClass);
                                                          
                                                         // create link
                                                         assocSetMethod.addToBoundObjects ("callee", callee);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object attributeAccess5 is really bound
                                                         JavaSDM.ensure ( attributeAccess5 != null ) ;
                                                          
                                                         // check object reference8 is really bound
                                                         JavaSDM.ensure ( reference8 != null ) ;
                                                          
                                                         // check object assocSetMethod is really bound
                                                         JavaSDM.ensure ( assocSetMethod != null ) ;
                                                          
                                                         // create link
                                                         assocSetMethod.addToAntecedentAnnos (attributeAccess5);
                                                          
                                                         // create link
                                                         assocSetMethod.addToAntecedentAnnos (reference8);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (assocSetMethod) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object assocSetMethod is really bound
            JavaSDM.ensure ( assocSetMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("reference", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("calledMethod", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind referencedClass: UMLClass
            referencedClass = callee.getParent () ;
            JavaSDM.ensure ( referencedClass != null ) ;
             
            // bind reference12: ReferenceAnnotation
            fujaba__IterReferencedClassAnnotationsReference12 = referencedClass.iteratorOfAnnotations () ;
            while ( fujaba__IterReferencedClassAnnotationsReference12.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReferencedClassAnnotationsReference12.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                  reference12 = (ReferenceAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between reference12 and referencedClass
                  JavaSDM.ensure ( reference12.hasInElements ("references", referencedClass) ) ;
                   
                  // bind referencingField: UMLAttr
                  fujaba__IterReference12ElementsReferencingField = reference12.iteratorOfElements ("field") ;
                  while ( fujaba__IterReference12ElementsReferencingField.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterReference12ElementsReferencingField.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        // bind referencingClass: UMLClass
                        referencingClass = referencingField.getParent () ;
                        JavaSDM.ensure ( referencingClass != null ) ;
                         
                        // bind attributeAccess9: AttributeAccessAnnotation
                        fujaba__IterReferencingFieldAnnotationsAttributeAccess9 = referencingField.iteratorOfAnnotations () ;
                        while ( fujaba__IterReferencingFieldAnnotationsAttributeAccess9.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReferencingFieldAnnotationsAttributeAccess9.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof AttributeAccessAnnotation ) ;
                              attributeAccess9 = (AttributeAccessAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between attributeAccess9 and referencingField
                              JavaSDM.ensure ( attributeAccess9.hasInElements ("field", referencingField) ) ;
                               
                              // bind setter: UMLMethod
                              fujaba__IterReferencingClassMethodsSetter = referencingClass.iteratorOfMethods () ;
                              while ( fujaba__IterReferencingClassMethodsSetter.hasNext () )
                              {
                                 try
                                 {
                                    setter = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterReferencingClassMethodsSetter.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(callee.equals (setter)) ) ;
                                     
                                    // check To-Many-Link 'elements' between attributeAccess9 and setter
                                    JavaSDM.ensure ( attributeAccess9.hasInElements ("method", setter) ) ;
                                     
                                    // bind aSTRootNode10: ASTRootNode
                                    aSTRootNode10 = setter.getASTRootNode () ;
                                    JavaSDM.ensure ( aSTRootNode10 != null ) ;
                                     
                                    // Path search between ASTRootNode and MethodCallNode
                                    // Bind methodCallNode11 : MethodCallNode
                                    fujaba__IterASTRootNode10ToMethodCallNode11 = new ASTPathVisitor (aSTRootNode10, MethodCallNode.class ) ;
                                    while ( fujaba__IterASTRootNode10ToMethodCallNode11.hasNext () )
                                    {
                                       try
                                       {
                                          methodCallNode11 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterASTRootNode10ToMethodCallNode11.next () ;
                                           
                                          // bind id: IdentifierNode
                                          id = methodCallNode11.getIdentifier () ;
                                          JavaSDM.ensure ( id != null ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id.getName().equals(callee.getName()) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object setter is really bound
                                                JavaSDM.ensure ( setter != null ) ;
                                                 
                                                // check object callee is really bound
                                                JavaSDM.ensure ( callee != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                                 
                                                // check object reference12 is really bound
                                                JavaSDM.ensure ( reference12 != null ) ;
                                                 
                                                // bind assocSetMethod: AssocSetMethodAnnotation
                                                fujaba__IterSetterAnnotationsAssocSetMethod = setter.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterSetterAnnotationsAssocSetMethod.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterSetterAnnotationsAssocSetMethod.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof AssocSetMethodAnnotation ) ;
                                                      assocSetMethod = (AssocSetMethodAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between assocSetMethod and setter
                                                      JavaSDM.ensure ( assocSetMethod.hasInElements ("setMethod", setter) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between assocSetMethod and callee
                                                      JavaSDM.ensure ( assocSetMethod.hasInElements ("calledMethod", callee) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between assocSetMethod and reference12
                                                      JavaSDM.ensure ( assocSetMethod.hasInElements ("reference", reference12) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object setter is really bound
                                                   JavaSDM.ensure ( setter != null ) ;
                                                    
                                                   // check object callee is really bound
                                                   JavaSDM.ensure ( callee != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(setter.equals (callee)) ) ;
                                                    
                                                   // check object reference12 is really bound
                                                   JavaSDM.ensure ( reference12 != null ) ;
                                                    
                                                   // check object referencingField is really bound
                                                   JavaSDM.ensure ( referencingField != null ) ;
                                                    
                                                   // check object id is really bound
                                                   JavaSDM.ensure ( id != null ) ;
                                                    
                                                   // check object referencingClass is really bound
                                                   JavaSDM.ensure ( referencingClass != null ) ;
                                                    
                                                   // check object referencedClass is really bound
                                                   JavaSDM.ensure ( referencedClass != null ) ;
                                                    
                                                   // create object
                                                   assocSetMethod = new AssocSetMethodAnnotation ( ) ;
                                                    
                                                   // create link
                                                   assocSetMethod.addToElements ("setMethod", setter);
                                                    
                                                   // create link
                                                   assocSetMethod.addToElements ("calledMethod", callee);
                                                    
                                                   // create link
                                                   assocSetMethod.addToElements ("reference", reference12);
                                                    
                                                   // create link
                                                   assocSetMethod.addToBoundObjects ("referencingField", referencingField);
                                                    
                                                   // create link
                                                   assocSetMethod.addToBoundObjects ("setter", setter);
                                                    
                                                   // create link
                                                   assocSetMethod.addToBoundObjects ("id", id);
                                                    
                                                   // create link
                                                   assocSetMethod.addToBoundObjects ("referencingClass", referencingClass);
                                                    
                                                   // create link
                                                   assocSetMethod.addToBoundObjects ("referencedClass", referencedClass);
                                                    
                                                   // create link
                                                   assocSetMethod.addToBoundObjects ("callee", callee);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object attributeAccess9 is really bound
                                                   JavaSDM.ensure ( attributeAccess9 != null ) ;
                                                    
                                                   // check object reference12 is really bound
                                                   JavaSDM.ensure ( reference12 != null ) ;
                                                    
                                                   // check object assocSetMethod is really bound
                                                   JavaSDM.ensure ( assocSetMethod != null ) ;
                                                    
                                                   // create link
                                                   assocSetMethod.addToAntecedentAnnos (attributeAccess9);
                                                    
                                                   // create link
                                                   assocSetMethod.addToAntecedentAnnos (reference12);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (assocSetMethod) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object assocSetMethod is really bound
            JavaSDM.ensure ( assocSetMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("calledMethod", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (assocSetMethod) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("setMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("calledMethod", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("reference", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof AttributeAccessAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      AttributeAccessAnnotation attributeAccess14 = null ;
      Iterator fujaba__IterAttributeAccess14ElementsReferencingField = null ;
      Iterator fujaba__IterReference13ElementsReferencingField = null ;
      Iterator fujaba__IterReferencedClassAnnotationsReference13 = null ;
      Iterator fujaba__IterSetterAnnotationsAttributeAccess14 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference13 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr referencingField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass referencedClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod setter = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("AttributeAccess") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            setter = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (setter);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind referencedClass: UMLClass
            referencedClass = callee.getParent () ;
            JavaSDM.ensure ( referencedClass != null ) ;
             
            // bind reference13: ReferenceAnnotation
            fujaba__IterReferencedClassAnnotationsReference13 = referencedClass.iteratorOfAnnotations () ;
            while ( fujaba__IterReferencedClassAnnotationsReference13.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReferencedClassAnnotationsReference13.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                  reference13 = (ReferenceAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between reference13 and referencedClass
                  JavaSDM.ensure ( reference13.hasInElements ("references", referencedClass) ) ;
                   
                  // bind referencingField: UMLAttr
                  fujaba__IterReference13ElementsReferencingField = reference13.iteratorOfElements ("field") ;
                  while ( fujaba__IterReference13ElementsReferencingField.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterReference13ElementsReferencingField.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        {
                           //  for each flow
                           set.add (referencingField);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference13 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReference13ElementsReferencingField = reference13.iteratorOfElements ("field") ;
            while ( fujaba__IterReference13ElementsReferencingField.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference13ElementsReferencingField.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference13 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind referencingField: UMLAttr
            fujaba__IterReference13ElementsReferencingField = reference13.iteratorOfElements ("field") ;
            while ( fujaba__IterReference13ElementsReferencingField.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference13ElementsReferencingField.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (referencingField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Reference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            setter = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind attributeAccess14: AttributeAccessAnnotation
            fujaba__IterSetterAnnotationsAttributeAccess14 = setter.iteratorOfAnnotations () ;
            while ( fujaba__IterSetterAnnotationsAttributeAccess14.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSetterAnnotationsAttributeAccess14.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof AttributeAccessAnnotation ) ;
                  attributeAccess14 = (AttributeAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between attributeAccess14 and setter
                  JavaSDM.ensure ( attributeAccess14.hasInElements ("method", setter) ) ;
                   
                  // bind referencingField: UMLAttr
                  fujaba__IterAttributeAccess14ElementsReferencingField = attributeAccess14.iteratorOfElements ("field") ;
                  while ( fujaba__IterAttributeAccess14ElementsReferencingField.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAttributeAccess14ElementsReferencingField.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        referencingField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        {
                           //  for each flow
                           set.add (referencingField);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind referencedClass: UMLClass
            referencedClass = callee.getParent () ;
            JavaSDM.ensure ( referencedClass != null ) ;
             
            {
               //  for each flow
               set.add (referencedClass);
            } //  end for each flow
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
