package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLStereotype;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLMethod;

public class BridgeInterfaceEngine
extends GFRNEngine
{
   private  BridgeInterfaceEngine()
   {
   }

   private static BridgeInterfaceEngine theBridgeInterfaceEngine;

   public static BridgeInterfaceEngine get()
   {
      if (theBridgeInterfaceEngine == null)
      {
         theBridgeInterfaceEngine = new BridgeInterfaceEngine ();
      }
      return theBridgeInterfaceEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      de.upb.tools.fca.FHashSet set = null ;
      boolean fujaba__Success = false ;
      BridgeInterfaceAnnotation bridgeInterface = null ;
      Iterator fujaba__IterAbstractionAnnotationsBridgeInterface = null ;
      Iterator fujaba__IterAbstractionAnnotationsGeneralization11 = null ;
      Iterator fujaba__IterAbstractionAnnotationsGeneralization3 = null ;
      Iterator fujaba__IterAbstractionAnnotationsGeneralization7 = null ;
      Iterator fujaba__IterAbstractionAttrsRefField = null ;
      Iterator fujaba__IterAbstractionMethodsOperation = null ;
      Iterator fujaba__IterImplementorAnnotationsBridgeInterface = null ;
      Iterator fujaba__IterImplementorAnnotationsReference10 = null ;
      Iterator fujaba__IterImplementorAnnotationsReference2 = null ;
      Iterator fujaba__IterImplementorMethodsOperationImpl = null ;
      Iterator fujaba__IterImplementorStereotypesUMLStereotype1 = null ;
      Iterator fujaba__IterImplementorStereotypesUMLStereotype5 = null ;
      Iterator fujaba__IterImplementorStereotypesUMLStereotype9 = null ;
      Iterator fujaba__IterNeighborCall12ElementsOperation = null ;
      Iterator fujaba__IterNeighborCall12ElementsOperationImpl = null ;
      Iterator fujaba__IterNeighborCall4ElementsOperation = null ;
      Iterator fujaba__IterNeighborCall8ElementsOperationImpl = null ;
      Iterator fujaba__IterOperationAnnotationsNeighborCall8 = null ;
      Iterator fujaba__IterOperationImplAnnotationsNeighborCall4 = null ;
      Iterator fujaba__IterRefFieldAnnotationsReference6 = null ;
      Iterator fujaba__IterReference2ElementsRefField = null ;
      Iterator fujaba__IterReference6ElementsImplementor = null ;
      Iterator fujaba__IterSet = null ;
      GeneralizationAnnotation fujaba__TmpObjectGeneralizationAnnotation = null ;
      GeneralizationAnnotation generalization11 = null ;
      GeneralizationAnnotation generalization3 = null ;
      GeneralizationAnnotation generalization7 = null ;
      NeighborCallAnnotation neighborCall12 = null ;
      NeighborCallAnnotation neighborCall4 = null ;
      NeighborCallAnnotation neighborCall8 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference10 = null ;
      ReferenceAnnotation reference2 = null ;
      ReferenceAnnotation reference6 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr refField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass abstraction = null ;
      de.uni_paderborn.fujaba.uml.UMLClass implementor = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod operation = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod operationImpl = null ;
      de.uni_paderborn.fujaba.uml.UMLStereotype uMLStereotype1 = null ;
      de.uni_paderborn.fujaba.uml.UMLStereotype uMLStereotype5 = null ;
      de.uni_paderborn.fujaba.uml.UMLStereotype uMLStereotype9 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("implementor", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            implementor = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind operationImpl: UMLMethod
            fujaba__IterImplementorMethodsOperationImpl = implementor.iteratorOfMethods () ;
            while ( fujaba__IterImplementorMethodsOperationImpl.hasNext () )
            {
               try
               {
                  operationImpl = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterImplementorMethodsOperationImpl.next () ;
                   
                  // bind uMLStereotype1: UMLStereotype
                  fujaba__IterImplementorStereotypesUMLStereotype1 = implementor.iteratorOfStereotypes () ;
                  while ( fujaba__IterImplementorStereotypesUMLStereotype1.hasNext () )
                  {
                     try
                     {
                        uMLStereotype1 = (de.uni_paderborn.fujaba.uml.UMLStereotype) fujaba__IterImplementorStereotypesUMLStereotype1.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (JavaSDM.stringCompare (uMLStereotype1.getText (), "interface") == 0) ) ;
                         
                        // bind reference2: ReferenceAnnotation
                        fujaba__IterImplementorAnnotationsReference2 = implementor.iteratorOfAnnotations () ;
                        while ( fujaba__IterImplementorAnnotationsReference2.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterImplementorAnnotationsReference2.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                              reference2 = (ReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between reference2 and implementor
                              JavaSDM.ensure ( reference2.hasInElements ("references", implementor) ) ;
                               
                              // bind neighborCall4: NeighborCallAnnotation
                              fujaba__IterOperationImplAnnotationsNeighborCall4 = operationImpl.iteratorOfAnnotations () ;
                              while ( fujaba__IterOperationImplAnnotationsNeighborCall4.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterOperationImplAnnotationsNeighborCall4.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                    neighborCall4 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between neighborCall4 and operationImpl
                                    JavaSDM.ensure ( neighborCall4.hasInElements ("callee", operationImpl) ) ;
                                     
                                    // bind refField: UMLAttr
                                    fujaba__IterReference2ElementsRefField = reference2.iteratorOfElements ("field") ;
                                    while ( fujaba__IterReference2ElementsRefField.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterReference2ElementsRefField.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                                          refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                                           
                                          // bind abstraction: UMLClass
                                          abstraction = refField.getParent () ;
                                          JavaSDM.ensure ( abstraction != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(implementor.equals (abstraction)) ) ;
                                           
                                          // bind operation: UMLMethod
                                          fujaba__IterNeighborCall4ElementsOperation = neighborCall4.iteratorOfElements ("caller") ;
                                          while ( fujaba__IterNeighborCall4ElementsOperation.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterNeighborCall4ElementsOperation.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                operation = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(operationImpl.equals (operation)) ) ;
                                                 
                                                // check To-One-Link 'parent' between operation and abstraction
                                                JavaSDM.ensure ( (operation.getParent () != null) && operation.getParent ().equals (abstraction) ) ;
                                                 
                                                // bind generalization3: GeneralizationAnnotation
                                                fujaba__IterAbstractionAnnotationsGeneralization3 = abstraction.iteratorOfAnnotations () ;
                                                while ( fujaba__IterAbstractionAnnotationsGeneralization3.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterAbstractionAnnotationsGeneralization3.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                      generalization3 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between generalization3 and abstraction
                                                      JavaSDM.ensure ( generalization3.hasInElements ("superClass", abstraction) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( (set == null) || !(set.contains (generalization3)) ) ;
                                                       
                                                      // linkSearchToSetTop
                                                      set = new de.upb.tools.fca.FHashSet ( ) ;
                                                      fujaba__IterSet = implementor.iteratorOfAnnotations () ;
                                                      while ( fujaba__IterSet.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterSet.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                            fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                             
                                                            set.remove (generalization3);
                                                            //  check link :) 'elements' between set and abstraction
                                                            JavaSDM.ensure ( fujaba__TmpObjectGeneralizationAnnotation.hasInElements (abstraction) ) ;
                                                             
                                                            set.add (fujaba__TmpObjectGeneralizationAnnotation);
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      } // while
                                                      // constraint
                                                      JavaSDM.ensure ( set.size() == 0 ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object implementor is really bound
                                                            JavaSDM.ensure ( implementor != null ) ;
                                                             
                                                            // check object abstraction is really bound
                                                            JavaSDM.ensure ( abstraction != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(implementor.equals (abstraction)) ) ;
                                                             
                                                            // bind bridgeInterface: BridgeInterfaceAnnotation
                                                            fujaba__IterAbstractionAnnotationsBridgeInterface = abstraction.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterAbstractionAnnotationsBridgeInterface.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterAbstractionAnnotationsBridgeInterface.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof BridgeInterfaceAnnotation ) ;
                                                                  bridgeInterface = (BridgeInterfaceAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between bridgeInterface and abstraction
                                                                  JavaSDM.ensure ( bridgeInterface.hasInElements ("abstraction", abstraction) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between bridgeInterface and implementor
                                                                  JavaSDM.ensure ( bridgeInterface.hasInElements ("implementor", implementor) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object implementor is really bound
                                                               JavaSDM.ensure ( implementor != null ) ;
                                                                
                                                               // check object abstraction is really bound
                                                               JavaSDM.ensure ( abstraction != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(implementor.equals (abstraction)) ) ;
                                                                
                                                               // check object refField is really bound
                                                               JavaSDM.ensure ( refField != null ) ;
                                                                
                                                               // check object operation is really bound
                                                               JavaSDM.ensure ( operation != null ) ;
                                                                
                                                               // check object operationImpl is really bound
                                                               JavaSDM.ensure ( operationImpl != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(operation.equals (operationImpl)) ) ;
                                                                
                                                               // create object
                                                               bridgeInterface = new BridgeInterfaceAnnotation ( ) ;
                                                                
                                                               // create link
                                                               bridgeInterface.addToElements ("implementor", implementor);
                                                                
                                                               // create link
                                                               bridgeInterface.addToElements ("abstraction", abstraction);
                                                                
                                                               // create link
                                                               bridgeInterface.addToBoundObjects ("implementor", implementor);
                                                                
                                                               // create link
                                                               bridgeInterface.addToBoundObjects ("refField", refField);
                                                                
                                                               // create link
                                                               bridgeInterface.addToBoundObjects ("abstraction", abstraction);
                                                                
                                                               // create link
                                                               bridgeInterface.addToBoundObjects ("operation", operation);
                                                                
                                                               // create link
                                                               bridgeInterface.addToBoundObjects ("operationImpl", operationImpl);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object reference2 is really bound
                                                               JavaSDM.ensure ( reference2 != null ) ;
                                                                
                                                               // check object generalization3 is really bound
                                                               JavaSDM.ensure ( generalization3 != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( (set == null) || !(set.contains (generalization3)) ) ;
                                                                
                                                               // check object neighborCall4 is really bound
                                                               JavaSDM.ensure ( neighborCall4 != null ) ;
                                                                
                                                               // check object bridgeInterface is really bound
                                                               JavaSDM.ensure ( bridgeInterface != null ) ;
                                                                
                                                               // create link
                                                               bridgeInterface.addToAntecedentAnnos (reference2);
                                                                
                                                               // create link
                                                               bridgeInterface.addToAntecedentAnnos (generalization3);
                                                                
                                                               // create link
                                                               bridgeInterface.addToAntecedentAnnos (neighborCall4);
                                                                
                                                               fujaba__IterSet = set.iterator () ;
                                                               while ( fujaba__IterSet.hasNext () )
                                                               {
                                                                  fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__IterSet.next () ;
                                                                  //  create set link
                                                                  bridgeInterface.addToAntecedentAnnos (fujaba__TmpObjectGeneralizationAnnotation);
                                                                  fujaba__Success = true ;
                                                               } // while
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (bridgeInterface) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object bridgeInterface is really bound
            JavaSDM.ensure ( bridgeInterface != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("implementor", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("abstraction", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstraction = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind refField: UMLAttr
            fujaba__IterAbstractionAttrsRefField = abstraction.iteratorOfAttrs () ;
            while ( fujaba__IterAbstractionAttrsRefField.hasNext () )
            {
               try
               {
                  refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterAbstractionAttrsRefField.next () ;
                   
                  // bind operation: UMLMethod
                  fujaba__IterAbstractionMethodsOperation = abstraction.iteratorOfMethods () ;
                  while ( fujaba__IterAbstractionMethodsOperation.hasNext () )
                  {
                     try
                     {
                        operation = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAbstractionMethodsOperation.next () ;
                         
                        // bind generalization7: GeneralizationAnnotation
                        fujaba__IterAbstractionAnnotationsGeneralization7 = abstraction.iteratorOfAnnotations () ;
                        while ( fujaba__IterAbstractionAnnotationsGeneralization7.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAbstractionAnnotationsGeneralization7.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                              generalization7 = (GeneralizationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between generalization7 and abstraction
                              JavaSDM.ensure ( generalization7.hasInElements ("superClass", abstraction) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( (set == null) || !(set.contains (generalization7)) ) ;
                               
                              // bind reference6: ReferenceAnnotation
                              fujaba__IterRefFieldAnnotationsReference6 = refField.iteratorOfAnnotations () ;
                              while ( fujaba__IterRefFieldAnnotationsReference6.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterRefFieldAnnotationsReference6.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                    reference6 = (ReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between reference6 and refField
                                    JavaSDM.ensure ( reference6.hasInElements ("field", refField) ) ;
                                     
                                    // bind neighborCall8: NeighborCallAnnotation
                                    fujaba__IterOperationAnnotationsNeighborCall8 = operation.iteratorOfAnnotations () ;
                                    while ( fujaba__IterOperationAnnotationsNeighborCall8.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterOperationAnnotationsNeighborCall8.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                          neighborCall8 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between neighborCall8 and operation
                                          JavaSDM.ensure ( neighborCall8.hasInElements ("caller", operation) ) ;
                                           
                                          // bind implementor: UMLClass
                                          fujaba__IterReference6ElementsImplementor = reference6.iteratorOfElements ("references") ;
                                          while ( fujaba__IterReference6ElementsImplementor.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterReference6ElementsImplementor.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                implementor = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(abstraction.equals (implementor)) ) ;
                                                 
                                                // bind operationImpl: UMLMethod
                                                fujaba__IterNeighborCall8ElementsOperationImpl = neighborCall8.iteratorOfElements ("callee") ;
                                                while ( fujaba__IterNeighborCall8ElementsOperationImpl.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterNeighborCall8ElementsOperationImpl.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                      operationImpl = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(operation.equals (operationImpl)) ) ;
                                                       
                                                      // check To-One-Link 'parent' between operationImpl and implementor
                                                      JavaSDM.ensure ( (operationImpl.getParent () != null) && operationImpl.getParent ().equals (implementor) ) ;
                                                       
                                                      // bind uMLStereotype5: UMLStereotype
                                                      fujaba__IterImplementorStereotypesUMLStereotype5 = implementor.iteratorOfStereotypes () ;
                                                      while ( fujaba__IterImplementorStereotypesUMLStereotype5.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            uMLStereotype5 = (de.uni_paderborn.fujaba.uml.UMLStereotype) fujaba__IterImplementorStereotypesUMLStereotype5.next () ;
                                                             
                                                            // attribute condition
                                                            JavaSDM.ensure ( (JavaSDM.stringCompare (uMLStereotype5.getText (), "interface") == 0) ) ;
                                                             
                                                            // linkSearchToSetTop
                                                            set = new de.upb.tools.fca.FHashSet ( ) ;
                                                            fujaba__IterSet = abstraction.iteratorOfAnnotations () ;
                                                            while ( fujaba__IterSet.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterSet.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                                  fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  set.remove (generalization7);
                                                                  //  check link :) 'elements' between set and implementor
                                                                  JavaSDM.ensure ( fujaba__TmpObjectGeneralizationAnnotation.hasInElements (implementor) ) ;
                                                                   
                                                                  set.add (fujaba__TmpObjectGeneralizationAnnotation);
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            } // while
                                                            // constraint
                                                            JavaSDM.ensure ( set.size() == 0 ) ;
                                                             
                                                            {
                                                               //  for each flow
                                                               try
                                                               {
                                                                  fujaba__Success = false ;
                                                                   
                                                                  // check object implementor is really bound
                                                                  JavaSDM.ensure ( implementor != null ) ;
                                                                   
                                                                  // check object abstraction is really bound
                                                                  JavaSDM.ensure ( abstraction != null ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(implementor.equals (abstraction)) ) ;
                                                                   
                                                                  // bind bridgeInterface: BridgeInterfaceAnnotation
                                                                  fujaba__IterImplementorAnnotationsBridgeInterface = implementor.iteratorOfAnnotations () ;
                                                                  while ( !(fujaba__Success) && fujaba__IterImplementorAnnotationsBridgeInterface.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterImplementorAnnotationsBridgeInterface.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof BridgeInterfaceAnnotation ) ;
                                                                        bridgeInterface = (BridgeInterfaceAnnotation) fujaba__TmpObject ;
                                                                         
                                                                        // check Reverse-Qualified-Link 'elements' between bridgeInterface and implementor
                                                                        JavaSDM.ensure ( bridgeInterface.hasInElements ("implementor", implementor) ) ;
                                                                         
                                                                        // check To-Many-Link 'elements' between bridgeInterface and abstraction
                                                                        JavaSDM.ensure ( bridgeInterface.hasInElements ("abstraction", abstraction) ) ;
                                                                         
                                                                        fujaba__Success = true ;
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                                  fujaba__Success = false ;
                                                               }
                                                                
                                                               if ( !(fujaba__Success) )
                                                               {
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object implementor is really bound
                                                                     JavaSDM.ensure ( implementor != null ) ;
                                                                      
                                                                     // check object abstraction is really bound
                                                                     JavaSDM.ensure ( abstraction != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(implementor.equals (abstraction)) ) ;
                                                                      
                                                                     // check object refField is really bound
                                                                     JavaSDM.ensure ( refField != null ) ;
                                                                      
                                                                     // check object operation is really bound
                                                                     JavaSDM.ensure ( operation != null ) ;
                                                                      
                                                                     // check object operationImpl is really bound
                                                                     JavaSDM.ensure ( operationImpl != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( !(operation.equals (operationImpl)) ) ;
                                                                      
                                                                     // create object
                                                                     bridgeInterface = new BridgeInterfaceAnnotation ( ) ;
                                                                      
                                                                     // create link
                                                                     bridgeInterface.addToElements ("implementor", implementor);
                                                                      
                                                                     // create link
                                                                     bridgeInterface.addToElements ("abstraction", abstraction);
                                                                      
                                                                     // create link
                                                                     bridgeInterface.addToBoundObjects ("implementor", implementor);
                                                                      
                                                                     // create link
                                                                     bridgeInterface.addToBoundObjects ("refField", refField);
                                                                      
                                                                     // create link
                                                                     bridgeInterface.addToBoundObjects ("abstraction", abstraction);
                                                                      
                                                                     // create link
                                                                     bridgeInterface.addToBoundObjects ("operation", operation);
                                                                      
                                                                     // create link
                                                                     bridgeInterface.addToBoundObjects ("operationImpl", operationImpl);
                                                                      
                                                                     fujaba__Success = true ;
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  try
                                                                  {
                                                                     fujaba__Success = false ;
                                                                      
                                                                     // check object reference6 is really bound
                                                                     JavaSDM.ensure ( reference6 != null ) ;
                                                                      
                                                                     // check object generalization7 is really bound
                                                                     JavaSDM.ensure ( generalization7 != null ) ;
                                                                      
                                                                     // check isomorphic binding
                                                                     JavaSDM.ensure ( (set == null) || !(set.contains (generalization7)) ) ;
                                                                      
                                                                     // check object neighborCall8 is really bound
                                                                     JavaSDM.ensure ( neighborCall8 != null ) ;
                                                                      
                                                                     // check object bridgeInterface is really bound
                                                                     JavaSDM.ensure ( bridgeInterface != null ) ;
                                                                      
                                                                     // create link
                                                                     bridgeInterface.addToAntecedentAnnos (reference6);
                                                                      
                                                                     // create link
                                                                     bridgeInterface.addToAntecedentAnnos (generalization7);
                                                                      
                                                                     // create link
                                                                     bridgeInterface.addToAntecedentAnnos (neighborCall8);
                                                                      
                                                                     fujaba__IterSet = set.iterator () ;
                                                                     while ( fujaba__IterSet.hasNext () )
                                                                     {
                                                                        fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__IterSet.next () ;
                                                                        //  create set link
                                                                        bridgeInterface.addToAntecedentAnnos (fujaba__TmpObjectGeneralizationAnnotation);
                                                                        fujaba__Success = true ;
                                                                     } // while
                                                                  }
                                                                  catch ( JavaSDMException fujaba__InternalException )
                                                                  {
                                                                     fujaba__Success = false ;
                                                                  }
                                                                   
                                                                  return (bridgeInterface) ;
                                                               }
                                                            } //  end for each flow
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object bridgeInterface is really bound
            JavaSDM.ensure ( bridgeInterface != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("abstraction", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall12 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind operation: UMLMethod
            fujaba__IterNeighborCall12ElementsOperation = neighborCall12.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall12ElementsOperation.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall12ElementsOperation.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  operation = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind abstraction: UMLClass
                  abstraction = operation.getParent () ;
                  JavaSDM.ensure ( abstraction != null ) ;
                   
                  // bind operationImpl: UMLMethod
                  fujaba__IterNeighborCall12ElementsOperationImpl = neighborCall12.iteratorOfElements ("callee") ;
                  while ( fujaba__IterNeighborCall12ElementsOperationImpl.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterNeighborCall12ElementsOperationImpl.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        operationImpl = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(operation.equals (operationImpl)) ) ;
                         
                        // bind implementor: UMLClass
                        implementor = operationImpl.getParent () ;
                        JavaSDM.ensure ( implementor != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(abstraction.equals (implementor)) ) ;
                         
                        // bind refField: UMLAttr
                        fujaba__IterAbstractionAttrsRefField = abstraction.iteratorOfAttrs () ;
                        while ( fujaba__IterAbstractionAttrsRefField.hasNext () )
                        {
                           try
                           {
                              refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterAbstractionAttrsRefField.next () ;
                               
                              // bind generalization11: GeneralizationAnnotation
                              fujaba__IterAbstractionAnnotationsGeneralization11 = abstraction.iteratorOfAnnotations () ;
                              while ( fujaba__IterAbstractionAnnotationsGeneralization11.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterAbstractionAnnotationsGeneralization11.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization11 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization11 and abstraction
                                    JavaSDM.ensure ( generalization11.hasInElements ("superClass", abstraction) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( (set == null) || !(set.contains (generalization11)) ) ;
                                     
                                    // bind uMLStereotype9: UMLStereotype
                                    fujaba__IterImplementorStereotypesUMLStereotype9 = implementor.iteratorOfStereotypes () ;
                                    while ( fujaba__IterImplementorStereotypesUMLStereotype9.hasNext () )
                                    {
                                       try
                                       {
                                          uMLStereotype9 = (de.uni_paderborn.fujaba.uml.UMLStereotype) fujaba__IterImplementorStereotypesUMLStereotype9.next () ;
                                           
                                          // attribute condition
                                          JavaSDM.ensure ( (JavaSDM.stringCompare (uMLStereotype9.getText (), "interface") == 0) ) ;
                                           
                                          // bind reference10: ReferenceAnnotation
                                          fujaba__IterImplementorAnnotationsReference10 = implementor.iteratorOfAnnotations () ;
                                          while ( fujaba__IterImplementorAnnotationsReference10.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterImplementorAnnotationsReference10.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                                reference10 = (ReferenceAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between reference10 and implementor
                                                JavaSDM.ensure ( reference10.hasInElements ("references", implementor) ) ;
                                                 
                                                // check To-Many-Link 'elements' between reference10 and refField
                                                JavaSDM.ensure ( reference10.hasInElements ("field", refField) ) ;
                                                 
                                                // linkSearchToSetTop
                                                set = new de.upb.tools.fca.FHashSet ( ) ;
                                                fujaba__IterSet = abstraction.iteratorOfAnnotations () ;
                                                while ( fujaba__IterSet.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterSet.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                      fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                       
                                                      set.remove (generalization11);
                                                      //  check link :) 'elements' between set and implementor
                                                      JavaSDM.ensure ( fujaba__TmpObjectGeneralizationAnnotation.hasInElements (implementor) ) ;
                                                       
                                                      set.add (fujaba__TmpObjectGeneralizationAnnotation);
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                } // while
                                                // constraint
                                                JavaSDM.ensure ( set.size() == 0 ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object implementor is really bound
                                                      JavaSDM.ensure ( implementor != null ) ;
                                                       
                                                      // check object abstraction is really bound
                                                      JavaSDM.ensure ( abstraction != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(implementor.equals (abstraction)) ) ;
                                                       
                                                      // bind bridgeInterface: BridgeInterfaceAnnotation
                                                      fujaba__IterAbstractionAnnotationsBridgeInterface = abstraction.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterAbstractionAnnotationsBridgeInterface.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterAbstractionAnnotationsBridgeInterface.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof BridgeInterfaceAnnotation ) ;
                                                            bridgeInterface = (BridgeInterfaceAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between bridgeInterface and abstraction
                                                            JavaSDM.ensure ( bridgeInterface.hasInElements ("abstraction", abstraction) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between bridgeInterface and implementor
                                                            JavaSDM.ensure ( bridgeInterface.hasInElements ("implementor", implementor) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object implementor is really bound
                                                         JavaSDM.ensure ( implementor != null ) ;
                                                          
                                                         // check object abstraction is really bound
                                                         JavaSDM.ensure ( abstraction != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(implementor.equals (abstraction)) ) ;
                                                          
                                                         // check object refField is really bound
                                                         JavaSDM.ensure ( refField != null ) ;
                                                          
                                                         // check object operation is really bound
                                                         JavaSDM.ensure ( operation != null ) ;
                                                          
                                                         // check object operationImpl is really bound
                                                         JavaSDM.ensure ( operationImpl != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(operation.equals (operationImpl)) ) ;
                                                          
                                                         // create object
                                                         bridgeInterface = new BridgeInterfaceAnnotation ( ) ;
                                                          
                                                         // create link
                                                         bridgeInterface.addToElements ("implementor", implementor);
                                                          
                                                         // create link
                                                         bridgeInterface.addToElements ("abstraction", abstraction);
                                                          
                                                         // create link
                                                         bridgeInterface.addToBoundObjects ("implementor", implementor);
                                                          
                                                         // create link
                                                         bridgeInterface.addToBoundObjects ("refField", refField);
                                                          
                                                         // create link
                                                         bridgeInterface.addToBoundObjects ("abstraction", abstraction);
                                                          
                                                         // create link
                                                         bridgeInterface.addToBoundObjects ("operation", operation);
                                                          
                                                         // create link
                                                         bridgeInterface.addToBoundObjects ("operationImpl", operationImpl);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object reference10 is really bound
                                                         JavaSDM.ensure ( reference10 != null ) ;
                                                          
                                                         // check object generalization11 is really bound
                                                         JavaSDM.ensure ( generalization11 != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( (set == null) || !(set.contains (generalization11)) ) ;
                                                          
                                                         // check object neighborCall12 is really bound
                                                         JavaSDM.ensure ( neighborCall12 != null ) ;
                                                          
                                                         // check object bridgeInterface is really bound
                                                         JavaSDM.ensure ( bridgeInterface != null ) ;
                                                          
                                                         // create link
                                                         bridgeInterface.addToAntecedentAnnos (reference10);
                                                          
                                                         // create link
                                                         bridgeInterface.addToAntecedentAnnos (generalization11);
                                                          
                                                         // create link
                                                         bridgeInterface.addToAntecedentAnnos (neighborCall12);
                                                          
                                                         fujaba__IterSet = set.iterator () ;
                                                         while ( fujaba__IterSet.hasNext () )
                                                         {
                                                            fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__IterSet.next () ;
                                                            //  create set link
                                                            bridgeInterface.addToAntecedentAnnos (fujaba__TmpObjectGeneralizationAnnotation);
                                                            fujaba__Success = true ;
                                                         } // while
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (bridgeInterface) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object bridgeInterface is really bound
            JavaSDM.ensure ( bridgeInterface != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (bridgeInterface) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("implementor", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("abstraction", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAbstractionAttrsRefField = null ;
      Iterator fujaba__IterImplementorMethodsOperationImpl = null ;
      Iterator fujaba__IterNeighborCall12ElementsOperation = null ;
      Iterator fujaba__IterNeighborCall13ElementsOperation = null ;
      Iterator fujaba__IterOperationImplAnnotationsNeighborCall13 = null ;
      Iterator fujaba__IterRefFieldAnnotationsReference14 = null ;
      Iterator fujaba__IterReference14ElementsImplementor = null ;
      NeighborCallAnnotation neighborCall12 = null ;
      NeighborCallAnnotation neighborCall13 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference14 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr refField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass abstraction = null ;
      de.uni_paderborn.fujaba.uml.UMLClass implementor = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod operation = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod operationImpl = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            implementor = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (implementor);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstraction = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (abstraction);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall12 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind operation: UMLMethod
            fujaba__IterNeighborCall12ElementsOperation = neighborCall12.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall12ElementsOperation.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall12ElementsOperation.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  operation = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind abstraction: UMLClass
                  abstraction = operation.getParent () ;
                  JavaSDM.ensure ( abstraction != null ) ;
                   
                  {
                     //  for each flow
                     set.add (abstraction);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Reference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            implementor = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (implementor);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstraction = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind refField: UMLAttr
            fujaba__IterAbstractionAttrsRefField = abstraction.iteratorOfAttrs () ;
            while ( fujaba__IterAbstractionAttrsRefField.hasNext () )
            {
               try
               {
                  refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterAbstractionAttrsRefField.next () ;
                   
                  {
                     //  for each flow
                     set.add (refField);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall12 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind operation: UMLMethod
            fujaba__IterNeighborCall12ElementsOperation = neighborCall12.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall12ElementsOperation.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall12ElementsOperation.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  operation = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind abstraction: UMLClass
                  abstraction = operation.getParent () ;
                  JavaSDM.ensure ( abstraction != null ) ;
                   
                  // bind refField: UMLAttr
                  fujaba__IterAbstractionAttrsRefField = abstraction.iteratorOfAttrs () ;
                  while ( fujaba__IterAbstractionAttrsRefField.hasNext () )
                  {
                     try
                     {
                        refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterAbstractionAttrsRefField.next () ;
                         
                        {
                           //  for each flow
                           set.add (refField);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            implementor = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind operationImpl: UMLMethod
            fujaba__IterImplementorMethodsOperationImpl = implementor.iteratorOfMethods () ;
            while ( fujaba__IterImplementorMethodsOperationImpl.hasNext () )
            {
               try
               {
                  operationImpl = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterImplementorMethodsOperationImpl.next () ;
                   
                  // bind neighborCall13: NeighborCallAnnotation
                  fujaba__IterOperationImplAnnotationsNeighborCall13 = operationImpl.iteratorOfAnnotations () ;
                  while ( fujaba__IterOperationImplAnnotationsNeighborCall13.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterOperationImplAnnotationsNeighborCall13.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall13 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall13 and operationImpl
                        JavaSDM.ensure ( neighborCall13.hasInElements ("callee", operationImpl) ) ;
                         
                        // bind operation: UMLMethod
                        fujaba__IterNeighborCall13ElementsOperation = neighborCall13.iteratorOfElements ("caller") ;
                        while ( fujaba__IterNeighborCall13ElementsOperation.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall13ElementsOperation.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              operation = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(operationImpl.equals (operation)) ) ;
                               
                              // bind abstraction: UMLClass
                              abstraction = operation.getParent () ;
                              JavaSDM.ensure ( abstraction != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(implementor.equals (abstraction)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (abstraction);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstraction = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (abstraction);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall13 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind operation: UMLMethod
            fujaba__IterNeighborCall13ElementsOperation = neighborCall13.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall13ElementsOperation.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall13ElementsOperation.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  operation = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind abstraction: UMLClass
                  abstraction = operation.getParent () ;
                  JavaSDM.ensure ( abstraction != null ) ;
                   
                  {
                     //  for each flow
                     set.add (abstraction);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("NeighborCall") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            implementor = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind operationImpl: UMLMethod
            fujaba__IterImplementorMethodsOperationImpl = implementor.iteratorOfMethods () ;
            while ( fujaba__IterImplementorMethodsOperationImpl.hasNext () )
            {
               try
               {
                  operationImpl = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterImplementorMethodsOperationImpl.next () ;
                   
                  {
                     //  for each flow
                     set.add (operationImpl);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstraction = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind refField: UMLAttr
            fujaba__IterAbstractionAttrsRefField = abstraction.iteratorOfAttrs () ;
            while ( fujaba__IterAbstractionAttrsRefField.hasNext () )
            {
               try
               {
                  refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterAbstractionAttrsRefField.next () ;
                   
                  // bind reference14: ReferenceAnnotation
                  fujaba__IterRefFieldAnnotationsReference14 = refField.iteratorOfAnnotations () ;
                  while ( fujaba__IterRefFieldAnnotationsReference14.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterRefFieldAnnotationsReference14.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                        reference14 = (ReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between reference14 and refField
                        JavaSDM.ensure ( reference14.hasInElements ("field", refField) ) ;
                         
                        // bind implementor: UMLClass
                        fujaba__IterReference14ElementsImplementor = reference14.iteratorOfElements ("references") ;
                        while ( fujaba__IterReference14ElementsImplementor.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReference14ElementsImplementor.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              implementor = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(abstraction.equals (implementor)) ) ;
                               
                              // bind operationImpl: UMLMethod
                              fujaba__IterImplementorMethodsOperationImpl = implementor.iteratorOfMethods () ;
                              while ( fujaba__IterImplementorMethodsOperationImpl.hasNext () )
                              {
                                 try
                                 {
                                    operationImpl = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterImplementorMethodsOperationImpl.next () ;
                                     
                                    {
                                       //  for each flow
                                       set.add (operationImpl);
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
