package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLMethod;

public class ChainOfResponsibilityEngine
extends GFRNEngine
{
   private  ChainOfResponsibilityEngine()
   {
   }

   private static ChainOfResponsibilityEngine theChainOfResponsibilityEngine;

   public static ChainOfResponsibilityEngine get()
   {
      if (theChainOfResponsibilityEngine == null)
      {
         theChainOfResponsibilityEngine = new ChainOfResponsibilityEngine ();
      }
      return theChainOfResponsibilityEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ChainOfResponsibilityAnnotation chainOfResponsibility = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsNeighborCall14 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsNeighborCall4 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsNeighborCall7 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod12 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod13 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod5 = null ;
      Iterator fujaba__IterAbstractHandleAnnotationsOverridingMethod6 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsGeneralization1 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsGeneralization2 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsGeneralization8 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsGeneralization9 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsReference10 = null ;
      Iterator fujaba__IterAbstractHandlerAnnotationsReference3 = null ;
      Iterator fujaba__IterAbstractHandlerMethodsAbstractHandle = null ;
      Iterator fujaba__IterGeneralization1ElementsConcreteHandler2 = null ;
      Iterator fujaba__IterGeneralization2ElementsConcreteHandler1 = null ;
      Iterator fujaba__IterNeighborCall11ElementsAbstractHandle = null ;
      Iterator fujaba__IterNeighborCall11ElementsConcreteHandle2 = null ;
      Iterator fujaba__IterNeighborCall4ElementsConcreteHandle2 = null ;
      Iterator fujaba__IterOverridingMethod13ElementsConcreteHandle1 = null ;
      Iterator fujaba__IterOverridingMethod6ElementsConcreteHandle1 = null ;
      GeneralizationAnnotation generalization1 = null ;
      GeneralizationAnnotation generalization2 = null ;
      GeneralizationAnnotation generalization8 = null ;
      GeneralizationAnnotation generalization9 = null ;
      NeighborCallAnnotation neighborCall11 = null ;
      NeighborCallAnnotation neighborCall14 = null ;
      NeighborCallAnnotation neighborCall4 = null ;
      NeighborCallAnnotation neighborCall7 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod12 = null ;
      OverridingMethodAnnotation overridingMethod13 = null ;
      OverridingMethodAnnotation overridingMethod5 = null ;
      OverridingMethodAnnotation overridingMethod6 = null ;
      ReferenceAnnotation reference10 = null ;
      ReferenceAnnotation reference3 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass abstractHandler = null ;
      de.uni_paderborn.fujaba.uml.UMLClass concreteHandler1 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass concreteHandler2 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod abstractHandle = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod concreteHandle1 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod concreteHandle2 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("handler", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractHandler = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // attribute condition
            JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
            while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
            {
               try
               {
                  abstractHandle = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  // bind generalization2: GeneralizationAnnotation
                  fujaba__IterAbstractHandlerAnnotationsGeneralization2 = abstractHandler.iteratorOfAnnotations () ;
                  while ( fujaba__IterAbstractHandlerAnnotationsGeneralization2.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsGeneralization2.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization2 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization2 and abstractHandler
                        JavaSDM.ensure ( generalization2.hasInElements ("superClass", abstractHandler) ) ;
                         
                        // bind generalization1: GeneralizationAnnotation
                        fujaba__IterAbstractHandlerAnnotationsGeneralization1 = abstractHandler.iteratorOfAnnotations () ;
                        while ( fujaba__IterAbstractHandlerAnnotationsGeneralization1.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsGeneralization1.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                              generalization1 = (GeneralizationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between generalization1 and abstractHandler
                              JavaSDM.ensure ( generalization1.hasInElements ("superClass", abstractHandler) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(generalization2.equals (generalization1)) ) ;
                               
                              // bind reference3: ReferenceAnnotation
                              fujaba__IterAbstractHandlerAnnotationsReference3 = abstractHandler.iteratorOfAnnotations () ;
                              while ( fujaba__IterAbstractHandlerAnnotationsReference3.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsReference3.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                    reference3 = (ReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between reference3 and abstractHandler
                                    JavaSDM.ensure ( reference3.hasInElements ("references", abstractHandler) ) ;
                                     
                                    // check To-Many-Link 'elements' between reference3 and abstractHandler
                                    JavaSDM.ensure ( reference3.hasInElements ("referencingClass", abstractHandler) ) ;
                                     
                                    // bind neighborCall4: NeighborCallAnnotation
                                    fujaba__IterAbstractHandleAnnotationsNeighborCall4 = abstractHandle.iteratorOfAnnotations () ;
                                    while ( fujaba__IterAbstractHandleAnnotationsNeighborCall4.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsNeighborCall4.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                          neighborCall4 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between neighborCall4 and abstractHandle
                                          JavaSDM.ensure ( neighborCall4.hasInElements ("callee", abstractHandle) ) ;
                                           
                                          // bind overridingMethod5: OverridingMethodAnnotation
                                          fujaba__IterAbstractHandleAnnotationsOverridingMethod5 = abstractHandle.iteratorOfAnnotations () ;
                                          while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod5.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod5.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                                overridingMethod5 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between overridingMethod5 and abstractHandle
                                                JavaSDM.ensure ( overridingMethod5.hasInElements ("overridden", abstractHandle) ) ;
                                                 
                                                // bind overridingMethod6: OverridingMethodAnnotation
                                                fujaba__IterAbstractHandleAnnotationsOverridingMethod6 = abstractHandle.iteratorOfAnnotations () ;
                                                while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod6.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod6.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                                      overridingMethod6 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between overridingMethod6 and abstractHandle
                                                      JavaSDM.ensure ( overridingMethod6.hasInElements ("overridden", abstractHandle) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(overridingMethod5.equals (overridingMethod6)) ) ;
                                                       
                                                      // bind neighborCall7: NeighborCallAnnotation
                                                      fujaba__IterAbstractHandleAnnotationsNeighborCall7 = abstractHandle.iteratorOfAnnotations () ;
                                                      while ( fujaba__IterAbstractHandleAnnotationsNeighborCall7.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsNeighborCall7.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                            neighborCall7 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between neighborCall7 and abstractHandle
                                                            JavaSDM.ensure ( neighborCall7.hasInElements ("callee", abstractHandle) ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(neighborCall4.equals (neighborCall7)) ) ;
                                                             
                                                            // bind concreteHandler1: UMLClass
                                                            fujaba__IterGeneralization2ElementsConcreteHandler1 = generalization2.iteratorOfElements ("subClass") ;
                                                            while ( fujaba__IterGeneralization2ElementsConcreteHandler1.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterGeneralization2ElementsConcreteHandler1.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                                  concreteHandler1 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                                                   
                                                                  // attribute condition
                                                                  JavaSDM.ensure ( (concreteHandler1.isAbstract () == false) ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler1)) ) ;
                                                                   
                                                                  // bind concreteHandler2: UMLClass
                                                                  fujaba__IterGeneralization1ElementsConcreteHandler2 = generalization1.iteratorOfElements ("subClass") ;
                                                                  while ( fujaba__IterGeneralization1ElementsConcreteHandler2.hasNext () )
                                                                  {
                                                                     try
                                                                     {
                                                                        fujaba__TmpObject = fujaba__IterGeneralization1ElementsConcreteHandler2.next () ;
                                                                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                                        concreteHandler2 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                                                         
                                                                        // attribute condition
                                                                        JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                                                                         
                                                                        // check isomorphic binding
                                                                        JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler2)) && !(concreteHandler1.equals (concreteHandler2)) ) ;
                                                                         
                                                                        // bind concreteHandle2: UMLMethod
                                                                        fujaba__IterNeighborCall4ElementsConcreteHandle2 = neighborCall4.iteratorOfElements ("caller") ;
                                                                        while ( fujaba__IterNeighborCall4ElementsConcreteHandle2.hasNext () )
                                                                        {
                                                                           try
                                                                           {
                                                                              fujaba__TmpObject = fujaba__IterNeighborCall4ElementsConcreteHandle2.next () ;
                                                                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                                              concreteHandle2 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                                               
                                                                              // attribute condition
                                                                              JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                                                                               
                                                                              // check isomorphic binding
                                                                              JavaSDM.ensure ( !(abstractHandle.equals (concreteHandle2)) ) ;
                                                                               
                                                                              // check To-Many-Link 'elements' between overridingMethod5 and concreteHandle2
                                                                              JavaSDM.ensure ( overridingMethod5.hasInElements ("overriding", concreteHandle2) ) ;
                                                                               
                                                                              // check To-One-Link 'parent' between concreteHandle2 and concreteHandler2
                                                                              JavaSDM.ensure ( (concreteHandle2.getParent () != null) && concreteHandle2.getParent ().equals (concreteHandler2) ) ;
                                                                               
                                                                              // bind concreteHandle1: UMLMethod
                                                                              fujaba__IterOverridingMethod6ElementsConcreteHandle1 = overridingMethod6.iteratorOfElements ("overriding") ;
                                                                              while ( fujaba__IterOverridingMethod6ElementsConcreteHandle1.hasNext () )
                                                                              {
                                                                                 try
                                                                                 {
                                                                                    fujaba__TmpObject = fujaba__IterOverridingMethod6ElementsConcreteHandle1.next () ;
                                                                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                                                    concreteHandle1 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                                                     
                                                                                    // attribute condition
                                                                                    JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                                                                                     
                                                                                    // check isomorphic binding
                                                                                    JavaSDM.ensure ( !(abstractHandle.equals (concreteHandle1)) && !(concreteHandle2.equals (concreteHandle1)) ) ;
                                                                                     
                                                                                    // check To-Many-Link 'elements' between neighborCall7 and concreteHandle1
                                                                                    JavaSDM.ensure ( neighborCall7.hasInElements ("caller", concreteHandle1) ) ;
                                                                                     
                                                                                    // check To-One-Link 'parent' between concreteHandle1 and concreteHandler1
                                                                                    JavaSDM.ensure ( (concreteHandle1.getParent () != null) && concreteHandle1.getParent ().equals (concreteHandler1) ) ;
                                                                                     
                                                                                    {
                                                                                       //  for each flow
                                                                                       try
                                                                                       {
                                                                                          fujaba__Success = false ;
                                                                                           
                                                                                          // check object abstractHandler is really bound
                                                                                          JavaSDM.ensure ( abstractHandler != null ) ;
                                                                                           
                                                                                          // bind chainOfResponsibility: ChainOfResponsibilityAnnotation
                                                                                          fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility = abstractHandler.iteratorOfAnnotations () ;
                                                                                          while ( !(fujaba__Success) && fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility.hasNext () )
                                                                                          {
                                                                                             try
                                                                                             {
                                                                                                fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility.next () ;
                                                                                                JavaSDM.ensure ( fujaba__TmpObject instanceof ChainOfResponsibilityAnnotation ) ;
                                                                                                chainOfResponsibility = (ChainOfResponsibilityAnnotation) fujaba__TmpObject ;
                                                                                                 
                                                                                                // check Reverse-Qualified-Link 'elements' between chainOfResponsibility and abstractHandler
                                                                                                JavaSDM.ensure ( chainOfResponsibility.hasInElements ("handler", abstractHandler) ) ;
                                                                                                 
                                                                                                fujaba__Success = true ;
                                                                                             }
                                                                                             catch ( JavaSDMException fujaba__InternalException )
                                                                                             {
                                                                                             }
                                                                                          }
                                                                                       }
                                                                                       catch ( JavaSDMException fujaba__InternalException )
                                                                                       {
                                                                                          fujaba__Success = false ;
                                                                                       }
                                                                                        
                                                                                       if ( !(fujaba__Success) )
                                                                                       {
                                                                                          try
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                              
                                                                                             // check object abstractHandler is really bound
                                                                                             JavaSDM.ensure ( abstractHandler != null ) ;
                                                                                              
                                                                                             // check object abstractHandle is really bound
                                                                                             JavaSDM.ensure ( abstractHandle != null ) ;
                                                                                              
                                                                                             // check object concreteHandle2 is really bound
                                                                                             JavaSDM.ensure ( concreteHandle2 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(abstractHandle.equals (concreteHandle2)) ) ;
                                                                                              
                                                                                             // check object concreteHandle1 is really bound
                                                                                             JavaSDM.ensure ( concreteHandle1 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(abstractHandle.equals (concreteHandle1)) && !(concreteHandle2.equals (concreteHandle1)) ) ;
                                                                                              
                                                                                             // check object concreteHandler1 is really bound
                                                                                             JavaSDM.ensure ( concreteHandler1 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler1)) ) ;
                                                                                              
                                                                                             // check object concreteHandler2 is really bound
                                                                                             JavaSDM.ensure ( concreteHandler2 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler2)) && !(concreteHandler1.equals (concreteHandler2)) ) ;
                                                                                              
                                                                                             // create object
                                                                                             chainOfResponsibility = new ChainOfResponsibilityAnnotation ( ) ;
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToElements ("handler", abstractHandler);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("abstractHandler", abstractHandler);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("abstractHandle", abstractHandle);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("concreteHandle2", concreteHandle2);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("concreteHandle1", concreteHandle1);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("concreteHandler1", concreteHandler1);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToBoundObjects ("concreteHandler2", concreteHandler2);
                                                                                              
                                                                                             fujaba__Success = true ;
                                                                                          }
                                                                                          catch ( JavaSDMException fujaba__InternalException )
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                          }
                                                                                           
                                                                                          try
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                              
                                                                                             // check object generalization1 is really bound
                                                                                             JavaSDM.ensure ( generalization1 != null ) ;
                                                                                              
                                                                                             // check object generalization2 is really bound
                                                                                             JavaSDM.ensure ( generalization2 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(generalization1.equals (generalization2)) ) ;
                                                                                              
                                                                                             // check object reference3 is really bound
                                                                                             JavaSDM.ensure ( reference3 != null ) ;
                                                                                              
                                                                                             // check object neighborCall4 is really bound
                                                                                             JavaSDM.ensure ( neighborCall4 != null ) ;
                                                                                              
                                                                                             // check object overridingMethod5 is really bound
                                                                                             JavaSDM.ensure ( overridingMethod5 != null ) ;
                                                                                              
                                                                                             // check object overridingMethod6 is really bound
                                                                                             JavaSDM.ensure ( overridingMethod6 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(overridingMethod5.equals (overridingMethod6)) ) ;
                                                                                              
                                                                                             // check object neighborCall7 is really bound
                                                                                             JavaSDM.ensure ( neighborCall7 != null ) ;
                                                                                              
                                                                                             // check isomorphic binding
                                                                                             JavaSDM.ensure ( !(neighborCall4.equals (neighborCall7)) ) ;
                                                                                              
                                                                                             // check object chainOfResponsibility is really bound
                                                                                             JavaSDM.ensure ( chainOfResponsibility != null ) ;
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (generalization1);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (generalization2);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (reference3);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (neighborCall4);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (overridingMethod5);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (overridingMethod6);
                                                                                              
                                                                                             // create link
                                                                                             chainOfResponsibility.addToAntecedentAnnos (neighborCall7);
                                                                                              
                                                                                             fujaba__Success = true ;
                                                                                          }
                                                                                          catch ( JavaSDMException fujaba__InternalException )
                                                                                          {
                                                                                             fujaba__Success = false ;
                                                                                          }
                                                                                           
                                                                                          return (chainOfResponsibility) ;
                                                                                       }
                                                                                    } //  end for each flow
                                                                                 }
                                                                                 catch ( JavaSDMException fujaba__InternalException )
                                                                                 {
                                                                                 }
                                                                              }
                                                                           }
                                                                           catch ( JavaSDMException fujaba__InternalException )
                                                                           {
                                                                           }
                                                                        }
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                     }
                                                                  }
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object chainOfResponsibility is really bound
            JavaSDM.ensure ( chainOfResponsibility != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("handler", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall11 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterNeighborCall11ElementsAbstractHandle = neighborCall11.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall11ElementsAbstractHandle.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall11ElementsAbstractHandle.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  abstractHandle = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  // bind abstractHandler: UMLClass
                  abstractHandler = abstractHandle.getParent () ;
                  JavaSDM.ensure ( abstractHandler != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  // bind concreteHandle2: UMLMethod
                  fujaba__IterNeighborCall11ElementsConcreteHandle2 = neighborCall11.iteratorOfElements ("caller") ;
                  while ( fujaba__IterNeighborCall11ElementsConcreteHandle2.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterNeighborCall11ElementsConcreteHandle2.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        concreteHandle2 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (concreteHandle2.isAbstract () == false) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(abstractHandle.equals (concreteHandle2)) ) ;
                         
                        // bind concreteHandler2: UMLClass
                        concreteHandler2 = concreteHandle2.getParent () ;
                        JavaSDM.ensure ( concreteHandler2 != null ) ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (concreteHandler2.isAbstract () == false) ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler2)) ) ;
                         
                        // bind overridingMethod12: OverridingMethodAnnotation
                        fujaba__IterAbstractHandleAnnotationsOverridingMethod12 = abstractHandle.iteratorOfAnnotations () ;
                        while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod12.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod12.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                              overridingMethod12 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between overridingMethod12 and abstractHandle
                              JavaSDM.ensure ( overridingMethod12.hasInElements ("overridden", abstractHandle) ) ;
                               
                              // check To-Many-Link 'elements' between overridingMethod12 and concreteHandle2
                              JavaSDM.ensure ( overridingMethod12.hasInElements ("overriding", concreteHandle2) ) ;
                               
                              // bind overridingMethod13: OverridingMethodAnnotation
                              fujaba__IterAbstractHandleAnnotationsOverridingMethod13 = abstractHandle.iteratorOfAnnotations () ;
                              while ( fujaba__IterAbstractHandleAnnotationsOverridingMethod13.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsOverridingMethod13.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                    overridingMethod13 = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between overridingMethod13 and abstractHandle
                                    JavaSDM.ensure ( overridingMethod13.hasInElements ("overridden", abstractHandle) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(overridingMethod12.equals (overridingMethod13)) ) ;
                                     
                                    // bind neighborCall14: NeighborCallAnnotation
                                    fujaba__IterAbstractHandleAnnotationsNeighborCall14 = abstractHandle.iteratorOfAnnotations () ;
                                    while ( fujaba__IterAbstractHandleAnnotationsNeighborCall14.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAbstractHandleAnnotationsNeighborCall14.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                          neighborCall14 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between neighborCall14 and abstractHandle
                                          JavaSDM.ensure ( neighborCall14.hasInElements ("callee", abstractHandle) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(neighborCall11.equals (neighborCall14)) ) ;
                                           
                                          // bind generalization9: GeneralizationAnnotation
                                          fujaba__IterAbstractHandlerAnnotationsGeneralization9 = abstractHandler.iteratorOfAnnotations () ;
                                          while ( fujaba__IterAbstractHandlerAnnotationsGeneralization9.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsGeneralization9.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                generalization9 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between generalization9 and abstractHandler
                                                JavaSDM.ensure ( generalization9.hasInElements ("superClass", abstractHandler) ) ;
                                                 
                                                // bind generalization8: GeneralizationAnnotation
                                                fujaba__IterAbstractHandlerAnnotationsGeneralization8 = abstractHandler.iteratorOfAnnotations () ;
                                                while ( fujaba__IterAbstractHandlerAnnotationsGeneralization8.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsGeneralization8.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                      generalization8 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between generalization8 and abstractHandler
                                                      JavaSDM.ensure ( generalization8.hasInElements ("superClass", abstractHandler) ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(generalization9.equals (generalization8)) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between generalization8 and concreteHandler2
                                                      JavaSDM.ensure ( generalization8.hasInElements ("subClass", concreteHandler2) ) ;
                                                       
                                                      // bind reference10: ReferenceAnnotation
                                                      fujaba__IterAbstractHandlerAnnotationsReference10 = abstractHandler.iteratorOfAnnotations () ;
                                                      while ( fujaba__IterAbstractHandlerAnnotationsReference10.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsReference10.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                                            reference10 = (ReferenceAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between reference10 and abstractHandler
                                                            JavaSDM.ensure ( reference10.hasInElements ("references", abstractHandler) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between reference10 and abstractHandler
                                                            JavaSDM.ensure ( reference10.hasInElements ("referencingClass", abstractHandler) ) ;
                                                             
                                                            // bind concreteHandle1: UMLMethod
                                                            fujaba__IterOverridingMethod13ElementsConcreteHandle1 = overridingMethod13.iteratorOfElements ("overriding") ;
                                                            while ( fujaba__IterOverridingMethod13ElementsConcreteHandle1.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterOverridingMethod13ElementsConcreteHandle1.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                                  concreteHandle1 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                                   
                                                                  // attribute condition
                                                                  JavaSDM.ensure ( (concreteHandle1.isAbstract () == false) ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(abstractHandle.equals (concreteHandle1)) && !(concreteHandle2.equals (concreteHandle1)) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between neighborCall14 and concreteHandle1
                                                                  JavaSDM.ensure ( neighborCall14.hasInElements ("caller", concreteHandle1) ) ;
                                                                   
                                                                  // bind concreteHandler1: UMLClass
                                                                  concreteHandler1 = concreteHandle1.getParent () ;
                                                                  JavaSDM.ensure ( concreteHandler1 != null ) ;
                                                                   
                                                                  // attribute condition
                                                                  JavaSDM.ensure ( (concreteHandler1.isAbstract () == false) ) ;
                                                                   
                                                                  // check isomorphic binding
                                                                  JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler1)) && !(concreteHandler2.equals (concreteHandler1)) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between generalization9 and concreteHandler1
                                                                  JavaSDM.ensure ( generalization9.hasInElements ("subClass", concreteHandler1) ) ;
                                                                   
                                                                  {
                                                                     //  for each flow
                                                                     try
                                                                     {
                                                                        fujaba__Success = false ;
                                                                         
                                                                        // check object abstractHandler is really bound
                                                                        JavaSDM.ensure ( abstractHandler != null ) ;
                                                                         
                                                                        // bind chainOfResponsibility: ChainOfResponsibilityAnnotation
                                                                        fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility = abstractHandler.iteratorOfAnnotations () ;
                                                                        while ( !(fujaba__Success) && fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility.hasNext () )
                                                                        {
                                                                           try
                                                                           {
                                                                              fujaba__TmpObject = fujaba__IterAbstractHandlerAnnotationsChainOfResponsibility.next () ;
                                                                              JavaSDM.ensure ( fujaba__TmpObject instanceof ChainOfResponsibilityAnnotation ) ;
                                                                              chainOfResponsibility = (ChainOfResponsibilityAnnotation) fujaba__TmpObject ;
                                                                               
                                                                              // check Reverse-Qualified-Link 'elements' between chainOfResponsibility and abstractHandler
                                                                              JavaSDM.ensure ( chainOfResponsibility.hasInElements ("handler", abstractHandler) ) ;
                                                                               
                                                                              fujaba__Success = true ;
                                                                           }
                                                                           catch ( JavaSDMException fujaba__InternalException )
                                                                           {
                                                                           }
                                                                        }
                                                                     }
                                                                     catch ( JavaSDMException fujaba__InternalException )
                                                                     {
                                                                        fujaba__Success = false ;
                                                                     }
                                                                      
                                                                     if ( !(fujaba__Success) )
                                                                     {
                                                                        try
                                                                        {
                                                                           fujaba__Success = false ;
                                                                            
                                                                           // check object abstractHandler is really bound
                                                                           JavaSDM.ensure ( abstractHandler != null ) ;
                                                                            
                                                                           // check object abstractHandle is really bound
                                                                           JavaSDM.ensure ( abstractHandle != null ) ;
                                                                            
                                                                           // check object concreteHandle2 is really bound
                                                                           JavaSDM.ensure ( concreteHandle2 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(abstractHandle.equals (concreteHandle2)) ) ;
                                                                            
                                                                           // check object concreteHandle1 is really bound
                                                                           JavaSDM.ensure ( concreteHandle1 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(abstractHandle.equals (concreteHandle1)) && !(concreteHandle2.equals (concreteHandle1)) ) ;
                                                                            
                                                                           // check object concreteHandler1 is really bound
                                                                           JavaSDM.ensure ( concreteHandler1 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler1)) ) ;
                                                                            
                                                                           // check object concreteHandler2 is really bound
                                                                           JavaSDM.ensure ( concreteHandler2 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(abstractHandler.equals (concreteHandler2)) && !(concreteHandler1.equals (concreteHandler2)) ) ;
                                                                            
                                                                           // create object
                                                                           chainOfResponsibility = new ChainOfResponsibilityAnnotation ( ) ;
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToElements ("handler", abstractHandler);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("abstractHandler", abstractHandler);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("abstractHandle", abstractHandle);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("concreteHandle2", concreteHandle2);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("concreteHandle1", concreteHandle1);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("concreteHandler1", concreteHandler1);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToBoundObjects ("concreteHandler2", concreteHandler2);
                                                                            
                                                                           fujaba__Success = true ;
                                                                        }
                                                                        catch ( JavaSDMException fujaba__InternalException )
                                                                        {
                                                                           fujaba__Success = false ;
                                                                        }
                                                                         
                                                                        try
                                                                        {
                                                                           fujaba__Success = false ;
                                                                            
                                                                           // check object generalization8 is really bound
                                                                           JavaSDM.ensure ( generalization8 != null ) ;
                                                                            
                                                                           // check object generalization9 is really bound
                                                                           JavaSDM.ensure ( generalization9 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(generalization8.equals (generalization9)) ) ;
                                                                            
                                                                           // check object reference10 is really bound
                                                                           JavaSDM.ensure ( reference10 != null ) ;
                                                                            
                                                                           // check object neighborCall11 is really bound
                                                                           JavaSDM.ensure ( neighborCall11 != null ) ;
                                                                            
                                                                           // check object overridingMethod12 is really bound
                                                                           JavaSDM.ensure ( overridingMethod12 != null ) ;
                                                                            
                                                                           // check object overridingMethod13 is really bound
                                                                           JavaSDM.ensure ( overridingMethod13 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(overridingMethod12.equals (overridingMethod13)) ) ;
                                                                            
                                                                           // check object neighborCall14 is really bound
                                                                           JavaSDM.ensure ( neighborCall14 != null ) ;
                                                                            
                                                                           // check isomorphic binding
                                                                           JavaSDM.ensure ( !(neighborCall11.equals (neighborCall14)) ) ;
                                                                            
                                                                           // check object chainOfResponsibility is really bound
                                                                           JavaSDM.ensure ( chainOfResponsibility != null ) ;
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (generalization8);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (generalization9);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (reference10);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (neighborCall11);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (overridingMethod12);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (overridingMethod13);
                                                                            
                                                                           // create link
                                                                           chainOfResponsibility.addToAntecedentAnnos (neighborCall14);
                                                                            
                                                                           fujaba__Success = true ;
                                                                        }
                                                                        catch ( JavaSDMException fujaba__InternalException )
                                                                        {
                                                                           fujaba__Success = false ;
                                                                        }
                                                                         
                                                                        return (chainOfResponsibility) ;
                                                                     }
                                                                  } //  end for each flow
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object chainOfResponsibility is really bound
            JavaSDM.ensure ( chainOfResponsibility != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (chainOfResponsibility) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("handler", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof OverridingMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof OverridingMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterAbstractHandlerMethodsAbstractHandle = null ;
      Iterator fujaba__IterNeighborCall11ElementsAbstractHandle = null ;
      NeighborCallAnnotation neighborCall11 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLClass abstractHandler = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod abstractHandle = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractHandler = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (abstractHandler);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall11 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterNeighborCall11ElementsAbstractHandle = neighborCall11.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall11ElementsAbstractHandle.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall11ElementsAbstractHandle.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  abstractHandle = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  // bind abstractHandler: UMLClass
                  abstractHandler = abstractHandle.getParent () ;
                  JavaSDM.ensure ( abstractHandler != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandler);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractHandler = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (abstractHandler);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall11 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterNeighborCall11ElementsAbstractHandle = neighborCall11.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall11ElementsAbstractHandle.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall11ElementsAbstractHandle.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  abstractHandle = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  // bind abstractHandler: UMLClass
                  abstractHandler = abstractHandle.getParent () ;
                  JavaSDM.ensure ( abstractHandler != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandler);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Reference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractHandler = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (abstractHandler);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall11 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterNeighborCall11ElementsAbstractHandle = neighborCall11.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall11ElementsAbstractHandle.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall11ElementsAbstractHandle.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  abstractHandle = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  // bind abstractHandler: UMLClass
                  abstractHandler = abstractHandle.getParent () ;
                  JavaSDM.ensure ( abstractHandler != null ) ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandler.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandler);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("NeighborCall") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractHandler = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
            while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
            {
               try
               {
                  abstractHandle = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("OverridingMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractHandler = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
            while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
            {
               try
               {
                  abstractHandle = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall11 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterNeighborCall11ElementsAbstractHandle = neighborCall11.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall11ElementsAbstractHandle.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall11ElementsAbstractHandle.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  abstractHandle = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("OverridingMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractHandler = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
            while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
            {
               try
               {
                  abstractHandle = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall11 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterNeighborCall11ElementsAbstractHandle = neighborCall11.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall11ElementsAbstractHandle.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall11ElementsAbstractHandle.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  abstractHandle = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("NeighborCall") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            abstractHandler = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterAbstractHandlerMethodsAbstractHandle = abstractHandler.iteratorOfMethods () ;
            while ( fujaba__IterAbstractHandlerMethodsAbstractHandle.hasNext () )
            {
               try
               {
                  abstractHandle = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterAbstractHandlerMethodsAbstractHandle.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall11 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind abstractHandle: UMLMethod
            fujaba__IterNeighborCall11ElementsAbstractHandle = neighborCall11.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall11ElementsAbstractHandle.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall11ElementsAbstractHandle.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  abstractHandle = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (abstractHandle.isAbstract () == true) ) ;
                   
                  {
                     //  for each flow
                     set.add (abstractHandle);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
