package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLMethod;

public class DecoratorEngine
extends GFRNEngine
{
   private  DecoratorEngine()
   {
   }

   private static DecoratorEngine theDecoratorEngine;

   public static DecoratorEngine get()
   {
      if (theDecoratorEngine == null)
      {
         theDecoratorEngine = new DecoratorEngine ();
      }
      return theDecoratorEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      DecoratorAnnotation decorator = null ;
      Iterator fujaba__IterCalleeAnnotationsNeighborCall4 = null ;
      Iterator fujaba__IterCallerAnnotationsNeighborCall8 = null ;
      Iterator fujaba__IterComponentClassAnnotationsDecorator = null ;
      Iterator fujaba__IterComponentClassAnnotationsGeneralization1 = null ;
      Iterator fujaba__IterComponentClassAnnotationsSingleReference2 = null ;
      Iterator fujaba__IterComponentClassAnnotationsSingleReference3 = null ;
      Iterator fujaba__IterComponentClassMethodsCallee = null ;
      Iterator fujaba__IterDecoratorClassAnnotationsDecorator = null ;
      Iterator fujaba__IterDecoratorClassAnnotationsGeneralization5 = null ;
      Iterator fujaba__IterDecoratorClassAnnotationsGeneralization9 = null ;
      Iterator fujaba__IterDecoratorClassAnnotationsSingleReference10 = null ;
      Iterator fujaba__IterDecoratorClassAnnotationsSingleReference11 = null ;
      Iterator fujaba__IterDecoratorClassAnnotationsSingleReference6 = null ;
      Iterator fujaba__IterDecoratorClassAnnotationsSingleReference7 = null ;
      Iterator fujaba__IterDecoratorClassMethodsCaller = null ;
      Iterator fujaba__IterGeneralization1ElementsDecoratorClass = null ;
      Iterator fujaba__IterNeighborCall12ElementsCallee = null ;
      Iterator fujaba__IterNeighborCall12ElementsCaller = null ;
      Iterator fujaba__IterNeighborCall4ElementsCaller = null ;
      Iterator fujaba__IterNeighborCall8ElementsCallee = null ;
      Iterator fujaba__IterSingleReference6ElementsComponentClass = null ;
      GeneralizationAnnotation generalization1 = null ;
      GeneralizationAnnotation generalization5 = null ;
      GeneralizationAnnotation generalization9 = null ;
      NeighborCallAnnotation neighborCall12 = null ;
      NeighborCallAnnotation neighborCall4 = null ;
      NeighborCallAnnotation neighborCall8 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      SingleReferenceAnnotation singleReference10 = null ;
      SingleReferenceAnnotation singleReference11 = null ;
      SingleReferenceAnnotation singleReference2 = null ;
      SingleReferenceAnnotation singleReference3 = null ;
      SingleReferenceAnnotation singleReference6 = null ;
      SingleReferenceAnnotation singleReference7 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass componentClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass decoratorClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("component", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            componentClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterComponentClassMethodsCallee = componentClass.iteratorOfMethods () ;
            while ( fujaba__IterComponentClassMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterComponentClassMethodsCallee.next () ;
                   
                  // bind generalization1: GeneralizationAnnotation
                  fujaba__IterComponentClassAnnotationsGeneralization1 = componentClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterComponentClassAnnotationsGeneralization1.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterComponentClassAnnotationsGeneralization1.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization1 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization1 and componentClass
                        JavaSDM.ensure ( generalization1.hasInElements ("superClass", componentClass) ) ;
                         
                        // bind singleReference2: SingleReferenceAnnotation
                        fujaba__IterComponentClassAnnotationsSingleReference2 = componentClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterComponentClassAnnotationsSingleReference2.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterComponentClassAnnotationsSingleReference2.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof SingleReferenceAnnotation ) ;
                              singleReference2 = (SingleReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between singleReference2 and componentClass
                              JavaSDM.ensure ( singleReference2.hasInElements ("references", componentClass) ) ;
                               
                              // bind singleReference3: SingleReferenceAnnotation
                              fujaba__IterComponentClassAnnotationsSingleReference3 = componentClass.iteratorOfAnnotations () ;
                              while ( fujaba__IterComponentClassAnnotationsSingleReference3.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterComponentClassAnnotationsSingleReference3.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof SingleReferenceAnnotation ) ;
                                    singleReference3 = (SingleReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between singleReference3 and componentClass
                                    JavaSDM.ensure ( singleReference3.hasInElements ("referencingClass", componentClass) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(singleReference2.equals (singleReference3)) ) ;
                                     
                                    // bind neighborCall4: NeighborCallAnnotation
                                    fujaba__IterCalleeAnnotationsNeighborCall4 = callee.iteratorOfAnnotations () ;
                                    while ( fujaba__IterCalleeAnnotationsNeighborCall4.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterCalleeAnnotationsNeighborCall4.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                          neighborCall4 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between neighborCall4 and callee
                                          JavaSDM.ensure ( neighborCall4.hasInElements ("callee", callee) ) ;
                                           
                                          // bind decoratorClass: UMLClass
                                          fujaba__IterGeneralization1ElementsDecoratorClass = generalization1.iteratorOfElements ("subClass") ;
                                          while ( fujaba__IterGeneralization1ElementsDecoratorClass.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterGeneralization1ElementsDecoratorClass.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                decoratorClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(componentClass.equals (decoratorClass)) ) ;
                                                 
                                                // check To-Many-Link 'elements' between singleReference2 and decoratorClass
                                                JavaSDM.ensure ( singleReference2.hasInElements ("referencingClass", decoratorClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between singleReference3 and decoratorClass
                                                JavaSDM.ensure ( singleReference3.hasInElements ("references", decoratorClass) ) ;
                                                 
                                                // bind caller: UMLMethod
                                                fujaba__IterNeighborCall4ElementsCaller = neighborCall4.iteratorOfElements ("caller") ;
                                                while ( fujaba__IterNeighborCall4ElementsCaller.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterNeighborCall4ElementsCaller.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                      caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                       
                                                      // check To-One-Link 'parent' between caller and decoratorClass
                                                      JavaSDM.ensure ( (caller.getParent () != null) && caller.getParent ().equals (decoratorClass) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object componentClass is really bound
                                                            JavaSDM.ensure ( componentClass != null ) ;
                                                             
                                                            // check object decoratorClass is really bound
                                                            JavaSDM.ensure ( decoratorClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(componentClass.equals (decoratorClass)) ) ;
                                                             
                                                            // bind decorator: DecoratorAnnotation
                                                            fujaba__IterComponentClassAnnotationsDecorator = componentClass.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterComponentClassAnnotationsDecorator.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterComponentClassAnnotationsDecorator.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof DecoratorAnnotation ) ;
                                                                  decorator = (DecoratorAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between decorator and componentClass
                                                                  JavaSDM.ensure ( decorator.hasInElements ("component", componentClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between decorator and decoratorClass
                                                                  JavaSDM.ensure ( decorator.hasInElements ("decorator", decoratorClass) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object componentClass is really bound
                                                               JavaSDM.ensure ( componentClass != null ) ;
                                                                
                                                               // check object decoratorClass is really bound
                                                               JavaSDM.ensure ( decoratorClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(componentClass.equals (decoratorClass)) ) ;
                                                                
                                                               // check object caller is really bound
                                                               JavaSDM.ensure ( caller != null ) ;
                                                                
                                                               // check object callee is really bound
                                                               JavaSDM.ensure ( callee != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                                
                                                               // create object
                                                               decorator = new DecoratorAnnotation ( ) ;
                                                                
                                                               // create link
                                                               decorator.addToElements ("component", componentClass);
                                                                
                                                               // create link
                                                               decorator.addToElements ("decorator", decoratorClass);
                                                                
                                                               // create link
                                                               decorator.addToBoundObjects ("componentClass", componentClass);
                                                                
                                                               // create link
                                                               decorator.addToBoundObjects ("decoratorClass", decoratorClass);
                                                                
                                                               // create link
                                                               decorator.addToBoundObjects ("caller", caller);
                                                                
                                                               // create link
                                                               decorator.addToBoundObjects ("callee", callee);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object generalization1 is really bound
                                                               JavaSDM.ensure ( generalization1 != null ) ;
                                                                
                                                               // check object singleReference2 is really bound
                                                               JavaSDM.ensure ( singleReference2 != null ) ;
                                                                
                                                               // check object singleReference3 is really bound
                                                               JavaSDM.ensure ( singleReference3 != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(singleReference2.equals (singleReference3)) ) ;
                                                                
                                                               // check object neighborCall4 is really bound
                                                               JavaSDM.ensure ( neighborCall4 != null ) ;
                                                                
                                                               // check object decorator is really bound
                                                               JavaSDM.ensure ( decorator != null ) ;
                                                                
                                                               // create link
                                                               decorator.addToAntecedentAnnos (generalization1);
                                                                
                                                               // create link
                                                               decorator.addToAntecedentAnnos (singleReference2);
                                                                
                                                               // create link
                                                               decorator.addToAntecedentAnnos (singleReference3);
                                                                
                                                               // create link
                                                               decorator.addToAntecedentAnnos (neighborCall4);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (decorator) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object decorator is really bound
            JavaSDM.ensure ( decorator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("component", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("decorator", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            decoratorClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterDecoratorClassMethodsCaller = decoratorClass.iteratorOfMethods () ;
            while ( fujaba__IterDecoratorClassMethodsCaller.hasNext () )
            {
               try
               {
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterDecoratorClassMethodsCaller.next () ;
                   
                  // bind singleReference6: SingleReferenceAnnotation
                  fujaba__IterDecoratorClassAnnotationsSingleReference6 = decoratorClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterDecoratorClassAnnotationsSingleReference6.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterDecoratorClassAnnotationsSingleReference6.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof SingleReferenceAnnotation ) ;
                        singleReference6 = (SingleReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between singleReference6 and decoratorClass
                        JavaSDM.ensure ( singleReference6.hasInElements ("referencingClass", decoratorClass) ) ;
                         
                        // bind generalization5: GeneralizationAnnotation
                        fujaba__IterDecoratorClassAnnotationsGeneralization5 = decoratorClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterDecoratorClassAnnotationsGeneralization5.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterDecoratorClassAnnotationsGeneralization5.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                              generalization5 = (GeneralizationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between generalization5 and decoratorClass
                              JavaSDM.ensure ( generalization5.hasInElements ("subClass", decoratorClass) ) ;
                               
                              // bind singleReference7: SingleReferenceAnnotation
                              fujaba__IterDecoratorClassAnnotationsSingleReference7 = decoratorClass.iteratorOfAnnotations () ;
                              while ( fujaba__IterDecoratorClassAnnotationsSingleReference7.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterDecoratorClassAnnotationsSingleReference7.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof SingleReferenceAnnotation ) ;
                                    singleReference7 = (SingleReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between singleReference7 and decoratorClass
                                    JavaSDM.ensure ( singleReference7.hasInElements ("references", decoratorClass) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(singleReference6.equals (singleReference7)) ) ;
                                     
                                    // bind neighborCall8: NeighborCallAnnotation
                                    fujaba__IterCallerAnnotationsNeighborCall8 = caller.iteratorOfAnnotations () ;
                                    while ( fujaba__IterCallerAnnotationsNeighborCall8.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterCallerAnnotationsNeighborCall8.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                          neighborCall8 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between neighborCall8 and caller
                                          JavaSDM.ensure ( neighborCall8.hasInElements ("caller", caller) ) ;
                                           
                                          // bind componentClass: UMLClass
                                          fujaba__IterSingleReference6ElementsComponentClass = singleReference6.iteratorOfElements ("references") ;
                                          while ( fujaba__IterSingleReference6ElementsComponentClass.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterSingleReference6ElementsComponentClass.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                                componentClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(decoratorClass.equals (componentClass)) ) ;
                                                 
                                                // check To-Many-Link 'elements' between generalization5 and componentClass
                                                JavaSDM.ensure ( generalization5.hasInElements ("superClass", componentClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between singleReference7 and componentClass
                                                JavaSDM.ensure ( singleReference7.hasInElements ("referencingClass", componentClass) ) ;
                                                 
                                                // bind callee: UMLMethod
                                                fujaba__IterNeighborCall8ElementsCallee = neighborCall8.iteratorOfElements ("callee") ;
                                                while ( fujaba__IterNeighborCall8ElementsCallee.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterNeighborCall8ElementsCallee.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                      callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                       
                                                      // check To-One-Link 'parent' between callee and componentClass
                                                      JavaSDM.ensure ( (callee.getParent () != null) && callee.getParent ().equals (componentClass) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object componentClass is really bound
                                                            JavaSDM.ensure ( componentClass != null ) ;
                                                             
                                                            // check object decoratorClass is really bound
                                                            JavaSDM.ensure ( decoratorClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(componentClass.equals (decoratorClass)) ) ;
                                                             
                                                            // bind decorator: DecoratorAnnotation
                                                            fujaba__IterDecoratorClassAnnotationsDecorator = decoratorClass.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterDecoratorClassAnnotationsDecorator.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterDecoratorClassAnnotationsDecorator.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof DecoratorAnnotation ) ;
                                                                  decorator = (DecoratorAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between decorator and decoratorClass
                                                                  JavaSDM.ensure ( decorator.hasInElements ("decorator", decoratorClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between decorator and componentClass
                                                                  JavaSDM.ensure ( decorator.hasInElements ("component", componentClass) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object componentClass is really bound
                                                               JavaSDM.ensure ( componentClass != null ) ;
                                                                
                                                               // check object decoratorClass is really bound
                                                               JavaSDM.ensure ( decoratorClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(componentClass.equals (decoratorClass)) ) ;
                                                                
                                                               // check object caller is really bound
                                                               JavaSDM.ensure ( caller != null ) ;
                                                                
                                                               // check object callee is really bound
                                                               JavaSDM.ensure ( callee != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                                
                                                               // create object
                                                               decorator = new DecoratorAnnotation ( ) ;
                                                                
                                                               // create link
                                                               decorator.addToElements ("component", componentClass);
                                                                
                                                               // create link
                                                               decorator.addToElements ("decorator", decoratorClass);
                                                                
                                                               // create link
                                                               decorator.addToBoundObjects ("componentClass", componentClass);
                                                                
                                                               // create link
                                                               decorator.addToBoundObjects ("decoratorClass", decoratorClass);
                                                                
                                                               // create link
                                                               decorator.addToBoundObjects ("caller", caller);
                                                                
                                                               // create link
                                                               decorator.addToBoundObjects ("callee", callee);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object generalization5 is really bound
                                                               JavaSDM.ensure ( generalization5 != null ) ;
                                                                
                                                               // check object singleReference6 is really bound
                                                               JavaSDM.ensure ( singleReference6 != null ) ;
                                                                
                                                               // check object singleReference7 is really bound
                                                               JavaSDM.ensure ( singleReference7 != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(singleReference6.equals (singleReference7)) ) ;
                                                                
                                                               // check object neighborCall8 is really bound
                                                               JavaSDM.ensure ( neighborCall8 != null ) ;
                                                                
                                                               // check object decorator is really bound
                                                               JavaSDM.ensure ( decorator != null ) ;
                                                                
                                                               // create link
                                                               decorator.addToAntecedentAnnos (generalization5);
                                                                
                                                               // create link
                                                               decorator.addToAntecedentAnnos (singleReference6);
                                                                
                                                               // create link
                                                               decorator.addToAntecedentAnnos (singleReference7);
                                                                
                                                               // create link
                                                               decorator.addToAntecedentAnnos (neighborCall8);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (decorator) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object decorator is really bound
            JavaSDM.ensure ( decorator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("decorator", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall12 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterNeighborCall12ElementsCaller = neighborCall12.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall12ElementsCaller.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall12ElementsCaller.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind decoratorClass: UMLClass
                  decoratorClass = caller.getParent () ;
                  JavaSDM.ensure ( decoratorClass != null ) ;
                   
                  // bind callee: UMLMethod
                  fujaba__IterNeighborCall12ElementsCallee = neighborCall12.iteratorOfElements ("callee") ;
                  while ( fujaba__IterNeighborCall12ElementsCallee.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterNeighborCall12ElementsCallee.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                         
                        // bind componentClass: UMLClass
                        componentClass = callee.getParent () ;
                        JavaSDM.ensure ( componentClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(decoratorClass.equals (componentClass)) ) ;
                         
                        // bind singleReference10: SingleReferenceAnnotation
                        fujaba__IterDecoratorClassAnnotationsSingleReference10 = decoratorClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterDecoratorClassAnnotationsSingleReference10.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterDecoratorClassAnnotationsSingleReference10.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof SingleReferenceAnnotation ) ;
                              singleReference10 = (SingleReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between singleReference10 and decoratorClass
                              JavaSDM.ensure ( singleReference10.hasInElements ("referencingClass", decoratorClass) ) ;
                               
                              // check To-Many-Link 'elements' between singleReference10 and componentClass
                              JavaSDM.ensure ( singleReference10.hasInElements ("references", componentClass) ) ;
                               
                              // bind generalization9: GeneralizationAnnotation
                              fujaba__IterDecoratorClassAnnotationsGeneralization9 = decoratorClass.iteratorOfAnnotations () ;
                              while ( fujaba__IterDecoratorClassAnnotationsGeneralization9.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterDecoratorClassAnnotationsGeneralization9.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                    generalization9 = (GeneralizationAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between generalization9 and decoratorClass
                                    JavaSDM.ensure ( generalization9.hasInElements ("subClass", decoratorClass) ) ;
                                     
                                    // check To-Many-Link 'elements' between generalization9 and componentClass
                                    JavaSDM.ensure ( generalization9.hasInElements ("superClass", componentClass) ) ;
                                     
                                    // bind singleReference11: SingleReferenceAnnotation
                                    fujaba__IterDecoratorClassAnnotationsSingleReference11 = decoratorClass.iteratorOfAnnotations () ;
                                    while ( fujaba__IterDecoratorClassAnnotationsSingleReference11.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterDecoratorClassAnnotationsSingleReference11.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof SingleReferenceAnnotation ) ;
                                          singleReference11 = (SingleReferenceAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between singleReference11 and decoratorClass
                                          JavaSDM.ensure ( singleReference11.hasInElements ("references", decoratorClass) ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(singleReference10.equals (singleReference11)) ) ;
                                           
                                          // check To-Many-Link 'elements' between singleReference11 and componentClass
                                          JavaSDM.ensure ( singleReference11.hasInElements ("referencingClass", componentClass) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object componentClass is really bound
                                                JavaSDM.ensure ( componentClass != null ) ;
                                                 
                                                // check object decoratorClass is really bound
                                                JavaSDM.ensure ( decoratorClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(componentClass.equals (decoratorClass)) ) ;
                                                 
                                                // bind decorator: DecoratorAnnotation
                                                fujaba__IterDecoratorClassAnnotationsDecorator = decoratorClass.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterDecoratorClassAnnotationsDecorator.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterDecoratorClassAnnotationsDecorator.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof DecoratorAnnotation ) ;
                                                      decorator = (DecoratorAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between decorator and decoratorClass
                                                      JavaSDM.ensure ( decorator.hasInElements ("decorator", decoratorClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between decorator and componentClass
                                                      JavaSDM.ensure ( decorator.hasInElements ("component", componentClass) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object componentClass is really bound
                                                   JavaSDM.ensure ( componentClass != null ) ;
                                                    
                                                   // check object decoratorClass is really bound
                                                   JavaSDM.ensure ( decoratorClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(componentClass.equals (decoratorClass)) ) ;
                                                    
                                                   // check object caller is really bound
                                                   JavaSDM.ensure ( caller != null ) ;
                                                    
                                                   // check object callee is really bound
                                                   JavaSDM.ensure ( callee != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                    
                                                   // create object
                                                   decorator = new DecoratorAnnotation ( ) ;
                                                    
                                                   // create link
                                                   decorator.addToElements ("component", componentClass);
                                                    
                                                   // create link
                                                   decorator.addToElements ("decorator", decoratorClass);
                                                    
                                                   // create link
                                                   decorator.addToBoundObjects ("componentClass", componentClass);
                                                    
                                                   // create link
                                                   decorator.addToBoundObjects ("decoratorClass", decoratorClass);
                                                    
                                                   // create link
                                                   decorator.addToBoundObjects ("caller", caller);
                                                    
                                                   // create link
                                                   decorator.addToBoundObjects ("callee", callee);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object generalization9 is really bound
                                                   JavaSDM.ensure ( generalization9 != null ) ;
                                                    
                                                   // check object singleReference10 is really bound
                                                   JavaSDM.ensure ( singleReference10 != null ) ;
                                                    
                                                   // check object singleReference11 is really bound
                                                   JavaSDM.ensure ( singleReference11 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(singleReference10.equals (singleReference11)) ) ;
                                                    
                                                   // check object neighborCall12 is really bound
                                                   JavaSDM.ensure ( neighborCall12 != null ) ;
                                                    
                                                   // check object decorator is really bound
                                                   JavaSDM.ensure ( decorator != null ) ;
                                                    
                                                   // create link
                                                   decorator.addToAntecedentAnnos (generalization9);
                                                    
                                                   // create link
                                                   decorator.addToAntecedentAnnos (singleReference10);
                                                    
                                                   // create link
                                                   decorator.addToAntecedentAnnos (singleReference11);
                                                    
                                                   // create link
                                                   decorator.addToAntecedentAnnos (neighborCall12);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (decorator) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object decorator is really bound
            JavaSDM.ensure ( decorator != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (decorator) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("component", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("decorator", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof SingleReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof SingleReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterComponentClassMethodsCallee = null ;
      Iterator fujaba__IterDecoratorClassMethodsCaller = null ;
      Iterator fujaba__IterNeighborCall12ElementsCaller = null ;
      NeighborCallAnnotation neighborCall12 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLClass componentClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass decoratorClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            componentClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (componentClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            decoratorClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (decoratorClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall12 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterNeighborCall12ElementsCaller = neighborCall12.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall12ElementsCaller.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall12ElementsCaller.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind decoratorClass: UMLClass
                  decoratorClass = caller.getParent () ;
                  JavaSDM.ensure ( decoratorClass != null ) ;
                   
                  {
                     //  for each flow
                     set.add (decoratorClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("SingleReference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            componentClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (componentClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            decoratorClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (decoratorClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall12 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterNeighborCall12ElementsCaller = neighborCall12.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall12ElementsCaller.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall12ElementsCaller.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind decoratorClass: UMLClass
                  decoratorClass = caller.getParent () ;
                  JavaSDM.ensure ( decoratorClass != null ) ;
                   
                  {
                     //  for each flow
                     set.add (decoratorClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("SingleReference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            componentClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (componentClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            decoratorClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (decoratorClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall12 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterNeighborCall12ElementsCaller = neighborCall12.iteratorOfElements ("caller") ;
            while ( fujaba__IterNeighborCall12ElementsCaller.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall12ElementsCaller.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind decoratorClass: UMLClass
                  decoratorClass = caller.getParent () ;
                  JavaSDM.ensure ( decoratorClass != null ) ;
                   
                  {
                     //  for each flow
                     set.add (decoratorClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("NeighborCall") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            componentClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterComponentClassMethodsCallee = componentClass.iteratorOfMethods () ;
            while ( fujaba__IterComponentClassMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterComponentClassMethodsCallee.next () ;
                   
                  {
                     //  for each flow
                     set.add (callee);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            decoratorClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterDecoratorClassMethodsCaller = decoratorClass.iteratorOfMethods () ;
            while ( fujaba__IterDecoratorClassMethodsCaller.hasNext () )
            {
               try
               {
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterDecoratorClassMethodsCaller.next () ;
                   
                  {
                     //  for each flow
                     set.add (caller);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
