package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;

public class MethodDeclerationEngine
extends GFRNEngine
{
   private  MethodDeclerationEngine()
   {
   }

   private static MethodDeclerationEngine theMethodDeclerationEngine;

   public static MethodDeclerationEngine get()
   {
      if (theMethodDeclerationEngine == null)
      {
         theMethodDeclerationEngine = new MethodDeclerationEngine ();
      }
      return theMethodDeclerationEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      de.upb.tools.fca.FHashSet set = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterDeclaredAnnotationsMethodDecleration = null ;
      Iterator fujaba__IterDeclaringAnnotationsMethodDecleration = null ;
      Iterator fujaba__IterDeclaringMethodsDeclared = null ;
      Iterator fujaba__IterSet = null ;
      MethodDeclerationAnnotation methodDecleration = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation fujaba__TmpObjectOverridingMethodAnnotation = null ;
      de.uni_paderborn.fujaba.uml.UMLClass declaring = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod declared = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("declared", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            declared = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind declaring: UMLClass
            declaring = declared.getParent () ;
            JavaSDM.ensure ( declaring != null ) ;
             
            // linkSearchToSetTop
            set = new de.upb.tools.fca.FHashSet ( ) ;
            fujaba__IterSet = declared.iteratorOfAnnotations () ;
            while ( fujaba__IterSet.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSet.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                  fujaba__TmpObjectOverridingMethodAnnotation = (OverridingMethodAnnotation) fujaba__TmpObject ;
                   
                  set.add (fujaba__TmpObjectOverridingMethodAnnotation);
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            } // while
            // constraint
            JavaSDM.ensure ( set.size() == 0 ) ;
             
            {
               //  for each flow
               try
               {
                  fujaba__Success = false ;
                   
                  // check object declared is really bound
                  JavaSDM.ensure ( declared != null ) ;
                   
                  // check object declaring is really bound
                  JavaSDM.ensure ( declaring != null ) ;
                   
                  // bind methodDecleration: MethodDeclerationAnnotation
                  fujaba__IterDeclaringAnnotationsMethodDecleration = declaring.iteratorOfAnnotations () ;
                  while ( !(fujaba__Success) && fujaba__IterDeclaringAnnotationsMethodDecleration.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterDeclaringAnnotationsMethodDecleration.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof MethodDeclerationAnnotation ) ;
                        methodDecleration = (MethodDeclerationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between methodDecleration and declaring
                        JavaSDM.ensure ( methodDecleration.hasInElements ("declaring", declaring) ) ;
                         
                        // check To-Many-Link 'elements' between methodDecleration and declared
                        JavaSDM.ensure ( methodDecleration.hasInElements ("declared", declared) ) ;
                         
                        fujaba__Success = true ;
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
                  fujaba__Success = false ;
               }
                
               if ( !(fujaba__Success) )
               {
                  try
                  {
                     fujaba__Success = false ;
                      
                     // check object declared is really bound
                     JavaSDM.ensure ( declared != null ) ;
                      
                     // check object declaring is really bound
                     JavaSDM.ensure ( declaring != null ) ;
                      
                     // create object
                     methodDecleration = new MethodDeclerationAnnotation ( ) ;
                      
                     // create link
                     methodDecleration.addToElements ("declared", declared);
                      
                     // create link
                     methodDecleration.addToElements ("declaring", declaring);
                      
                     // create link
                     methodDecleration.addToBoundObjects ("declared", declared);
                      
                     // create link
                     methodDecleration.addToBoundObjects ("declaring", declaring);
                      
                     fujaba__Success = true ;
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false ;
                  }
                   
                  try
                  {
                     fujaba__Success = false ;
                      
                     // check object methodDecleration is really bound
                     JavaSDM.ensure ( methodDecleration != null ) ;
                      
                     fujaba__IterSet = set.iterator () ;
                     while ( fujaba__IterSet.hasNext () )
                     {
                        fujaba__TmpObjectOverridingMethodAnnotation = (OverridingMethodAnnotation) fujaba__IterSet.next () ;
                        //  create set link
                        methodDecleration.addToAntecedentAnnos (fujaba__TmpObjectOverridingMethodAnnotation);
                        fujaba__Success = true ;
                     } // while
                  }
                  catch ( JavaSDMException fujaba__InternalException )
                  {
                     fujaba__Success = false ;
                  }
                   
                  return (methodDecleration) ;
               }
            } //  end for each flow
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object methodDecleration is really bound
            JavaSDM.ensure ( methodDecleration != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("declared", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("declaring", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            declaring = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind declared: UMLMethod
            fujaba__IterDeclaringMethodsDeclared = declaring.iteratorOfMethods () ;
            while ( fujaba__IterDeclaringMethodsDeclared.hasNext () )
            {
               try
               {
                  declared = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterDeclaringMethodsDeclared.next () ;
                   
                  // linkSearchToSetTop
                  set = new de.upb.tools.fca.FHashSet ( ) ;
                  fujaba__IterSet = declared.iteratorOfAnnotations () ;
                  while ( fujaba__IterSet.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterSet.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                        fujaba__TmpObjectOverridingMethodAnnotation = (OverridingMethodAnnotation) fujaba__TmpObject ;
                         
                        set.add (fujaba__TmpObjectOverridingMethodAnnotation);
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  } // while
                  // constraint
                  JavaSDM.ensure ( set.size() == 0 ) ;
                   
                  {
                     //  for each flow
                     try
                     {
                        fujaba__Success = false ;
                         
                        // check object declared is really bound
                        JavaSDM.ensure ( declared != null ) ;
                         
                        // check object declaring is really bound
                        JavaSDM.ensure ( declaring != null ) ;
                         
                        // bind methodDecleration: MethodDeclerationAnnotation
                        fujaba__IterDeclaredAnnotationsMethodDecleration = declared.iteratorOfAnnotations () ;
                        while ( !(fujaba__Success) && fujaba__IterDeclaredAnnotationsMethodDecleration.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterDeclaredAnnotationsMethodDecleration.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof MethodDeclerationAnnotation ) ;
                              methodDecleration = (MethodDeclerationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between methodDecleration and declared
                              JavaSDM.ensure ( methodDecleration.hasInElements ("declared", declared) ) ;
                               
                              // check To-Many-Link 'elements' between methodDecleration and declaring
                              JavaSDM.ensure ( methodDecleration.hasInElements ("declaring", declaring) ) ;
                               
                              fujaba__Success = true ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                        fujaba__Success = false ;
                     }
                      
                     if ( !(fujaba__Success) )
                     {
                        try
                        {
                           fujaba__Success = false ;
                            
                           // check object declared is really bound
                           JavaSDM.ensure ( declared != null ) ;
                            
                           // check object declaring is really bound
                           JavaSDM.ensure ( declaring != null ) ;
                            
                           // create object
                           methodDecleration = new MethodDeclerationAnnotation ( ) ;
                            
                           // create link
                           methodDecleration.addToElements ("declared", declared);
                            
                           // create link
                           methodDecleration.addToElements ("declaring", declaring);
                            
                           // create link
                           methodDecleration.addToBoundObjects ("declared", declared);
                            
                           // create link
                           methodDecleration.addToBoundObjects ("declaring", declaring);
                            
                           fujaba__Success = true ;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false ;
                        }
                         
                        try
                        {
                           fujaba__Success = false ;
                            
                           // check object methodDecleration is really bound
                           JavaSDM.ensure ( methodDecleration != null ) ;
                            
                           fujaba__IterSet = set.iterator () ;
                           while ( fujaba__IterSet.hasNext () )
                           {
                              fujaba__TmpObjectOverridingMethodAnnotation = (OverridingMethodAnnotation) fujaba__IterSet.next () ;
                              //  create set link
                              methodDecleration.addToAntecedentAnnos (fujaba__TmpObjectOverridingMethodAnnotation);
                              fujaba__Success = true ;
                           } // while
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false ;
                        }
                         
                        return (methodDecleration) ;
                     }
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object methodDecleration is really bound
            JavaSDM.ensure ( methodDecleration != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("declaring", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (methodDecleration) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("declared", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("declaring", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof OverridingMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterDeclaringMethodsDeclared = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLClass declaring = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod declared = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("OverridingMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            declared = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (declared);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            declaring = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind declared: UMLMethod
            fujaba__IterDeclaringMethodsDeclared = declaring.iteratorOfMethods () ;
            while ( fujaba__IterDeclaringMethodsDeclared.hasNext () )
            {
               try
               {
                  declared = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterDeclaringMethodsDeclared.next () ;
                   
                  {
                     //  for each flow
                     set.add (declared);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
