package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLClass;

public class MultiLevelGeneralizationEngine
extends GFRNEngine
{
   private  MultiLevelGeneralizationEngine()
   {
   }

   private static MultiLevelGeneralizationEngine theMultiLevelGeneralizationEngine;

   public static MultiLevelGeneralizationEngine get()
   {
      if (theMultiLevelGeneralizationEngine == null)
      {
         theMultiLevelGeneralizationEngine = new MultiLevelGeneralizationEngine ();
      }
      return theMultiLevelGeneralizationEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterGeneralization1ElementsIntermediateClass = null ;
      Iterator fujaba__IterGeneralization2ElementsSubClass = null ;
      Iterator fujaba__IterGeneralization3ElementsIntermediateClass = null ;
      Iterator fujaba__IterGeneralization3ElementsSuperClass = null ;
      Iterator fujaba__IterGeneralization4ElementsSubClass = null ;
      Iterator fujaba__IterGeneralization5ElementsSuperClass = null ;
      Iterator fujaba__IterGeneralization6ElementsIntermediateClass = null ;
      Iterator fujaba__IterIntermediateClassAnnotationsGeneralization2 = null ;
      Iterator fujaba__IterIntermediateClassAnnotationsGeneralization4 = null ;
      Iterator fujaba__IterIntermediateClassAnnotationsGeneralization5 = null ;
      Iterator fujaba__IterSubClassAnnotationsGeneralization6 = null ;
      Iterator fujaba__IterSubClassAnnotationsMultiLevelGeneralization = null ;
      Iterator fujaba__IterSuperClassAnnotationsGeneralization1 = null ;
      Iterator fujaba__IterSuperClassAnnotationsMultiLevelGeneralization = null ;
      GeneralizationAnnotation generalization1 = null ;
      GeneralizationAnnotation generalization2 = null ;
      GeneralizationAnnotation generalization3 = null ;
      GeneralizationAnnotation generalization4 = null ;
      GeneralizationAnnotation generalization5 = null ;
      GeneralizationAnnotation generalization6 = null ;
      MultiLevelGeneralizationAnnotation multiLevelGeneralization = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLClass intermediateClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass subClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass superClass = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("superClass", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            superClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind generalization1: GeneralizationAnnotation
            fujaba__IterSuperClassAnnotationsGeneralization1 = superClass.iteratorOfAnnotations () ;
            while ( fujaba__IterSuperClassAnnotationsGeneralization1.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSuperClassAnnotationsGeneralization1.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                  generalization1 = (GeneralizationAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between generalization1 and superClass
                  JavaSDM.ensure ( generalization1.hasInElements ("superClass", superClass) ) ;
                   
                  // bind intermediateClass: UMLClass
                  fujaba__IterGeneralization1ElementsIntermediateClass = generalization1.iteratorOfElements ("subClass") ;
                  while ( fujaba__IterGeneralization1ElementsIntermediateClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization1ElementsIntermediateClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        intermediateClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(superClass.equals (intermediateClass)) ) ;
                         
                        // bind generalization2: GeneralizationAnnotation
                        fujaba__IterIntermediateClassAnnotationsGeneralization2 = intermediateClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterIntermediateClassAnnotationsGeneralization2.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterIntermediateClassAnnotationsGeneralization2.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                              generalization2 = (GeneralizationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between generalization2 and intermediateClass
                              JavaSDM.ensure ( generalization2.hasInElements ("superClass", intermediateClass) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(generalization1.equals (generalization2)) ) ;
                               
                              // bind subClass: UMLClass
                              fujaba__IterGeneralization2ElementsSubClass = generalization2.iteratorOfElements ("subClass") ;
                              while ( fujaba__IterGeneralization2ElementsSubClass.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterGeneralization2ElementsSubClass.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    subClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(superClass.equals (subClass)) && !(intermediateClass.equals (subClass)) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object superClass is really bound
                                          JavaSDM.ensure ( superClass != null ) ;
                                           
                                          // check object subClass is really bound
                                          JavaSDM.ensure ( subClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(superClass.equals (subClass)) ) ;
                                           
                                          // bind multiLevelGeneralization: MultiLevelGeneralizationAnnotation
                                          fujaba__IterSubClassAnnotationsMultiLevelGeneralization = subClass.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterSubClassAnnotationsMultiLevelGeneralization.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterSubClassAnnotationsMultiLevelGeneralization.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof MultiLevelGeneralizationAnnotation ) ;
                                                multiLevelGeneralization = (MultiLevelGeneralizationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between multiLevelGeneralization and subClass
                                                JavaSDM.ensure ( multiLevelGeneralization.hasInElements ("subClass", subClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between multiLevelGeneralization and superClass
                                                JavaSDM.ensure ( multiLevelGeneralization.hasInElements ("superClass", superClass) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object superClass is really bound
                                             JavaSDM.ensure ( superClass != null ) ;
                                              
                                             // check object subClass is really bound
                                             JavaSDM.ensure ( subClass != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(superClass.equals (subClass)) ) ;
                                              
                                             // check object intermediateClass is really bound
                                             JavaSDM.ensure ( intermediateClass != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(superClass.equals (intermediateClass)) && !(subClass.equals (intermediateClass)) ) ;
                                              
                                             // create object
                                             multiLevelGeneralization = new MultiLevelGeneralizationAnnotation ( ) ;
                                              
                                             // create link
                                             multiLevelGeneralization.addToElements ("superClass", superClass);
                                              
                                             // create link
                                             multiLevelGeneralization.addToElements ("subClass", subClass);
                                              
                                             // create link
                                             multiLevelGeneralization.addToBoundObjects ("superClass", superClass);
                                              
                                             // create link
                                             multiLevelGeneralization.addToBoundObjects ("intermediateClass", intermediateClass);
                                              
                                             // create link
                                             multiLevelGeneralization.addToBoundObjects ("subClass", subClass);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object generalization1 is really bound
                                             JavaSDM.ensure ( generalization1 != null ) ;
                                              
                                             // check object generalization2 is really bound
                                             JavaSDM.ensure ( generalization2 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(generalization1.equals (generalization2)) ) ;
                                              
                                             // check object multiLevelGeneralization is really bound
                                             JavaSDM.ensure ( multiLevelGeneralization != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(generalization1.equals (multiLevelGeneralization)) && !(generalization2.equals (multiLevelGeneralization)) ) ;
                                              
                                             // create link
                                             multiLevelGeneralization.addToAntecedentAnnos (generalization1);
                                              
                                             // create link
                                             multiLevelGeneralization.addToAntecedentAnnos (generalization2);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (multiLevelGeneralization) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiLevelGeneralization is really bound
            JavaSDM.ensure ( multiLevelGeneralization != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("superClass", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization3 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind superClass: UMLClass
            fujaba__IterGeneralization3ElementsSuperClass = generalization3.iteratorOfElements ("superClass") ;
            while ( fujaba__IterGeneralization3ElementsSuperClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization3ElementsSuperClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  superClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  // bind intermediateClass: UMLClass
                  fujaba__IterGeneralization3ElementsIntermediateClass = generalization3.iteratorOfElements ("subClass") ;
                  while ( fujaba__IterGeneralization3ElementsIntermediateClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization3ElementsIntermediateClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        intermediateClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(superClass.equals (intermediateClass)) ) ;
                         
                        // bind generalization4: GeneralizationAnnotation
                        fujaba__IterIntermediateClassAnnotationsGeneralization4 = intermediateClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterIntermediateClassAnnotationsGeneralization4.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterIntermediateClassAnnotationsGeneralization4.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                              generalization4 = (GeneralizationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between generalization4 and intermediateClass
                              JavaSDM.ensure ( generalization4.hasInElements ("superClass", intermediateClass) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(generalization3.equals (generalization4)) ) ;
                               
                              // bind subClass: UMLClass
                              fujaba__IterGeneralization4ElementsSubClass = generalization4.iteratorOfElements ("subClass") ;
                              while ( fujaba__IterGeneralization4ElementsSubClass.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterGeneralization4ElementsSubClass.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    subClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(superClass.equals (subClass)) && !(intermediateClass.equals (subClass)) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object superClass is really bound
                                          JavaSDM.ensure ( superClass != null ) ;
                                           
                                          // check object subClass is really bound
                                          JavaSDM.ensure ( subClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(superClass.equals (subClass)) ) ;
                                           
                                          // bind multiLevelGeneralization: MultiLevelGeneralizationAnnotation
                                          fujaba__IterSuperClassAnnotationsMultiLevelGeneralization = superClass.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterSuperClassAnnotationsMultiLevelGeneralization.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterSuperClassAnnotationsMultiLevelGeneralization.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof MultiLevelGeneralizationAnnotation ) ;
                                                multiLevelGeneralization = (MultiLevelGeneralizationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between multiLevelGeneralization and superClass
                                                JavaSDM.ensure ( multiLevelGeneralization.hasInElements ("superClass", superClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between multiLevelGeneralization and subClass
                                                JavaSDM.ensure ( multiLevelGeneralization.hasInElements ("subClass", subClass) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object superClass is really bound
                                             JavaSDM.ensure ( superClass != null ) ;
                                              
                                             // check object subClass is really bound
                                             JavaSDM.ensure ( subClass != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(superClass.equals (subClass)) ) ;
                                              
                                             // check object intermediateClass is really bound
                                             JavaSDM.ensure ( intermediateClass != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(superClass.equals (intermediateClass)) && !(subClass.equals (intermediateClass)) ) ;
                                              
                                             // create object
                                             multiLevelGeneralization = new MultiLevelGeneralizationAnnotation ( ) ;
                                              
                                             // create link
                                             multiLevelGeneralization.addToElements ("superClass", superClass);
                                              
                                             // create link
                                             multiLevelGeneralization.addToElements ("subClass", subClass);
                                              
                                             // create link
                                             multiLevelGeneralization.addToBoundObjects ("superClass", superClass);
                                              
                                             // create link
                                             multiLevelGeneralization.addToBoundObjects ("intermediateClass", intermediateClass);
                                              
                                             // create link
                                             multiLevelGeneralization.addToBoundObjects ("subClass", subClass);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object generalization3 is really bound
                                             JavaSDM.ensure ( generalization3 != null ) ;
                                              
                                             // check object generalization4 is really bound
                                             JavaSDM.ensure ( generalization4 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(generalization3.equals (generalization4)) ) ;
                                              
                                             // check object multiLevelGeneralization is really bound
                                             JavaSDM.ensure ( multiLevelGeneralization != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(generalization3.equals (multiLevelGeneralization)) && !(generalization4.equals (multiLevelGeneralization)) ) ;
                                              
                                             // create link
                                             multiLevelGeneralization.addToAntecedentAnnos (generalization3);
                                              
                                             // create link
                                             multiLevelGeneralization.addToAntecedentAnnos (generalization4);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (multiLevelGeneralization) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiLevelGeneralization is really bound
            JavaSDM.ensure ( multiLevelGeneralization != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("subClass", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            subClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind generalization6: GeneralizationAnnotation
            fujaba__IterSubClassAnnotationsGeneralization6 = subClass.iteratorOfAnnotations () ;
            while ( fujaba__IterSubClassAnnotationsGeneralization6.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSubClassAnnotationsGeneralization6.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                  generalization6 = (GeneralizationAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between generalization6 and subClass
                  JavaSDM.ensure ( generalization6.hasInElements ("subClass", subClass) ) ;
                   
                  // bind intermediateClass: UMLClass
                  fujaba__IterGeneralization6ElementsIntermediateClass = generalization6.iteratorOfElements ("superClass") ;
                  while ( fujaba__IterGeneralization6ElementsIntermediateClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization6ElementsIntermediateClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        intermediateClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(subClass.equals (intermediateClass)) ) ;
                         
                        // bind generalization5: GeneralizationAnnotation
                        fujaba__IterIntermediateClassAnnotationsGeneralization5 = intermediateClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterIntermediateClassAnnotationsGeneralization5.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterIntermediateClassAnnotationsGeneralization5.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                              generalization5 = (GeneralizationAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between generalization5 and intermediateClass
                              JavaSDM.ensure ( generalization5.hasInElements ("subClass", intermediateClass) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(generalization6.equals (generalization5)) ) ;
                               
                              // bind superClass: UMLClass
                              fujaba__IterGeneralization5ElementsSuperClass = generalization5.iteratorOfElements ("superClass") ;
                              while ( fujaba__IterGeneralization5ElementsSuperClass.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterGeneralization5ElementsSuperClass.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    superClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(intermediateClass.equals (superClass)) && !(subClass.equals (superClass)) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object superClass is really bound
                                          JavaSDM.ensure ( superClass != null ) ;
                                           
                                          // check object subClass is really bound
                                          JavaSDM.ensure ( subClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(superClass.equals (subClass)) ) ;
                                           
                                          // bind multiLevelGeneralization: MultiLevelGeneralizationAnnotation
                                          fujaba__IterSubClassAnnotationsMultiLevelGeneralization = subClass.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterSubClassAnnotationsMultiLevelGeneralization.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterSubClassAnnotationsMultiLevelGeneralization.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof MultiLevelGeneralizationAnnotation ) ;
                                                multiLevelGeneralization = (MultiLevelGeneralizationAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between multiLevelGeneralization and subClass
                                                JavaSDM.ensure ( multiLevelGeneralization.hasInElements ("subClass", subClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between multiLevelGeneralization and superClass
                                                JavaSDM.ensure ( multiLevelGeneralization.hasInElements ("superClass", superClass) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object superClass is really bound
                                             JavaSDM.ensure ( superClass != null ) ;
                                              
                                             // check object subClass is really bound
                                             JavaSDM.ensure ( subClass != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(superClass.equals (subClass)) ) ;
                                              
                                             // check object intermediateClass is really bound
                                             JavaSDM.ensure ( intermediateClass != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(superClass.equals (intermediateClass)) && !(subClass.equals (intermediateClass)) ) ;
                                              
                                             // create object
                                             multiLevelGeneralization = new MultiLevelGeneralizationAnnotation ( ) ;
                                              
                                             // create link
                                             multiLevelGeneralization.addToElements ("superClass", superClass);
                                              
                                             // create link
                                             multiLevelGeneralization.addToElements ("subClass", subClass);
                                              
                                             // create link
                                             multiLevelGeneralization.addToBoundObjects ("superClass", superClass);
                                              
                                             // create link
                                             multiLevelGeneralization.addToBoundObjects ("intermediateClass", intermediateClass);
                                              
                                             // create link
                                             multiLevelGeneralization.addToBoundObjects ("subClass", subClass);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object generalization5 is really bound
                                             JavaSDM.ensure ( generalization5 != null ) ;
                                              
                                             // check object generalization6 is really bound
                                             JavaSDM.ensure ( generalization6 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(generalization5.equals (generalization6)) ) ;
                                              
                                             // check object multiLevelGeneralization is really bound
                                             JavaSDM.ensure ( multiLevelGeneralization != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(generalization5.equals (multiLevelGeneralization)) && !(generalization6.equals (multiLevelGeneralization)) ) ;
                                              
                                             // create link
                                             multiLevelGeneralization.addToAntecedentAnnos (generalization5);
                                              
                                             // create link
                                             multiLevelGeneralization.addToAntecedentAnnos (generalization6);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (multiLevelGeneralization) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiLevelGeneralization is really bound
            JavaSDM.ensure ( multiLevelGeneralization != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("subClass", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (multiLevelGeneralization) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("superClass", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("subClass", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterGeneralization7ElementsIntermediateClass = null ;
      Iterator fujaba__IterGeneralization8ElementsIntermediateClass = null ;
      Iterator fujaba__IterSubClassAnnotationsGeneralization7 = null ;
      Iterator fujaba__IterSuperClassAnnotationsGeneralization8 = null ;
      GeneralizationAnnotation generalization7 = null ;
      GeneralizationAnnotation generalization8 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLClass intermediateClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass subClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass superClass = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            superClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (superClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            subClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind generalization7: GeneralizationAnnotation
            fujaba__IterSubClassAnnotationsGeneralization7 = subClass.iteratorOfAnnotations () ;
            while ( fujaba__IterSubClassAnnotationsGeneralization7.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSubClassAnnotationsGeneralization7.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                  generalization7 = (GeneralizationAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between generalization7 and subClass
                  JavaSDM.ensure ( generalization7.hasInElements ("subClass", subClass) ) ;
                   
                  // bind intermediateClass: UMLClass
                  fujaba__IterGeneralization7ElementsIntermediateClass = generalization7.iteratorOfElements ("superClass") ;
                  while ( fujaba__IterGeneralization7ElementsIntermediateClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization7ElementsIntermediateClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        intermediateClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(subClass.equals (intermediateClass)) ) ;
                         
                        {
                           //  for each flow
                           set.add (intermediateClass);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            superClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind generalization8: GeneralizationAnnotation
            fujaba__IterSuperClassAnnotationsGeneralization8 = superClass.iteratorOfAnnotations () ;
            while ( fujaba__IterSuperClassAnnotationsGeneralization8.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterSuperClassAnnotationsGeneralization8.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                  generalization8 = (GeneralizationAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between generalization8 and superClass
                  JavaSDM.ensure ( generalization8.hasInElements ("superClass", superClass) ) ;
                   
                  // bind intermediateClass: UMLClass
                  fujaba__IterGeneralization8ElementsIntermediateClass = generalization8.iteratorOfElements ("subClass") ;
                  while ( fujaba__IterGeneralization8ElementsIntermediateClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization8ElementsIntermediateClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        intermediateClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(superClass.equals (intermediateClass)) ) ;
                         
                        {
                           //  for each flow
                           set.add (intermediateClass);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            subClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (subClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization8 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind intermediateClass: UMLClass
            fujaba__IterGeneralization8ElementsIntermediateClass = generalization8.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization8ElementsIntermediateClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization8ElementsIntermediateClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  intermediateClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (intermediateClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
