package de.upb.inferenceengine.engines;

import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.upb.javaast.methodast.MethodCallNode;
import de.upb.javaast.methodast.IdentifierNode;
import de.uni_paderborn.fujaba.uml.ASTRootNode;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.upb.javaast.methodast.LoopNode;

public class MultiNeighborCallEngine
extends GFRNEngine
{
   private  MultiNeighborCallEngine()
   {
   }

   private static MultiNeighborCallEngine theMultiNeighborCallEngine;

   public static MultiNeighborCallEngine get()
   {
      if (theMultiNeighborCallEngine == null)
      {
         theMultiNeighborCallEngine = new MultiNeighborCallEngine ();
      }
      return theMultiNeighborCallEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ASTPathVisitor fujaba__IterLoopToMethodCallNode10 = null ;
      ASTPathVisitor fujaba__IterLoopToMethodCallNode2 = null ;
      ASTPathVisitor fujaba__IterLoopToMethodCallNode4 = null ;
      ASTPathVisitor fujaba__IterLoopToMethodCallNode6 = null ;
      ASTPathVisitor fujaba__IterLoopToMethodCallNode8 = null ;
      ASTPathVisitor fujaba__IterRootToLoop = null ;
      de.uni_paderborn.fujaba.uml.ASTRootNode root = null ;
      Iterator fujaba__IterAttrAnnotationsMultiReference3 = null ;
      Iterator fujaba__IterAttrAnnotationsMultiReference9 = null ;
      Iterator fujaba__IterCalleeAnnotationsMultiNeighborCall = null ;
      Iterator fujaba__IterCalleeClassAnnotationsMultiNeighborCall = null ;
      Iterator fujaba__IterCalleeClassAnnotationsMultiReference5 = null ;
      Iterator fujaba__IterCalleeClassAnnotationsMultiReference7 = null ;
      Iterator fujaba__IterCalleeClassMethodsCallee = null ;
      Iterator fujaba__IterCallerAnnotationsMultiNeighborCall = null ;
      Iterator fujaba__IterCallerClassAttrsAttr = null ;
      Iterator fujaba__IterCallerClassMethodsCaller = null ;
      Iterator fujaba__IterMultiReference1ElementsAttr = null ;
      Iterator fujaba__IterMultiReference1ElementsCalleeClass = null ;
      Iterator fujaba__IterMultiReference3ElementsCalleeClass = null ;
      Iterator fujaba__IterMultiReference5ElementsAttr = null ;
      Iterator fujaba__IterMultiReference7ElementsAttr = null ;
      Iterator fujaba__IterMultiReference9ElementsCalleeClass = null ;
      de.upb.javaast.methodast.IdentifierNode id = null ;
      de.upb.javaast.methodast.LoopNode loop = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode10 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode2 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode4 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode6 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode8 = null ;
      MultiNeighborCallAnnotation multiNeighborCall = null ;
      MultiReferenceAnnotation multiReference1 = null ;
      MultiReferenceAnnotation multiReference3 = null ;
      MultiReferenceAnnotation multiReference5 = null ;
      MultiReferenceAnnotation multiReference7 = null ;
      MultiReferenceAnnotation multiReference9 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr attr = null ;
      de.uni_paderborn.fujaba.uml.UMLClass calleeClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass callerClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof MultiReferenceAnnotation ) ;
             
            // explicit type cast
            multiReference1 = (MultiReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind calleeClass: UMLClass
            fujaba__IterMultiReference1ElementsCalleeClass = multiReference1.iteratorOfElements ("references") ;
            while ( fujaba__IterMultiReference1ElementsCalleeClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterMultiReference1ElementsCalleeClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  // bind attr: UMLAttr
                  fujaba__IterMultiReference1ElementsAttr = multiReference1.iteratorOfElements ("field") ;
                  while ( fujaba__IterMultiReference1ElementsAttr.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterMultiReference1ElementsAttr.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        // bind callerClass: UMLClass
                        callerClass = attr.getParent () ;
                        JavaSDM.ensure ( callerClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(calleeClass.equals (callerClass)) ) ;
                         
                        // bind callee: UMLMethod
                        fujaba__IterCalleeClassMethodsCallee = calleeClass.iteratorOfMethods () ;
                        while ( fujaba__IterCalleeClassMethodsCallee.hasNext () )
                        {
                           try
                           {
                              callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCalleeClassMethodsCallee.next () ;
                               
                              // bind caller: UMLMethod
                              fujaba__IterCallerClassMethodsCaller = callerClass.iteratorOfMethods () ;
                              while ( fujaba__IterCallerClassMethodsCaller.hasNext () )
                              {
                                 try
                                 {
                                    caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCallerClassMethodsCaller.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                     
                                    // bind root: ASTRootNode
                                    root = caller.getASTRootNode () ;
                                    JavaSDM.ensure ( root != null ) ;
                                     
                                    // Path search between ASTRootNode and LoopNode
                                    // Bind loop : LoopNode
                                    fujaba__IterRootToLoop = new ASTPathVisitor (root, LoopNode.class ) ;
                                    while ( fujaba__IterRootToLoop.hasNext () )
                                    {
                                       try
                                       {
                                          loop = (de.upb.javaast.methodast.LoopNode) fujaba__IterRootToLoop.next () ;
                                           
                                          // Path search between LoopNode and MethodCallNode
                                          // Bind methodCallNode2 : MethodCallNode
                                          fujaba__IterLoopToMethodCallNode2 = new ASTPathVisitor (loop, MethodCallNode.class ) ;
                                          while ( fujaba__IterLoopToMethodCallNode2.hasNext () )
                                          {
                                             try
                                             {
                                                methodCallNode2 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterLoopToMethodCallNode2.next () ;
                                                 
                                                // bind id: IdentifierNode
                                                id = methodCallNode2.getIdentifier () ;
                                                JavaSDM.ensure ( id != null ) ;
                                                 
                                                // constraint
                                                JavaSDM.ensure ( id.getName().equals(callee.getName()) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object caller is really bound
                                                      JavaSDM.ensure ( caller != null ) ;
                                                       
                                                      // check object callee is really bound
                                                      JavaSDM.ensure ( callee != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                       
                                                      // check object callerClass is really bound
                                                      JavaSDM.ensure ( callerClass != null ) ;
                                                       
                                                      // check object calleeClass is really bound
                                                      JavaSDM.ensure ( calleeClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                       
                                                      // bind multiNeighborCall: MultiNeighborCallAnnotation
                                                      fujaba__IterCalleeClassAnnotationsMultiNeighborCall = calleeClass.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterCalleeClassAnnotationsMultiNeighborCall.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterCalleeClassAnnotationsMultiNeighborCall.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof MultiNeighborCallAnnotation ) ;
                                                            multiNeighborCall = (MultiNeighborCallAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between multiNeighborCall and calleeClass
                                                            JavaSDM.ensure ( multiNeighborCall.hasInElements ("calleeClass", calleeClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between multiNeighborCall and caller
                                                            JavaSDM.ensure ( multiNeighborCall.hasInElements ("caller", caller) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between multiNeighborCall and callee
                                                            JavaSDM.ensure ( multiNeighborCall.hasInElements ("callee", callee) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between multiNeighborCall and callerClass
                                                            JavaSDM.ensure ( multiNeighborCall.hasInElements ("callerClass", callerClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object caller is really bound
                                                         JavaSDM.ensure ( caller != null ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                          
                                                         // check object callerClass is really bound
                                                         JavaSDM.ensure ( callerClass != null ) ;
                                                          
                                                         // check object calleeClass is really bound
                                                         JavaSDM.ensure ( calleeClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                          
                                                         // check object id is really bound
                                                         JavaSDM.ensure ( id != null ) ;
                                                          
                                                         // check object loop is really bound
                                                         JavaSDM.ensure ( loop != null ) ;
                                                          
                                                         // check object root is really bound
                                                         JavaSDM.ensure ( root != null ) ;
                                                          
                                                         // check object attr is really bound
                                                         JavaSDM.ensure ( attr != null ) ;
                                                          
                                                         // create object
                                                         multiNeighborCall = new MultiNeighborCallAnnotation ( ) ;
                                                          
                                                         // create link
                                                         multiNeighborCall.addToElements ("caller", caller);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToElements ("callee", callee);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToElements ("callerClass", callerClass);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToElements ("calleeClass", calleeClass);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("caller", caller);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("id", id);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("loop", loop);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("root", root);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("calleeClass", calleeClass);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("callerClass", callerClass);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("attr", attr);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object multiReference1 is really bound
                                                         JavaSDM.ensure ( multiReference1 != null ) ;
                                                          
                                                         // check object multiNeighborCall is really bound
                                                         JavaSDM.ensure ( multiNeighborCall != null ) ;
                                                          
                                                         // create link
                                                         multiNeighborCall.addToAntecedentAnnos (multiReference1);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (multiNeighborCall) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiNeighborCall is really bound
            JavaSDM.ensure ( multiNeighborCall != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("caller", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind root: ASTRootNode
            root = caller.getASTRootNode () ;
            JavaSDM.ensure ( root != null ) ;
             
            // bind callerClass: UMLClass
            callerClass = caller.getParent () ;
            JavaSDM.ensure ( callerClass != null ) ;
             
            // bind attr: UMLAttr
            fujaba__IterCallerClassAttrsAttr = callerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCallerClassAttrsAttr.hasNext () )
            {
               try
               {
                  attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCallerClassAttrsAttr.next () ;
                   
                  // bind multiReference3: MultiReferenceAnnotation
                  fujaba__IterAttrAnnotationsMultiReference3 = attr.iteratorOfAnnotations () ;
                  while ( fujaba__IterAttrAnnotationsMultiReference3.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAttrAnnotationsMultiReference3.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                        multiReference3 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between multiReference3 and attr
                        JavaSDM.ensure ( multiReference3.hasInElements ("field", attr) ) ;
                         
                        // bind calleeClass: UMLClass
                        fujaba__IterMultiReference3ElementsCalleeClass = multiReference3.iteratorOfElements ("references") ;
                        while ( fujaba__IterMultiReference3ElementsCalleeClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMultiReference3ElementsCalleeClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                               
                              // bind callee: UMLMethod
                              fujaba__IterCalleeClassMethodsCallee = calleeClass.iteratorOfMethods () ;
                              while ( fujaba__IterCalleeClassMethodsCallee.hasNext () )
                              {
                                 try
                                 {
                                    callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCalleeClassMethodsCallee.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                     
                                    // Path search between ASTRootNode and LoopNode
                                    // Bind loop : LoopNode
                                    fujaba__IterRootToLoop = new ASTPathVisitor (root, LoopNode.class ) ;
                                    while ( fujaba__IterRootToLoop.hasNext () )
                                    {
                                       try
                                       {
                                          loop = (de.upb.javaast.methodast.LoopNode) fujaba__IterRootToLoop.next () ;
                                           
                                          // Path search between LoopNode and MethodCallNode
                                          // Bind methodCallNode4 : MethodCallNode
                                          fujaba__IterLoopToMethodCallNode4 = new ASTPathVisitor (loop, MethodCallNode.class ) ;
                                          while ( fujaba__IterLoopToMethodCallNode4.hasNext () )
                                          {
                                             try
                                             {
                                                methodCallNode4 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterLoopToMethodCallNode4.next () ;
                                                 
                                                // bind id: IdentifierNode
                                                id = methodCallNode4.getIdentifier () ;
                                                JavaSDM.ensure ( id != null ) ;
                                                 
                                                // constraint
                                                JavaSDM.ensure ( id.getName().equals(callee.getName()) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object caller is really bound
                                                      JavaSDM.ensure ( caller != null ) ;
                                                       
                                                      // check object callee is really bound
                                                      JavaSDM.ensure ( callee != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                       
                                                      // check object callerClass is really bound
                                                      JavaSDM.ensure ( callerClass != null ) ;
                                                       
                                                      // check object calleeClass is really bound
                                                      JavaSDM.ensure ( calleeClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                       
                                                      // bind multiNeighborCall: MultiNeighborCallAnnotation
                                                      fujaba__IterCalleeAnnotationsMultiNeighborCall = callee.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterCalleeAnnotationsMultiNeighborCall.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterCalleeAnnotationsMultiNeighborCall.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof MultiNeighborCallAnnotation ) ;
                                                            multiNeighborCall = (MultiNeighborCallAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between multiNeighborCall and callee
                                                            JavaSDM.ensure ( multiNeighborCall.hasInElements ("callee", callee) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between multiNeighborCall and caller
                                                            JavaSDM.ensure ( multiNeighborCall.hasInElements ("caller", caller) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between multiNeighborCall and callerClass
                                                            JavaSDM.ensure ( multiNeighborCall.hasInElements ("callerClass", callerClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between multiNeighborCall and calleeClass
                                                            JavaSDM.ensure ( multiNeighborCall.hasInElements ("calleeClass", calleeClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object caller is really bound
                                                         JavaSDM.ensure ( caller != null ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                          
                                                         // check object callerClass is really bound
                                                         JavaSDM.ensure ( callerClass != null ) ;
                                                          
                                                         // check object calleeClass is really bound
                                                         JavaSDM.ensure ( calleeClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                          
                                                         // check object id is really bound
                                                         JavaSDM.ensure ( id != null ) ;
                                                          
                                                         // check object loop is really bound
                                                         JavaSDM.ensure ( loop != null ) ;
                                                          
                                                         // check object root is really bound
                                                         JavaSDM.ensure ( root != null ) ;
                                                          
                                                         // check object attr is really bound
                                                         JavaSDM.ensure ( attr != null ) ;
                                                          
                                                         // create object
                                                         multiNeighborCall = new MultiNeighborCallAnnotation ( ) ;
                                                          
                                                         // create link
                                                         multiNeighborCall.addToElements ("caller", caller);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToElements ("callee", callee);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToElements ("callerClass", callerClass);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToElements ("calleeClass", calleeClass);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("caller", caller);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("id", id);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("loop", loop);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("root", root);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("calleeClass", calleeClass);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("callerClass", callerClass);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("attr", attr);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object multiReference3 is really bound
                                                         JavaSDM.ensure ( multiReference3 != null ) ;
                                                          
                                                         // check object multiNeighborCall is really bound
                                                         JavaSDM.ensure ( multiNeighborCall != null ) ;
                                                          
                                                         // create link
                                                         multiNeighborCall.addToAntecedentAnnos (multiReference3);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (multiNeighborCall) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiNeighborCall is really bound
            JavaSDM.ensure ( multiNeighborCall != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("caller", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("callee", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind calleeClass: UMLClass
            calleeClass = callee.getParent () ;
            JavaSDM.ensure ( calleeClass != null ) ;
             
            // bind multiReference5: MultiReferenceAnnotation
            fujaba__IterCalleeClassAnnotationsMultiReference5 = calleeClass.iteratorOfAnnotations () ;
            while ( fujaba__IterCalleeClassAnnotationsMultiReference5.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterCalleeClassAnnotationsMultiReference5.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                  multiReference5 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between multiReference5 and calleeClass
                  JavaSDM.ensure ( multiReference5.hasInElements ("references", calleeClass) ) ;
                   
                  // bind attr: UMLAttr
                  fujaba__IterMultiReference5ElementsAttr = multiReference5.iteratorOfElements ("field") ;
                  while ( fujaba__IterMultiReference5ElementsAttr.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterMultiReference5ElementsAttr.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        // bind callerClass: UMLClass
                        callerClass = attr.getParent () ;
                        JavaSDM.ensure ( callerClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(calleeClass.equals (callerClass)) ) ;
                         
                        // bind caller: UMLMethod
                        fujaba__IterCallerClassMethodsCaller = callerClass.iteratorOfMethods () ;
                        while ( fujaba__IterCallerClassMethodsCaller.hasNext () )
                        {
                           try
                           {
                              caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCallerClassMethodsCaller.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                               
                              // bind root: ASTRootNode
                              root = caller.getASTRootNode () ;
                              JavaSDM.ensure ( root != null ) ;
                               
                              // Path search between ASTRootNode and LoopNode
                              // Bind loop : LoopNode
                              fujaba__IterRootToLoop = new ASTPathVisitor (root, LoopNode.class ) ;
                              while ( fujaba__IterRootToLoop.hasNext () )
                              {
                                 try
                                 {
                                    loop = (de.upb.javaast.methodast.LoopNode) fujaba__IterRootToLoop.next () ;
                                     
                                    // Path search between LoopNode and MethodCallNode
                                    // Bind methodCallNode6 : MethodCallNode
                                    fujaba__IterLoopToMethodCallNode6 = new ASTPathVisitor (loop, MethodCallNode.class ) ;
                                    while ( fujaba__IterLoopToMethodCallNode6.hasNext () )
                                    {
                                       try
                                       {
                                          methodCallNode6 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterLoopToMethodCallNode6.next () ;
                                           
                                          // bind id: IdentifierNode
                                          id = methodCallNode6.getIdentifier () ;
                                          JavaSDM.ensure ( id != null ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id.getName().equals(callee.getName()) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object caller is really bound
                                                JavaSDM.ensure ( caller != null ) ;
                                                 
                                                // check object callee is really bound
                                                JavaSDM.ensure ( callee != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                 
                                                // check object callerClass is really bound
                                                JavaSDM.ensure ( callerClass != null ) ;
                                                 
                                                // check object calleeClass is really bound
                                                JavaSDM.ensure ( calleeClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                 
                                                // bind multiNeighborCall: MultiNeighborCallAnnotation
                                                fujaba__IterCallerAnnotationsMultiNeighborCall = caller.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterCallerAnnotationsMultiNeighborCall.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterCallerAnnotationsMultiNeighborCall.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof MultiNeighborCallAnnotation ) ;
                                                      multiNeighborCall = (MultiNeighborCallAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between multiNeighborCall and caller
                                                      JavaSDM.ensure ( multiNeighborCall.hasInElements ("caller", caller) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between multiNeighborCall and callee
                                                      JavaSDM.ensure ( multiNeighborCall.hasInElements ("callee", callee) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between multiNeighborCall and callerClass
                                                      JavaSDM.ensure ( multiNeighborCall.hasInElements ("callerClass", callerClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between multiNeighborCall and calleeClass
                                                      JavaSDM.ensure ( multiNeighborCall.hasInElements ("calleeClass", calleeClass) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object caller is really bound
                                                   JavaSDM.ensure ( caller != null ) ;
                                                    
                                                   // check object callee is really bound
                                                   JavaSDM.ensure ( callee != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                    
                                                   // check object callerClass is really bound
                                                   JavaSDM.ensure ( callerClass != null ) ;
                                                    
                                                   // check object calleeClass is really bound
                                                   JavaSDM.ensure ( calleeClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                    
                                                   // check object id is really bound
                                                   JavaSDM.ensure ( id != null ) ;
                                                    
                                                   // check object loop is really bound
                                                   JavaSDM.ensure ( loop != null ) ;
                                                    
                                                   // check object root is really bound
                                                   JavaSDM.ensure ( root != null ) ;
                                                    
                                                   // check object attr is really bound
                                                   JavaSDM.ensure ( attr != null ) ;
                                                    
                                                   // create object
                                                   multiNeighborCall = new MultiNeighborCallAnnotation ( ) ;
                                                    
                                                   // create link
                                                   multiNeighborCall.addToElements ("caller", caller);
                                                    
                                                   // create link
                                                   multiNeighborCall.addToElements ("callee", callee);
                                                    
                                                   // create link
                                                   multiNeighborCall.addToElements ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   multiNeighborCall.addToElements ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   multiNeighborCall.addToBoundObjects ("caller", caller);
                                                    
                                                   // create link
                                                   multiNeighborCall.addToBoundObjects ("id", id);
                                                    
                                                   // create link
                                                   multiNeighborCall.addToBoundObjects ("loop", loop);
                                                    
                                                   // create link
                                                   multiNeighborCall.addToBoundObjects ("root", root);
                                                    
                                                   // create link
                                                   multiNeighborCall.addToBoundObjects ("callee", callee);
                                                    
                                                   // create link
                                                   multiNeighborCall.addToBoundObjects ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   multiNeighborCall.addToBoundObjects ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   multiNeighborCall.addToBoundObjects ("attr", attr);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object multiReference5 is really bound
                                                   JavaSDM.ensure ( multiReference5 != null ) ;
                                                    
                                                   // check object multiNeighborCall is really bound
                                                   JavaSDM.ensure ( multiNeighborCall != null ) ;
                                                    
                                                   // create link
                                                   multiNeighborCall.addToAntecedentAnnos (multiReference5);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (multiNeighborCall) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiNeighborCall is really bound
            JavaSDM.ensure ( multiNeighborCall != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("callee", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("calleeClass", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterCalleeClassMethodsCallee = calleeClass.iteratorOfMethods () ;
            while ( fujaba__IterCalleeClassMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCalleeClassMethodsCallee.next () ;
                   
                  // bind multiReference7: MultiReferenceAnnotation
                  fujaba__IterCalleeClassAnnotationsMultiReference7 = calleeClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterCalleeClassAnnotationsMultiReference7.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterCalleeClassAnnotationsMultiReference7.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                        multiReference7 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between multiReference7 and calleeClass
                        JavaSDM.ensure ( multiReference7.hasInElements ("references", calleeClass) ) ;
                         
                        // bind attr: UMLAttr
                        fujaba__IterMultiReference7ElementsAttr = multiReference7.iteratorOfElements ("field") ;
                        while ( fujaba__IterMultiReference7ElementsAttr.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMultiReference7ElementsAttr.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                              attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                               
                              // bind callerClass: UMLClass
                              callerClass = attr.getParent () ;
                              JavaSDM.ensure ( callerClass != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(calleeClass.equals (callerClass)) ) ;
                               
                              // bind caller: UMLMethod
                              fujaba__IterCallerClassMethodsCaller = callerClass.iteratorOfMethods () ;
                              while ( fujaba__IterCallerClassMethodsCaller.hasNext () )
                              {
                                 try
                                 {
                                    caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCallerClassMethodsCaller.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                     
                                    // bind root: ASTRootNode
                                    root = caller.getASTRootNode () ;
                                    JavaSDM.ensure ( root != null ) ;
                                     
                                    // Path search between ASTRootNode and LoopNode
                                    // Bind loop : LoopNode
                                    fujaba__IterRootToLoop = new ASTPathVisitor (root, LoopNode.class ) ;
                                    while ( fujaba__IterRootToLoop.hasNext () )
                                    {
                                       try
                                       {
                                          loop = (de.upb.javaast.methodast.LoopNode) fujaba__IterRootToLoop.next () ;
                                           
                                          // Path search between LoopNode and MethodCallNode
                                          // Bind methodCallNode8 : MethodCallNode
                                          fujaba__IterLoopToMethodCallNode8 = new ASTPathVisitor (loop, MethodCallNode.class ) ;
                                          while ( fujaba__IterLoopToMethodCallNode8.hasNext () )
                                          {
                                             try
                                             {
                                                methodCallNode8 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterLoopToMethodCallNode8.next () ;
                                                 
                                                // bind id: IdentifierNode
                                                id = methodCallNode8.getIdentifier () ;
                                                JavaSDM.ensure ( id != null ) ;
                                                 
                                                // constraint
                                                JavaSDM.ensure ( id.getName().equals(callee.getName()) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object caller is really bound
                                                      JavaSDM.ensure ( caller != null ) ;
                                                       
                                                      // check object callee is really bound
                                                      JavaSDM.ensure ( callee != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                       
                                                      // check object callerClass is really bound
                                                      JavaSDM.ensure ( callerClass != null ) ;
                                                       
                                                      // check object calleeClass is really bound
                                                      JavaSDM.ensure ( calleeClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                       
                                                      // bind multiNeighborCall: MultiNeighborCallAnnotation
                                                      fujaba__IterCallerAnnotationsMultiNeighborCall = caller.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterCallerAnnotationsMultiNeighborCall.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterCallerAnnotationsMultiNeighborCall.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof MultiNeighborCallAnnotation ) ;
                                                            multiNeighborCall = (MultiNeighborCallAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between multiNeighborCall and caller
                                                            JavaSDM.ensure ( multiNeighborCall.hasInElements ("caller", caller) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between multiNeighborCall and callee
                                                            JavaSDM.ensure ( multiNeighborCall.hasInElements ("callee", callee) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between multiNeighborCall and callerClass
                                                            JavaSDM.ensure ( multiNeighborCall.hasInElements ("callerClass", callerClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between multiNeighborCall and calleeClass
                                                            JavaSDM.ensure ( multiNeighborCall.hasInElements ("calleeClass", calleeClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object caller is really bound
                                                         JavaSDM.ensure ( caller != null ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                          
                                                         // check object callerClass is really bound
                                                         JavaSDM.ensure ( callerClass != null ) ;
                                                          
                                                         // check object calleeClass is really bound
                                                         JavaSDM.ensure ( calleeClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                          
                                                         // check object id is really bound
                                                         JavaSDM.ensure ( id != null ) ;
                                                          
                                                         // check object loop is really bound
                                                         JavaSDM.ensure ( loop != null ) ;
                                                          
                                                         // check object root is really bound
                                                         JavaSDM.ensure ( root != null ) ;
                                                          
                                                         // check object attr is really bound
                                                         JavaSDM.ensure ( attr != null ) ;
                                                          
                                                         // create object
                                                         multiNeighborCall = new MultiNeighborCallAnnotation ( ) ;
                                                          
                                                         // create link
                                                         multiNeighborCall.addToElements ("caller", caller);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToElements ("callee", callee);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToElements ("callerClass", callerClass);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToElements ("calleeClass", calleeClass);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("caller", caller);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("id", id);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("loop", loop);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("root", root);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("calleeClass", calleeClass);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("callerClass", callerClass);
                                                          
                                                         // create link
                                                         multiNeighborCall.addToBoundObjects ("attr", attr);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object multiReference7 is really bound
                                                         JavaSDM.ensure ( multiReference7 != null ) ;
                                                          
                                                         // check object multiNeighborCall is really bound
                                                         JavaSDM.ensure ( multiNeighborCall != null ) ;
                                                          
                                                         // create link
                                                         multiNeighborCall.addToAntecedentAnnos (multiReference7);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (multiNeighborCall) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiNeighborCall is really bound
            JavaSDM.ensure ( multiNeighborCall != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("calleeClass", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("callerClass", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            callerClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind attr: UMLAttr
            fujaba__IterCallerClassAttrsAttr = callerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCallerClassAttrsAttr.hasNext () )
            {
               try
               {
                  attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCallerClassAttrsAttr.next () ;
                   
                  // bind caller: UMLMethod
                  fujaba__IterCallerClassMethodsCaller = callerClass.iteratorOfMethods () ;
                  while ( fujaba__IterCallerClassMethodsCaller.hasNext () )
                  {
                     try
                     {
                        caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCallerClassMethodsCaller.next () ;
                         
                        // bind root: ASTRootNode
                        root = caller.getASTRootNode () ;
                        JavaSDM.ensure ( root != null ) ;
                         
                        // bind multiReference9: MultiReferenceAnnotation
                        fujaba__IterAttrAnnotationsMultiReference9 = attr.iteratorOfAnnotations () ;
                        while ( fujaba__IterAttrAnnotationsMultiReference9.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAttrAnnotationsMultiReference9.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                              multiReference9 = (MultiReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between multiReference9 and attr
                              JavaSDM.ensure ( multiReference9.hasInElements ("field", attr) ) ;
                               
                              // bind calleeClass: UMLClass
                              fujaba__IterMultiReference9ElementsCalleeClass = multiReference9.iteratorOfElements ("references") ;
                              while ( fujaba__IterMultiReference9ElementsCalleeClass.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterMultiReference9ElementsCalleeClass.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                     
                                    // bind callee: UMLMethod
                                    fujaba__IterCalleeClassMethodsCallee = calleeClass.iteratorOfMethods () ;
                                    while ( fujaba__IterCalleeClassMethodsCallee.hasNext () )
                                    {
                                       try
                                       {
                                          callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCalleeClassMethodsCallee.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                           
                                          // Path search between ASTRootNode and LoopNode
                                          // Bind loop : LoopNode
                                          fujaba__IterRootToLoop = new ASTPathVisitor (root, LoopNode.class ) ;
                                          while ( fujaba__IterRootToLoop.hasNext () )
                                          {
                                             try
                                             {
                                                loop = (de.upb.javaast.methodast.LoopNode) fujaba__IterRootToLoop.next () ;
                                                 
                                                // Path search between LoopNode and MethodCallNode
                                                // Bind methodCallNode10 : MethodCallNode
                                                fujaba__IterLoopToMethodCallNode10 = new ASTPathVisitor (loop, MethodCallNode.class ) ;
                                                while ( fujaba__IterLoopToMethodCallNode10.hasNext () )
                                                {
                                                   try
                                                   {
                                                      methodCallNode10 = (de.upb.javaast.methodast.MethodCallNode) fujaba__IterLoopToMethodCallNode10.next () ;
                                                       
                                                      // bind id: IdentifierNode
                                                      id = methodCallNode10.getIdentifier () ;
                                                      JavaSDM.ensure ( id != null ) ;
                                                       
                                                      // constraint
                                                      JavaSDM.ensure ( id.getName().equals(callee.getName()) ) ;
                                                       
                                                      {
                                                         //  for each flow
                                                         try
                                                         {
                                                            fujaba__Success = false ;
                                                             
                                                            // check object caller is really bound
                                                            JavaSDM.ensure ( caller != null ) ;
                                                             
                                                            // check object callee is really bound
                                                            JavaSDM.ensure ( callee != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                             
                                                            // check object callerClass is really bound
                                                            JavaSDM.ensure ( callerClass != null ) ;
                                                             
                                                            // check object calleeClass is really bound
                                                            JavaSDM.ensure ( calleeClass != null ) ;
                                                             
                                                            // check isomorphic binding
                                                            JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                             
                                                            // bind multiNeighborCall: MultiNeighborCallAnnotation
                                                            fujaba__IterCalleeClassAnnotationsMultiNeighborCall = calleeClass.iteratorOfAnnotations () ;
                                                            while ( !(fujaba__Success) && fujaba__IterCalleeClassAnnotationsMultiNeighborCall.hasNext () )
                                                            {
                                                               try
                                                               {
                                                                  fujaba__TmpObject = fujaba__IterCalleeClassAnnotationsMultiNeighborCall.next () ;
                                                                  JavaSDM.ensure ( fujaba__TmpObject instanceof MultiNeighborCallAnnotation ) ;
                                                                  multiNeighborCall = (MultiNeighborCallAnnotation) fujaba__TmpObject ;
                                                                   
                                                                  // check Reverse-Qualified-Link 'elements' between multiNeighborCall and calleeClass
                                                                  JavaSDM.ensure ( multiNeighborCall.hasInElements ("calleeClass", calleeClass) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between multiNeighborCall and caller
                                                                  JavaSDM.ensure ( multiNeighborCall.hasInElements ("caller", caller) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between multiNeighborCall and callee
                                                                  JavaSDM.ensure ( multiNeighborCall.hasInElements ("callee", callee) ) ;
                                                                   
                                                                  // check To-Many-Link 'elements' between multiNeighborCall and callerClass
                                                                  JavaSDM.ensure ( multiNeighborCall.hasInElements ("callerClass", callerClass) ) ;
                                                                   
                                                                  fujaba__Success = true ;
                                                               }
                                                               catch ( JavaSDMException fujaba__InternalException )
                                                               {
                                                               }
                                                            }
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                            fujaba__Success = false ;
                                                         }
                                                          
                                                         if ( !(fujaba__Success) )
                                                         {
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object caller is really bound
                                                               JavaSDM.ensure ( caller != null ) ;
                                                                
                                                               // check object callee is really bound
                                                               JavaSDM.ensure ( callee != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                                
                                                               // check object callerClass is really bound
                                                               JavaSDM.ensure ( callerClass != null ) ;
                                                                
                                                               // check object calleeClass is really bound
                                                               JavaSDM.ensure ( calleeClass != null ) ;
                                                                
                                                               // check isomorphic binding
                                                               JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                                
                                                               // check object id is really bound
                                                               JavaSDM.ensure ( id != null ) ;
                                                                
                                                               // check object loop is really bound
                                                               JavaSDM.ensure ( loop != null ) ;
                                                                
                                                               // check object root is really bound
                                                               JavaSDM.ensure ( root != null ) ;
                                                                
                                                               // check object attr is really bound
                                                               JavaSDM.ensure ( attr != null ) ;
                                                                
                                                               // create object
                                                               multiNeighborCall = new MultiNeighborCallAnnotation ( ) ;
                                                                
                                                               // create link
                                                               multiNeighborCall.addToElements ("caller", caller);
                                                                
                                                               // create link
                                                               multiNeighborCall.addToElements ("callee", callee);
                                                                
                                                               // create link
                                                               multiNeighborCall.addToElements ("callerClass", callerClass);
                                                                
                                                               // create link
                                                               multiNeighborCall.addToElements ("calleeClass", calleeClass);
                                                                
                                                               // create link
                                                               multiNeighborCall.addToBoundObjects ("caller", caller);
                                                                
                                                               // create link
                                                               multiNeighborCall.addToBoundObjects ("id", id);
                                                                
                                                               // create link
                                                               multiNeighborCall.addToBoundObjects ("loop", loop);
                                                                
                                                               // create link
                                                               multiNeighborCall.addToBoundObjects ("root", root);
                                                                
                                                               // create link
                                                               multiNeighborCall.addToBoundObjects ("callee", callee);
                                                                
                                                               // create link
                                                               multiNeighborCall.addToBoundObjects ("calleeClass", calleeClass);
                                                                
                                                               // create link
                                                               multiNeighborCall.addToBoundObjects ("callerClass", callerClass);
                                                                
                                                               // create link
                                                               multiNeighborCall.addToBoundObjects ("attr", attr);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            try
                                                            {
                                                               fujaba__Success = false ;
                                                                
                                                               // check object multiReference9 is really bound
                                                               JavaSDM.ensure ( multiReference9 != null ) ;
                                                                
                                                               // check object multiNeighborCall is really bound
                                                               JavaSDM.ensure ( multiNeighborCall != null ) ;
                                                                
                                                               // create link
                                                               multiNeighborCall.addToAntecedentAnnos (multiReference9);
                                                                
                                                               fujaba__Success = true ;
                                                            }
                                                            catch ( JavaSDMException fujaba__InternalException )
                                                            {
                                                               fujaba__Success = false ;
                                                            }
                                                             
                                                            return (multiNeighborCall) ;
                                                         }
                                                      } //  end for each flow
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiNeighborCall is really bound
            JavaSDM.ensure ( multiNeighborCall != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("callerClass", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (multiNeighborCall) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("caller", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("callee", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("callerClass", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("calleeClass", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof MultiReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterCallerClassAttrsAttr = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr attr = null ;
      de.uni_paderborn.fujaba.uml.UMLClass calleeClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass callerClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("MultiReference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind callerClass: UMLClass
            callerClass = caller.getParent () ;
            JavaSDM.ensure ( callerClass != null ) ;
             
            // bind attr: UMLAttr
            fujaba__IterCallerClassAttrsAttr = callerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCallerClassAttrsAttr.hasNext () )
            {
               try
               {
                  attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCallerClassAttrsAttr.next () ;
                   
                  {
                     //  for each flow
                     set.add (attr);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind calleeClass: UMLClass
            calleeClass = callee.getParent () ;
            JavaSDM.ensure ( calleeClass != null ) ;
             
            {
               //  for each flow
               set.add (calleeClass);
            } //  end for each flow
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            callerClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind attr: UMLAttr
            fujaba__IterCallerClassAttrsAttr = callerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCallerClassAttrsAttr.hasNext () )
            {
               try
               {
                  attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCallerClassAttrsAttr.next () ;
                   
                  {
                     //  for each flow
                     set.add (attr);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (calleeClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
