package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLType;

public class OverridingMethodEngine
extends GFRNEngine
{
   private  OverridingMethodEngine()
   {
   }

   private static OverridingMethodEngine theOverridingMethodEngine;

   public static OverridingMethodEngine get()
   {
      if (theOverridingMethodEngine == null)
      {
         theOverridingMethodEngine = new OverridingMethodEngine ();
      }
      return theOverridingMethodEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterGeneralization6ElementsSubClass = null ;
      Iterator fujaba__IterGeneralization6ElementsSuperClass = null ;
      Iterator fujaba__IterOverriddenAnnotationsOverridingMethod = null ;
      Iterator fujaba__IterOverridingAnnotationsOverridingMethod = null ;
      Iterator fujaba__IterSubClassAnnotationsGeneralization2 = null ;
      Iterator fujaba__IterSubClassMethodsOverriding = null ;
      Iterator fujaba__IterSuperClassAnnotationsGeneralization4 = null ;
      Iterator fujaba__IterSuperClassMethodsOverridden = null ;
      Iterator fujaba__IterUMLType1RevResultTypeOverridden = null ;
      Iterator fujaba__IterUMLType3RevResultTypeOverriding = null ;
      GeneralizationAnnotation generalization2 = null ;
      GeneralizationAnnotation generalization4 = null ;
      GeneralizationAnnotation generalization6 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OverridingMethodAnnotation overridingMethod = null ;
      de.uni_paderborn.fujaba.uml.UMLClass subClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass superClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod overridden = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod overriding = null ;
      de.uni_paderborn.fujaba.uml.UMLType uMLType1 = null ;
      de.uni_paderborn.fujaba.uml.UMLType uMLType3 = null ;
      de.uni_paderborn.fujaba.uml.UMLType uMLType5 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("overriding", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            overriding = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind uMLType1: UMLType
            uMLType1 = overriding.getResultType () ;
            JavaSDM.ensure ( uMLType1 != null ) ;
             
            // bind subClass: UMLClass
            subClass = overriding.getParent () ;
            JavaSDM.ensure ( subClass != null ) ;
             
            // check isomorphic binding
            JavaSDM.ensure ( !(uMLType1.equals (subClass)) ) ;
             
            // bind overridden: UMLMethod
            fujaba__IterUMLType1RevResultTypeOverridden = uMLType1.iteratorOfRevResultType () ;
            while ( fujaba__IterUMLType1RevResultTypeOverridden.hasNext () )
            {
               try
               {
                  overridden = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterUMLType1RevResultTypeOverridden.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (overridden.getVisibility () != UMLMethod.PRIVATE) ) ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(overriding.equals (overridden)) ) ;
                   
                  // bind superClass: UMLClass
                  superClass = overridden.getParent () ;
                  JavaSDM.ensure ( superClass != null ) ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(subClass.equals (superClass)) && !(uMLType1.equals (superClass)) ) ;
                   
                  // bind generalization2: GeneralizationAnnotation
                  fujaba__IterSubClassAnnotationsGeneralization2 = subClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterSubClassAnnotationsGeneralization2.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterSubClassAnnotationsGeneralization2.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization2 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization2 and subClass
                        JavaSDM.ensure ( generalization2.hasInElements ("subClass", subClass) ) ;
                         
                        // check To-Many-Link 'elements' between generalization2 and superClass
                        JavaSDM.ensure ( generalization2.hasInElements ("superClass", superClass) ) ;
                         
                        // constraint
                        JavaSDM.ensure ( overriding.getFullMethodName().equals(overridden.getFullMethodName()) ) ;
                         
                        // constraint
                        JavaSDM.ensure ( overriding.getVisibility() == overridden.getVisibility() ) ;
                         
                        {
                           //  for each flow
                           try
                           {
                              fujaba__Success = false ;
                               
                              // check object overriding is really bound
                              JavaSDM.ensure ( overriding != null ) ;
                               
                              // check object overridden is really bound
                              JavaSDM.ensure ( overridden != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(overriding.equals (overridden)) ) ;
                               
                              // bind overridingMethod: OverridingMethodAnnotation
                              fujaba__IterOverridingAnnotationsOverridingMethod = overriding.iteratorOfAnnotations () ;
                              while ( !(fujaba__Success) && fujaba__IterOverridingAnnotationsOverridingMethod.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterOverridingAnnotationsOverridingMethod.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                    overridingMethod = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between overridingMethod and overriding
                                    JavaSDM.ensure ( overridingMethod.hasInElements ("overriding", overriding) ) ;
                                     
                                    // check To-Many-Link 'elements' between overridingMethod and overridden
                                    JavaSDM.ensure ( overridingMethod.hasInElements ("overridden", overridden) ) ;
                                     
                                    fujaba__Success = true ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           if ( !(fujaba__Success) )
                           {
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object overriding is really bound
                                 JavaSDM.ensure ( overriding != null ) ;
                                  
                                 // check object overridden is really bound
                                 JavaSDM.ensure ( overridden != null ) ;
                                  
                                 // check isomorphic binding
                                 JavaSDM.ensure ( !(overriding.equals (overridden)) ) ;
                                  
                                 // check object subClass is really bound
                                 JavaSDM.ensure ( subClass != null ) ;
                                  
                                 // check object superClass is really bound
                                 JavaSDM.ensure ( superClass != null ) ;
                                  
                                 // check isomorphic binding
                                 JavaSDM.ensure ( !(subClass.equals (superClass)) ) ;
                                  
                                 // create object
                                 overridingMethod = new OverridingMethodAnnotation ( ) ;
                                  
                                 // create link
                                 overridingMethod.addToElements ("overriding", overriding);
                                  
                                 // create link
                                 overridingMethod.addToElements ("overridden", overridden);
                                  
                                 // create link
                                 overridingMethod.addToBoundObjects ("subClass", subClass);
                                  
                                 // create link
                                 overridingMethod.addToBoundObjects ("overriding", overriding);
                                  
                                 // create link
                                 overridingMethod.addToBoundObjects ("overridden", overridden);
                                  
                                 // create link
                                 overridingMethod.addToBoundObjects ("superClass", superClass);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object generalization2 is really bound
                                 JavaSDM.ensure ( generalization2 != null ) ;
                                  
                                 // check object overridingMethod is really bound
                                 JavaSDM.ensure ( overridingMethod != null ) ;
                                  
                                 // create link
                                 overridingMethod.addToAntecedentAnnos (generalization2);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              return (overridingMethod) ;
                           }
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object overridingMethod is really bound
            JavaSDM.ensure ( overridingMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("overriding", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("overridden", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            overridden = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // attribute condition
            JavaSDM.ensure ( (overridden.getVisibility () != UMLMethod.PRIVATE) ) ;
             
            // bind uMLType3: UMLType
            uMLType3 = overridden.getResultType () ;
            JavaSDM.ensure ( uMLType3 != null ) ;
             
            // bind superClass: UMLClass
            superClass = overridden.getParent () ;
            JavaSDM.ensure ( superClass != null ) ;
             
            // check isomorphic binding
            JavaSDM.ensure ( !(uMLType3.equals (superClass)) ) ;
             
            // bind overriding: UMLMethod
            fujaba__IterUMLType3RevResultTypeOverriding = uMLType3.iteratorOfRevResultType () ;
            while ( fujaba__IterUMLType3RevResultTypeOverriding.hasNext () )
            {
               try
               {
                  overriding = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterUMLType3RevResultTypeOverriding.next () ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(overridden.equals (overriding)) ) ;
                   
                  // bind subClass: UMLClass
                  subClass = overriding.getParent () ;
                  JavaSDM.ensure ( subClass != null ) ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(uMLType3.equals (subClass)) && !(superClass.equals (subClass)) ) ;
                   
                  // bind generalization4: GeneralizationAnnotation
                  fujaba__IterSuperClassAnnotationsGeneralization4 = superClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterSuperClassAnnotationsGeneralization4.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterSuperClassAnnotationsGeneralization4.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                        generalization4 = (GeneralizationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between generalization4 and superClass
                        JavaSDM.ensure ( generalization4.hasInElements ("superClass", superClass) ) ;
                         
                        // check To-Many-Link 'elements' between generalization4 and subClass
                        JavaSDM.ensure ( generalization4.hasInElements ("subClass", subClass) ) ;
                         
                        // constraint
                        JavaSDM.ensure ( overriding.getFullMethodName().equals(overridden.getFullMethodName()) ) ;
                         
                        // constraint
                        JavaSDM.ensure ( overriding.getVisibility() == overridden.getVisibility() ) ;
                         
                        {
                           //  for each flow
                           try
                           {
                              fujaba__Success = false ;
                               
                              // check object overriding is really bound
                              JavaSDM.ensure ( overriding != null ) ;
                               
                              // check object overridden is really bound
                              JavaSDM.ensure ( overridden != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(overriding.equals (overridden)) ) ;
                               
                              // bind overridingMethod: OverridingMethodAnnotation
                              fujaba__IterOverriddenAnnotationsOverridingMethod = overridden.iteratorOfAnnotations () ;
                              while ( !(fujaba__Success) && fujaba__IterOverriddenAnnotationsOverridingMethod.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterOverriddenAnnotationsOverridingMethod.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                    overridingMethod = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between overridingMethod and overridden
                                    JavaSDM.ensure ( overridingMethod.hasInElements ("overridden", overridden) ) ;
                                     
                                    // check To-Many-Link 'elements' between overridingMethod and overriding
                                    JavaSDM.ensure ( overridingMethod.hasInElements ("overriding", overriding) ) ;
                                     
                                    fujaba__Success = true ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           if ( !(fujaba__Success) )
                           {
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object overriding is really bound
                                 JavaSDM.ensure ( overriding != null ) ;
                                  
                                 // check object overridden is really bound
                                 JavaSDM.ensure ( overridden != null ) ;
                                  
                                 // check isomorphic binding
                                 JavaSDM.ensure ( !(overriding.equals (overridden)) ) ;
                                  
                                 // check object subClass is really bound
                                 JavaSDM.ensure ( subClass != null ) ;
                                  
                                 // check object superClass is really bound
                                 JavaSDM.ensure ( superClass != null ) ;
                                  
                                 // check isomorphic binding
                                 JavaSDM.ensure ( !(subClass.equals (superClass)) ) ;
                                  
                                 // create object
                                 overridingMethod = new OverridingMethodAnnotation ( ) ;
                                  
                                 // create link
                                 overridingMethod.addToElements ("overriding", overriding);
                                  
                                 // create link
                                 overridingMethod.addToElements ("overridden", overridden);
                                  
                                 // create link
                                 overridingMethod.addToBoundObjects ("subClass", subClass);
                                  
                                 // create link
                                 overridingMethod.addToBoundObjects ("overriding", overriding);
                                  
                                 // create link
                                 overridingMethod.addToBoundObjects ("overridden", overridden);
                                  
                                 // create link
                                 overridingMethod.addToBoundObjects ("superClass", superClass);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object generalization4 is really bound
                                 JavaSDM.ensure ( generalization4 != null ) ;
                                  
                                 // check object overridingMethod is really bound
                                 JavaSDM.ensure ( overridingMethod != null ) ;
                                  
                                 // create link
                                 overridingMethod.addToAntecedentAnnos (generalization4);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              return (overridingMethod) ;
                           }
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object overridingMethod is really bound
            JavaSDM.ensure ( overridingMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("overridden", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof GeneralizationAnnotation ) ;
             
            // explicit type cast
            generalization6 = (GeneralizationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind subClass: UMLClass
            fujaba__IterGeneralization6ElementsSubClass = generalization6.iteratorOfElements ("subClass") ;
            while ( fujaba__IterGeneralization6ElementsSubClass.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterGeneralization6ElementsSubClass.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  subClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  // bind superClass: UMLClass
                  fujaba__IterGeneralization6ElementsSuperClass = generalization6.iteratorOfElements ("superClass") ;
                  while ( fujaba__IterGeneralization6ElementsSuperClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterGeneralization6ElementsSuperClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        superClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(subClass.equals (superClass)) ) ;
                         
                        // bind overriding: UMLMethod
                        fujaba__IterSubClassMethodsOverriding = subClass.iteratorOfMethods () ;
                        while ( fujaba__IterSubClassMethodsOverriding.hasNext () )
                        {
                           try
                           {
                              overriding = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterSubClassMethodsOverriding.next () ;
                               
                              // bind uMLType5: UMLType
                              uMLType5 = overriding.getResultType () ;
                              JavaSDM.ensure ( uMLType5 != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(subClass.equals (uMLType5)) && !(superClass.equals (uMLType5)) ) ;
                               
                              // bind overridden: UMLMethod
                              fujaba__IterSuperClassMethodsOverridden = superClass.iteratorOfMethods () ;
                              while ( fujaba__IterSuperClassMethodsOverridden.hasNext () )
                              {
                                 try
                                 {
                                    overridden = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterSuperClassMethodsOverridden.next () ;
                                     
                                    // attribute condition
                                    JavaSDM.ensure ( (overridden.getVisibility () != UMLMethod.PRIVATE) ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(overriding.equals (overridden)) ) ;
                                     
                                    // check To-One-Link 'resultType' between overridden and uMLType5
                                    JavaSDM.ensure ( (overridden.getResultType () != null) && overridden.getResultType ().equals (uMLType5) ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( overriding.getFullMethodName().equals(overridden.getFullMethodName()) ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( overriding.getVisibility() == overridden.getVisibility() ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object overriding is really bound
                                          JavaSDM.ensure ( overriding != null ) ;
                                           
                                          // check object overridden is really bound
                                          JavaSDM.ensure ( overridden != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(overriding.equals (overridden)) ) ;
                                           
                                          // bind overridingMethod: OverridingMethodAnnotation
                                          fujaba__IterOverridingAnnotationsOverridingMethod = overriding.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterOverridingAnnotationsOverridingMethod.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterOverridingAnnotationsOverridingMethod.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof OverridingMethodAnnotation ) ;
                                                overridingMethod = (OverridingMethodAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between overridingMethod and overriding
                                                JavaSDM.ensure ( overridingMethod.hasInElements ("overriding", overriding) ) ;
                                                 
                                                // check To-Many-Link 'elements' between overridingMethod and overridden
                                                JavaSDM.ensure ( overridingMethod.hasInElements ("overridden", overridden) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object overriding is really bound
                                             JavaSDM.ensure ( overriding != null ) ;
                                              
                                             // check object overridden is really bound
                                             JavaSDM.ensure ( overridden != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(overriding.equals (overridden)) ) ;
                                              
                                             // check object subClass is really bound
                                             JavaSDM.ensure ( subClass != null ) ;
                                              
                                             // check object superClass is really bound
                                             JavaSDM.ensure ( superClass != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(subClass.equals (superClass)) ) ;
                                              
                                             // create object
                                             overridingMethod = new OverridingMethodAnnotation ( ) ;
                                              
                                             // create link
                                             overridingMethod.addToElements ("overriding", overriding);
                                              
                                             // create link
                                             overridingMethod.addToElements ("overridden", overridden);
                                              
                                             // create link
                                             overridingMethod.addToBoundObjects ("subClass", subClass);
                                              
                                             // create link
                                             overridingMethod.addToBoundObjects ("overriding", overriding);
                                              
                                             // create link
                                             overridingMethod.addToBoundObjects ("overridden", overridden);
                                              
                                             // create link
                                             overridingMethod.addToBoundObjects ("superClass", superClass);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object generalization6 is really bound
                                             JavaSDM.ensure ( generalization6 != null ) ;
                                              
                                             // check object overridingMethod is really bound
                                             JavaSDM.ensure ( overridingMethod != null ) ;
                                              
                                             // create link
                                             overridingMethod.addToAntecedentAnnos (generalization6);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (overridingMethod) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object overridingMethod is really bound
            JavaSDM.ensure ( overridingMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (overridingMethod) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("overriding", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("overridden", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterUMLType7RevResultTypeOverridden = null ;
      Iterator fujaba__IterUMLType8RevResultTypeOverriding = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLClass subClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass superClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod overridden = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod overriding = null ;
      de.uni_paderborn.fujaba.uml.UMLType uMLType7 = null ;
      de.uni_paderborn.fujaba.uml.UMLType uMLType8 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            overriding = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind uMLType7: UMLType
            uMLType7 = overriding.getResultType () ;
            JavaSDM.ensure ( uMLType7 != null ) ;
             
            // bind overridden: UMLMethod
            fujaba__IterUMLType7RevResultTypeOverridden = uMLType7.iteratorOfRevResultType () ;
            while ( fujaba__IterUMLType7RevResultTypeOverridden.hasNext () )
            {
               try
               {
                  overridden = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterUMLType7RevResultTypeOverridden.next () ;
                   
                  // attribute condition
                  JavaSDM.ensure ( (overridden.getVisibility () != UMLMethod.PRIVATE) ) ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(overriding.equals (overridden)) ) ;
                   
                  // bind superClass: UMLClass
                  superClass = overridden.getParent () ;
                  JavaSDM.ensure ( superClass != null ) ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(uMLType7.equals (superClass)) ) ;
                   
                  {
                     //  for each flow
                     set.add (superClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            overridden = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind uMLType8: UMLType
            uMLType8 = overridden.getResultType () ;
            JavaSDM.ensure ( uMLType8 != null ) ;
             
            // bind overriding: UMLMethod
            fujaba__IterUMLType8RevResultTypeOverriding = uMLType8.iteratorOfRevResultType () ;
            while ( fujaba__IterUMLType8RevResultTypeOverriding.hasNext () )
            {
               try
               {
                  overriding = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterUMLType8RevResultTypeOverriding.next () ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(overridden.equals (overriding)) ) ;
                   
                  // bind subClass: UMLClass
                  subClass = overriding.getParent () ;
                  JavaSDM.ensure ( subClass != null ) ;
                   
                  // check isomorphic binding
                  JavaSDM.ensure ( !(uMLType8.equals (subClass)) ) ;
                   
                  {
                     //  for each flow
                     set.add (subClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
