package de.upb.inferenceengine.engines;

import de.upb.tools.fca.FEmptyIterator;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLParam;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;

public class SetMethodEngine
extends GFRNEngine
{
   private  SetMethodEngine()
   {
   }

   private static SetMethodEngine theSetMethodEngine;

   public static SetMethodEngine get()
   {
      if (theSetMethodEngine == null)
      {
         theSetMethodEngine = new SetMethodEngine ();
      }
      return theSetMethodEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterMethodAnnotationsSetMethod = null ;
      Iterator fujaba__IterMethodParamUMLParam1 = null ;
      Iterator fujaba__IterSettingRevParamTypeUMLParam2 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      SetMethodAnnotation setMethod = null ;
      de.uni_paderborn.fujaba.uml.UMLClass setting = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod method = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam1 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam2 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            method = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind uMLParam1: UMLParam
            fujaba__IterMethodParamUMLParam1 = method.iteratorOfParam () ;
            while ( fujaba__IterMethodParamUMLParam1.hasNext () )
            {
               try
               {
                  uMLParam1 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__IterMethodParamUMLParam1.next () ;
                   
                  // bind setting: UMLClass
                  fujaba__TmpObject = uMLParam1.getParamType () ;
                  JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  setting = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     try
                     {
                        fujaba__Success = false ;
                         
                        // check object method is really bound
                        JavaSDM.ensure ( method != null ) ;
                         
                        // check object setting is really bound
                        JavaSDM.ensure ( setting != null ) ;
                         
                        // bind setMethod: SetMethodAnnotation
                        fujaba__IterMethodAnnotationsSetMethod = method.iteratorOfAnnotations () ;
                        while ( !(fujaba__Success) && fujaba__IterMethodAnnotationsSetMethod.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMethodAnnotationsSetMethod.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof SetMethodAnnotation ) ;
                              setMethod = (SetMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between setMethod and method
                              JavaSDM.ensure ( setMethod.hasInElements ("method", method) ) ;
                               
                              // check To-Many-Link 'elements' between setMethod and setting
                              JavaSDM.ensure ( setMethod.hasInElements ("sets", setting) ) ;
                               
                              fujaba__Success = true ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                        fujaba__Success = false ;
                     }
                      
                     if ( !(fujaba__Success) )
                     {
                        try
                        {
                           fujaba__Success = false ;
                            
                           // check object method is really bound
                           JavaSDM.ensure ( method != null ) ;
                            
                           // check object setting is really bound
                           JavaSDM.ensure ( setting != null ) ;
                            
                           // create object
                           setMethod = new SetMethodAnnotation ( ) ;
                            
                           // create link
                           setMethod.addToElements ("method", method);
                            
                           // create link
                           setMethod.addToElements ("sets", setting);
                            
                           // create link
                           setMethod.addToBoundObjects ("method", method);
                            
                           // create link
                           setMethod.addToBoundObjects ("setting", setting);
                            
                           fujaba__Success = true ;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false ;
                        }
                         
                        try
                        {
                           fujaba__Success = false ;
                            
                           fujaba__Success = true ;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false ;
                        }
                         
                        return (setMethod) ;
                     }
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object setMethod is really bound
            JavaSDM.ensure ( setMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("method", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("sets", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            setting = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLParam2: UMLParam
            fujaba__IterSettingRevParamTypeUMLParam2 = setting.iteratorOfRevParamType () ;
            while ( fujaba__IterSettingRevParamTypeUMLParam2.hasNext () )
            {
               try
               {
                  uMLParam2 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__IterSettingRevParamTypeUMLParam2.next () ;
                   
                  // bind method: UMLMethod
                  method = uMLParam2.getRevParam () ;
                  JavaSDM.ensure ( method != null ) ;
                   
                  {
                     //  for each flow
                     try
                     {
                        fujaba__Success = false ;
                         
                        // check object method is really bound
                        JavaSDM.ensure ( method != null ) ;
                         
                        // check object setting is really bound
                        JavaSDM.ensure ( setting != null ) ;
                         
                        // bind setMethod: SetMethodAnnotation
                        fujaba__IterMethodAnnotationsSetMethod = method.iteratorOfAnnotations () ;
                        while ( !(fujaba__Success) && fujaba__IterMethodAnnotationsSetMethod.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterMethodAnnotationsSetMethod.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof SetMethodAnnotation ) ;
                              setMethod = (SetMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between setMethod and method
                              JavaSDM.ensure ( setMethod.hasInElements ("method", method) ) ;
                               
                              // check To-Many-Link 'elements' between setMethod and setting
                              JavaSDM.ensure ( setMethod.hasInElements ("sets", setting) ) ;
                               
                              fujaba__Success = true ;
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                        fujaba__Success = false ;
                     }
                      
                     if ( !(fujaba__Success) )
                     {
                        try
                        {
                           fujaba__Success = false ;
                            
                           // check object method is really bound
                           JavaSDM.ensure ( method != null ) ;
                            
                           // check object setting is really bound
                           JavaSDM.ensure ( setting != null ) ;
                            
                           // create object
                           setMethod = new SetMethodAnnotation ( ) ;
                            
                           // create link
                           setMethod.addToElements ("method", method);
                            
                           // create link
                           setMethod.addToElements ("sets", setting);
                            
                           // create link
                           setMethod.addToBoundObjects ("method", method);
                            
                           // create link
                           setMethod.addToBoundObjects ("setting", setting);
                            
                           fujaba__Success = true ;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false ;
                        }
                         
                        try
                        {
                           fujaba__Success = false ;
                            
                           fujaba__Success = true ;
                        }
                        catch ( JavaSDMException fujaba__InternalException )
                        {
                           fujaba__Success = false ;
                        }
                         
                        return (setMethod) ;
                     }
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object setMethod is really bound
            JavaSDM.ensure ( setMethod != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("sets", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (setMethod) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("sets", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      return (FEmptyIterator.get()) ;
   }


}
