package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLStereotype;

public class StrategyInterfaceEngine
extends GFRNEngine
{
   private  StrategyInterfaceEngine()
   {
   }

   private static StrategyInterfaceEngine theStrategyInterfaceEngine;

   public static StrategyInterfaceEngine get()
   {
      if (theStrategyInterfaceEngine == null)
      {
         theStrategyInterfaceEngine = new StrategyInterfaceEngine ();
      }
      return theStrategyInterfaceEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      de.upb.tools.fca.FHashSet set = null ;
      boolean fujaba__Success = false ;
      Iterator fujaba__IterCalleeAnnotationsNeighborCall2 = null ;
      Iterator fujaba__IterCallerAnnotationsNeighborCall8 = null ;
      Iterator fujaba__IterContextClassAnnotationsStrategyInterface = null ;
      Iterator fujaba__IterContextClassAttrsRefField = null ;
      Iterator fujaba__IterContextClassMethodsCaller = null ;
      Iterator fujaba__IterNeighborCall2ElementsCaller = null ;
      Iterator fujaba__IterNeighborCall5ElementsCallee = null ;
      Iterator fujaba__IterNeighborCall5ElementsCaller = null ;
      Iterator fujaba__IterNeighborCall8ElementsCallee = null ;
      Iterator fujaba__IterRefFieldAnnotationsReference9 = null ;
      Iterator fujaba__IterReference3ElementsRefField = null ;
      Iterator fujaba__IterSet = null ;
      Iterator fujaba__IterStrategyClassAnnotationsReference3 = null ;
      Iterator fujaba__IterStrategyClassAnnotationsReference6 = null ;
      Iterator fujaba__IterStrategyClassMethodsCallee = null ;
      Iterator fujaba__IterStrategyClassStereotypesUMLStereotype1 = null ;
      Iterator fujaba__IterStrategyClassStereotypesUMLStereotype4 = null ;
      Iterator fujaba__IterStrategyClassStereotypesUMLStereotype7 = null ;
      GeneralizationAnnotation fujaba__TmpObjectGeneralizationAnnotation = null ;
      NeighborCallAnnotation neighborCall2 = null ;
      NeighborCallAnnotation neighborCall5 = null ;
      NeighborCallAnnotation neighborCall8 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      ReferenceAnnotation reference3 = null ;
      ReferenceAnnotation reference6 = null ;
      ReferenceAnnotation reference9 = null ;
      StrategyInterfaceAnnotation strategyInterface = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr refField = null ;
      de.uni_paderborn.fujaba.uml.UMLClass contextClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass strategyClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
      de.uni_paderborn.fujaba.uml.UMLStereotype uMLStereotype1 = null ;
      de.uni_paderborn.fujaba.uml.UMLStereotype uMLStereotype4 = null ;
      de.uni_paderborn.fujaba.uml.UMLStereotype uMLStereotype7 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("strategy", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            strategyClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterStrategyClassMethodsCallee = strategyClass.iteratorOfMethods () ;
            while ( fujaba__IterStrategyClassMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterStrategyClassMethodsCallee.next () ;
                   
                  // bind uMLStereotype1: UMLStereotype
                  fujaba__IterStrategyClassStereotypesUMLStereotype1 = strategyClass.iteratorOfStereotypes () ;
                  while ( fujaba__IterStrategyClassStereotypesUMLStereotype1.hasNext () )
                  {
                     try
                     {
                        uMLStereotype1 = (de.uni_paderborn.fujaba.uml.UMLStereotype) fujaba__IterStrategyClassStereotypesUMLStereotype1.next () ;
                         
                        // attribute condition
                        JavaSDM.ensure ( (JavaSDM.stringCompare (uMLStereotype1.getText (), "interface") == 0) ) ;
                         
                        // bind reference3: ReferenceAnnotation
                        fujaba__IterStrategyClassAnnotationsReference3 = strategyClass.iteratorOfAnnotations () ;
                        while ( fujaba__IterStrategyClassAnnotationsReference3.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterStrategyClassAnnotationsReference3.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                              reference3 = (ReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between reference3 and strategyClass
                              JavaSDM.ensure ( reference3.hasInElements ("references", strategyClass) ) ;
                               
                              // bind neighborCall2: NeighborCallAnnotation
                              fujaba__IterCalleeAnnotationsNeighborCall2 = callee.iteratorOfAnnotations () ;
                              while ( fujaba__IterCalleeAnnotationsNeighborCall2.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCalleeAnnotationsNeighborCall2.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                    neighborCall2 = (NeighborCallAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between neighborCall2 and callee
                                    JavaSDM.ensure ( neighborCall2.hasInElements ("callee", callee) ) ;
                                     
                                    // bind refField: UMLAttr
                                    fujaba__IterReference3ElementsRefField = reference3.iteratorOfElements ("field") ;
                                    while ( fujaba__IterReference3ElementsRefField.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterReference3ElementsRefField.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                                          refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                                           
                                          // bind contextClass: UMLClass
                                          contextClass = refField.getParent () ;
                                          JavaSDM.ensure ( contextClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(strategyClass.equals (contextClass)) ) ;
                                           
                                          // bind caller: UMLMethod
                                          fujaba__IterNeighborCall2ElementsCaller = neighborCall2.iteratorOfElements ("caller") ;
                                          while ( fujaba__IterNeighborCall2ElementsCaller.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterNeighborCall2ElementsCaller.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                                caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                 
                                                // check To-One-Link 'parent' between caller and contextClass
                                                JavaSDM.ensure ( (caller.getParent () != null) && caller.getParent ().equals (contextClass) ) ;
                                                 
                                                // linkSearchToSetTop
                                                set = new de.upb.tools.fca.FHashSet ( ) ;
                                                fujaba__IterSet = strategyClass.iteratorOfAnnotations () ;
                                                while ( fujaba__IterSet.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterSet.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                      fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                       
                                                      //  check link :) 'elements' between set and contextClass
                                                      JavaSDM.ensure ( fujaba__TmpObjectGeneralizationAnnotation.hasInElements (contextClass) ) ;
                                                       
                                                      set.add (fujaba__TmpObjectGeneralizationAnnotation);
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                } // while
                                                // constraint
                                                JavaSDM.ensure ( set.size() == 0 ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object strategyClass is really bound
                                                      JavaSDM.ensure ( strategyClass != null ) ;
                                                       
                                                      // check object contextClass is really bound
                                                      JavaSDM.ensure ( contextClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(strategyClass.equals (contextClass)) ) ;
                                                       
                                                      // bind strategyInterface: StrategyInterfaceAnnotation
                                                      fujaba__IterContextClassAnnotationsStrategyInterface = contextClass.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterContextClassAnnotationsStrategyInterface.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterContextClassAnnotationsStrategyInterface.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof StrategyInterfaceAnnotation ) ;
                                                            strategyInterface = (StrategyInterfaceAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between strategyInterface and contextClass
                                                            JavaSDM.ensure ( strategyInterface.hasInElements ("context", contextClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between strategyInterface and strategyClass
                                                            JavaSDM.ensure ( strategyInterface.hasInElements ("strategy", strategyClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object strategyClass is really bound
                                                         JavaSDM.ensure ( strategyClass != null ) ;
                                                          
                                                         // check object contextClass is really bound
                                                         JavaSDM.ensure ( contextClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(strategyClass.equals (contextClass)) ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check object caller is really bound
                                                         JavaSDM.ensure ( caller != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                          
                                                         // check object refField is really bound
                                                         JavaSDM.ensure ( refField != null ) ;
                                                          
                                                         // create object
                                                         strategyInterface = new StrategyInterfaceAnnotation ( ) ;
                                                          
                                                         // create link
                                                         strategyInterface.addToElements ("strategy", strategyClass);
                                                          
                                                         // create link
                                                         strategyInterface.addToElements ("context", contextClass);
                                                          
                                                         // create link
                                                         strategyInterface.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         strategyInterface.addToBoundObjects ("strategyClass", strategyClass);
                                                          
                                                         // create link
                                                         strategyInterface.addToBoundObjects ("caller", caller);
                                                          
                                                         // create link
                                                         strategyInterface.addToBoundObjects ("contextClass", contextClass);
                                                          
                                                         // create link
                                                         strategyInterface.addToBoundObjects ("refField", refField);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object neighborCall2 is really bound
                                                         JavaSDM.ensure ( neighborCall2 != null ) ;
                                                          
                                                         // check object reference3 is really bound
                                                         JavaSDM.ensure ( reference3 != null ) ;
                                                          
                                                         // check object strategyInterface is really bound
                                                         JavaSDM.ensure ( strategyInterface != null ) ;
                                                          
                                                         // create link
                                                         strategyInterface.addToAntecedentAnnos (neighborCall2);
                                                          
                                                         // create link
                                                         strategyInterface.addToAntecedentAnnos (reference3);
                                                          
                                                         fujaba__IterSet = set.iterator () ;
                                                         while ( fujaba__IterSet.hasNext () )
                                                         {
                                                            fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__IterSet.next () ;
                                                            //  create set link
                                                            strategyInterface.addToAntecedentAnnos (fujaba__TmpObjectGeneralizationAnnotation);
                                                            fujaba__Success = true ;
                                                         } // while
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (strategyInterface) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object strategyInterface is really bound
            JavaSDM.ensure ( strategyInterface != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("strategy", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall5 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterNeighborCall5ElementsCallee = neighborCall5.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall5ElementsCallee.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall5ElementsCallee.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind strategyClass: UMLClass
                  strategyClass = callee.getParent () ;
                  JavaSDM.ensure ( strategyClass != null ) ;
                   
                  // bind caller: UMLMethod
                  fujaba__IterNeighborCall5ElementsCaller = neighborCall5.iteratorOfElements ("caller") ;
                  while ( fujaba__IterNeighborCall5ElementsCaller.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterNeighborCall5ElementsCaller.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                        caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                         
                        // bind contextClass: UMLClass
                        contextClass = caller.getParent () ;
                        JavaSDM.ensure ( contextClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(strategyClass.equals (contextClass)) ) ;
                         
                        // bind uMLStereotype4: UMLStereotype
                        fujaba__IterStrategyClassStereotypesUMLStereotype4 = strategyClass.iteratorOfStereotypes () ;
                        while ( fujaba__IterStrategyClassStereotypesUMLStereotype4.hasNext () )
                        {
                           try
                           {
                              uMLStereotype4 = (de.uni_paderborn.fujaba.uml.UMLStereotype) fujaba__IterStrategyClassStereotypesUMLStereotype4.next () ;
                               
                              // attribute condition
                              JavaSDM.ensure ( (JavaSDM.stringCompare (uMLStereotype4.getText (), "interface") == 0) ) ;
                               
                              // bind reference6: ReferenceAnnotation
                              fujaba__IterStrategyClassAnnotationsReference6 = strategyClass.iteratorOfAnnotations () ;
                              while ( fujaba__IterStrategyClassAnnotationsReference6.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterStrategyClassAnnotationsReference6.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                    reference6 = (ReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between reference6 and strategyClass
                                    JavaSDM.ensure ( reference6.hasInElements ("references", strategyClass) ) ;
                                     
                                    // bind refField: UMLAttr
                                    fujaba__IterContextClassAttrsRefField = contextClass.iteratorOfAttrs () ;
                                    while ( fujaba__IterContextClassAttrsRefField.hasNext () )
                                    {
                                       try
                                       {
                                          refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterContextClassAttrsRefField.next () ;
                                           
                                          // check To-Many-Link 'elements' between reference6 and refField
                                          JavaSDM.ensure ( reference6.hasInElements ("field", refField) ) ;
                                           
                                          // linkSearchToSetTop
                                          set = new de.upb.tools.fca.FHashSet ( ) ;
                                          fujaba__IterSet = strategyClass.iteratorOfAnnotations () ;
                                          while ( fujaba__IterSet.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterSet.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                 
                                                //  check link :) 'elements' between set and contextClass
                                                JavaSDM.ensure ( fujaba__TmpObjectGeneralizationAnnotation.hasInElements (contextClass) ) ;
                                                 
                                                set.add (fujaba__TmpObjectGeneralizationAnnotation);
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          } // while
                                          // constraint
                                          JavaSDM.ensure ( set.size() == 0 ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object strategyClass is really bound
                                                JavaSDM.ensure ( strategyClass != null ) ;
                                                 
                                                // check object contextClass is really bound
                                                JavaSDM.ensure ( contextClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(strategyClass.equals (contextClass)) ) ;
                                                 
                                                // bind strategyInterface: StrategyInterfaceAnnotation
                                                fujaba__IterContextClassAnnotationsStrategyInterface = contextClass.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterContextClassAnnotationsStrategyInterface.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterContextClassAnnotationsStrategyInterface.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof StrategyInterfaceAnnotation ) ;
                                                      strategyInterface = (StrategyInterfaceAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between strategyInterface and contextClass
                                                      JavaSDM.ensure ( strategyInterface.hasInElements ("context", contextClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between strategyInterface and strategyClass
                                                      JavaSDM.ensure ( strategyInterface.hasInElements ("strategy", strategyClass) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object strategyClass is really bound
                                                   JavaSDM.ensure ( strategyClass != null ) ;
                                                    
                                                   // check object contextClass is really bound
                                                   JavaSDM.ensure ( contextClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(strategyClass.equals (contextClass)) ) ;
                                                    
                                                   // check object callee is really bound
                                                   JavaSDM.ensure ( callee != null ) ;
                                                    
                                                   // check object caller is really bound
                                                   JavaSDM.ensure ( caller != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                    
                                                   // check object refField is really bound
                                                   JavaSDM.ensure ( refField != null ) ;
                                                    
                                                   // create object
                                                   strategyInterface = new StrategyInterfaceAnnotation ( ) ;
                                                    
                                                   // create link
                                                   strategyInterface.addToElements ("strategy", strategyClass);
                                                    
                                                   // create link
                                                   strategyInterface.addToElements ("context", contextClass);
                                                    
                                                   // create link
                                                   strategyInterface.addToBoundObjects ("callee", callee);
                                                    
                                                   // create link
                                                   strategyInterface.addToBoundObjects ("strategyClass", strategyClass);
                                                    
                                                   // create link
                                                   strategyInterface.addToBoundObjects ("caller", caller);
                                                    
                                                   // create link
                                                   strategyInterface.addToBoundObjects ("contextClass", contextClass);
                                                    
                                                   // create link
                                                   strategyInterface.addToBoundObjects ("refField", refField);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object neighborCall5 is really bound
                                                   JavaSDM.ensure ( neighborCall5 != null ) ;
                                                    
                                                   // check object reference6 is really bound
                                                   JavaSDM.ensure ( reference6 != null ) ;
                                                    
                                                   // check object strategyInterface is really bound
                                                   JavaSDM.ensure ( strategyInterface != null ) ;
                                                    
                                                   // create link
                                                   strategyInterface.addToAntecedentAnnos (neighborCall5);
                                                    
                                                   // create link
                                                   strategyInterface.addToAntecedentAnnos (reference6);
                                                    
                                                   fujaba__IterSet = set.iterator () ;
                                                   while ( fujaba__IterSet.hasNext () )
                                                   {
                                                      fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__IterSet.next () ;
                                                      //  create set link
                                                      strategyInterface.addToAntecedentAnnos (fujaba__TmpObjectGeneralizationAnnotation);
                                                      fujaba__Success = true ;
                                                   } // while
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (strategyInterface) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object strategyInterface is really bound
            JavaSDM.ensure ( strategyInterface != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("context", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            contextClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterContextClassMethodsCaller = contextClass.iteratorOfMethods () ;
            while ( fujaba__IterContextClassMethodsCaller.hasNext () )
            {
               try
               {
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterContextClassMethodsCaller.next () ;
                   
                  // bind refField: UMLAttr
                  fujaba__IterContextClassAttrsRefField = contextClass.iteratorOfAttrs () ;
                  while ( fujaba__IterContextClassAttrsRefField.hasNext () )
                  {
                     try
                     {
                        refField = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterContextClassAttrsRefField.next () ;
                         
                        // bind neighborCall8: NeighborCallAnnotation
                        fujaba__IterCallerAnnotationsNeighborCall8 = caller.iteratorOfAnnotations () ;
                        while ( fujaba__IterCallerAnnotationsNeighborCall8.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterCallerAnnotationsNeighborCall8.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                              neighborCall8 = (NeighborCallAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between neighborCall8 and caller
                              JavaSDM.ensure ( neighborCall8.hasInElements ("caller", caller) ) ;
                               
                              // bind reference9: ReferenceAnnotation
                              fujaba__IterRefFieldAnnotationsReference9 = refField.iteratorOfAnnotations () ;
                              while ( fujaba__IterRefFieldAnnotationsReference9.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterRefFieldAnnotationsReference9.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                                    reference9 = (ReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between reference9 and refField
                                    JavaSDM.ensure ( reference9.hasInElements ("field", refField) ) ;
                                     
                                    // bind callee: UMLMethod
                                    fujaba__IterNeighborCall8ElementsCallee = neighborCall8.iteratorOfElements ("callee") ;
                                    while ( fujaba__IterNeighborCall8ElementsCallee.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterNeighborCall8ElementsCallee.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                          callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                           
                                          // bind strategyClass: UMLClass
                                          strategyClass = callee.getParent () ;
                                          JavaSDM.ensure ( strategyClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(contextClass.equals (strategyClass)) ) ;
                                           
                                          // check To-Many-Link 'elements' between reference9 and strategyClass
                                          JavaSDM.ensure ( reference9.hasInElements ("references", strategyClass) ) ;
                                           
                                          // bind uMLStereotype7: UMLStereotype
                                          fujaba__IterStrategyClassStereotypesUMLStereotype7 = strategyClass.iteratorOfStereotypes () ;
                                          while ( fujaba__IterStrategyClassStereotypesUMLStereotype7.hasNext () )
                                          {
                                             try
                                             {
                                                uMLStereotype7 = (de.uni_paderborn.fujaba.uml.UMLStereotype) fujaba__IterStrategyClassStereotypesUMLStereotype7.next () ;
                                                 
                                                // attribute condition
                                                JavaSDM.ensure ( (JavaSDM.stringCompare (uMLStereotype7.getText (), "interface") == 0) ) ;
                                                 
                                                // linkSearchToSetTop
                                                set = new de.upb.tools.fca.FHashSet ( ) ;
                                                fujaba__IterSet = contextClass.iteratorOfAnnotations () ;
                                                while ( fujaba__IterSet.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterSet.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof GeneralizationAnnotation ) ;
                                                      fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__TmpObject ;
                                                       
                                                      //  check link :) 'elements' between set and strategyClass
                                                      JavaSDM.ensure ( fujaba__TmpObjectGeneralizationAnnotation.hasInElements (strategyClass) ) ;
                                                       
                                                      set.add (fujaba__TmpObjectGeneralizationAnnotation);
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                } // while
                                                // constraint
                                                JavaSDM.ensure ( set.size() == 0 ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object strategyClass is really bound
                                                      JavaSDM.ensure ( strategyClass != null ) ;
                                                       
                                                      // check object contextClass is really bound
                                                      JavaSDM.ensure ( contextClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(strategyClass.equals (contextClass)) ) ;
                                                       
                                                      // bind strategyInterface: StrategyInterfaceAnnotation
                                                      fujaba__IterContextClassAnnotationsStrategyInterface = contextClass.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterContextClassAnnotationsStrategyInterface.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterContextClassAnnotationsStrategyInterface.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof StrategyInterfaceAnnotation ) ;
                                                            strategyInterface = (StrategyInterfaceAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between strategyInterface and contextClass
                                                            JavaSDM.ensure ( strategyInterface.hasInElements ("context", contextClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between strategyInterface and strategyClass
                                                            JavaSDM.ensure ( strategyInterface.hasInElements ("strategy", strategyClass) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object strategyClass is really bound
                                                         JavaSDM.ensure ( strategyClass != null ) ;
                                                          
                                                         // check object contextClass is really bound
                                                         JavaSDM.ensure ( contextClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(strategyClass.equals (contextClass)) ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check object caller is really bound
                                                         JavaSDM.ensure ( caller != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                                          
                                                         // check object refField is really bound
                                                         JavaSDM.ensure ( refField != null ) ;
                                                          
                                                         // create object
                                                         strategyInterface = new StrategyInterfaceAnnotation ( ) ;
                                                          
                                                         // create link
                                                         strategyInterface.addToElements ("strategy", strategyClass);
                                                          
                                                         // create link
                                                         strategyInterface.addToElements ("context", contextClass);
                                                          
                                                         // create link
                                                         strategyInterface.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         strategyInterface.addToBoundObjects ("strategyClass", strategyClass);
                                                          
                                                         // create link
                                                         strategyInterface.addToBoundObjects ("caller", caller);
                                                          
                                                         // create link
                                                         strategyInterface.addToBoundObjects ("contextClass", contextClass);
                                                          
                                                         // create link
                                                         strategyInterface.addToBoundObjects ("refField", refField);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object neighborCall8 is really bound
                                                         JavaSDM.ensure ( neighborCall8 != null ) ;
                                                          
                                                         // check object reference9 is really bound
                                                         JavaSDM.ensure ( reference9 != null ) ;
                                                          
                                                         // check object strategyInterface is really bound
                                                         JavaSDM.ensure ( strategyInterface != null ) ;
                                                          
                                                         // create link
                                                         strategyInterface.addToAntecedentAnnos (neighborCall8);
                                                          
                                                         // create link
                                                         strategyInterface.addToAntecedentAnnos (reference9);
                                                          
                                                         fujaba__IterSet = set.iterator () ;
                                                         while ( fujaba__IterSet.hasNext () )
                                                         {
                                                            fujaba__TmpObjectGeneralizationAnnotation = (GeneralizationAnnotation) fujaba__IterSet.next () ;
                                                            //  create set link
                                                            strategyInterface.addToAntecedentAnnos (fujaba__TmpObjectGeneralizationAnnotation);
                                                            fujaba__Success = true ;
                                                         } // while
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (strategyInterface) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object strategyInterface is really bound
            JavaSDM.ensure ( strategyInterface != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("context", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (strategyInterface) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("strategy", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("context", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof NeighborCallAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof GeneralizationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterCallerAnnotationsNeighborCall10 = null ;
      Iterator fujaba__IterContextClassMethodsCaller = null ;
      Iterator fujaba__IterNeighborCall10ElementsCallee = null ;
      Iterator fujaba__IterNeighborCall8ElementsCallee = null ;
      Iterator fujaba__IterStrategyClassMethodsCallee = null ;
      NeighborCallAnnotation neighborCall10 = null ;
      NeighborCallAnnotation neighborCall8 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLClass contextClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass strategyClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("NeighborCall") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            strategyClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterStrategyClassMethodsCallee = strategyClass.iteratorOfMethods () ;
            while ( fujaba__IterStrategyClassMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterStrategyClassMethodsCallee.next () ;
                   
                  {
                     //  for each flow
                     set.add (callee);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            contextClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterContextClassMethodsCaller = contextClass.iteratorOfMethods () ;
            while ( fujaba__IterContextClassMethodsCaller.hasNext () )
            {
               try
               {
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterContextClassMethodsCaller.next () ;
                   
                  {
                     //  for each flow
                     set.add (caller);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Generalization") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            strategyClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (strategyClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            contextClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (contextClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall8 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterNeighborCall8ElementsCallee = neighborCall8.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall8ElementsCallee.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall8ElementsCallee.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind strategyClass: UMLClass
                  strategyClass = callee.getParent () ;
                  JavaSDM.ensure ( strategyClass != null ) ;
                   
                  {
                     //  for each flow
                     set.add (strategyClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("Reference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            strategyClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (strategyClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            contextClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind caller: UMLMethod
            fujaba__IterContextClassMethodsCaller = contextClass.iteratorOfMethods () ;
            while ( fujaba__IterContextClassMethodsCaller.hasNext () )
            {
               try
               {
                  caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterContextClassMethodsCaller.next () ;
                   
                  // bind neighborCall10: NeighborCallAnnotation
                  fujaba__IterCallerAnnotationsNeighborCall10 = caller.iteratorOfAnnotations () ;
                  while ( fujaba__IterCallerAnnotationsNeighborCall10.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterCallerAnnotationsNeighborCall10.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                        neighborCall10 = (NeighborCallAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between neighborCall10 and caller
                        JavaSDM.ensure ( neighborCall10.hasInElements ("caller", caller) ) ;
                         
                        // bind callee: UMLMethod
                        fujaba__IterNeighborCall10ElementsCallee = neighborCall10.iteratorOfElements ("callee") ;
                        while ( fujaba__IterNeighborCall10ElementsCallee.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterNeighborCall10ElementsCallee.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                              callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                               
                              // bind strategyClass: UMLClass
                              strategyClass = callee.getParent () ;
                              JavaSDM.ensure ( strategyClass != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(contextClass.equals (strategyClass)) ) ;
                               
                              {
                                 //  for each flow
                                 set.add (strategyClass);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof NeighborCallAnnotation ) ;
             
            // explicit type cast
            neighborCall10 = (NeighborCallAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterNeighborCall10ElementsCallee = neighborCall10.iteratorOfElements ("callee") ;
            while ( fujaba__IterNeighborCall10ElementsCallee.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterNeighborCall10ElementsCallee.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                   
                  // bind strategyClass: UMLClass
                  strategyClass = callee.getParent () ;
                  JavaSDM.ensure ( strategyClass != null ) ;
                   
                  {
                     //  for each flow
                     set.add (strategyClass);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
